Type: Package
Package: soilassessment
Title: Soil Health Assessment Models for Assessing Soil Conditions and
        Suitability
Version: 1.3.1
Description: Soil health assessment builds information to improve decision in
    soil management. It facilitates assessment of soil conditions for crop suitability [such as those given by FAO
    <https://www.fao.org/land-water/databases-and-software/crop-information/en/>], 
    groundwater recharge, fertility, erosion, salinization [<doi:10.1002/ldr.4211>], 
    carbon sequestration, irrigation potential, and status of soil resources. 
License: GPL
Depends: R (>= 3.5.0)
Imports: caret, deSolve, e1071, FuzzyAHP, googledrive, Hmisc, methods,
        nnet, png, randomForest, raster, soiltexture, sp, sf, terra,
        stats, curl, httr, withr
Suggests: arm, Cubist, aqp, kernlab, nlme, ranger, rpart, plyr, qrnn,
        quantregForest
Encoding: UTF-8
LazyData: true
Authors@R: 
    person("Christian Thine", "Omuto", , "thineomuto@yahoo.com", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-5792-3485"))
Config/roxygen2/version: 8.0.0
NeedsCompilation: no
Packaged: 2026-06-09 22:11:15 UTC; Cthine
Author: Christian Thine Omuto [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-5792-3485>)
Maintainer: Christian Thine Omuto <thineomuto@yahoo.com>
Repository: CRAN
Date/Publication: 2026-06-09 22:40:02 UTC
Built: R 4.5.2; ; 2026-06-10 01:43:50 UTC; unix

exportPattern("^[[:alpha:]]+")
import(sp)
import(raster)
import(sf)
importFrom(utils,"txtProgressBar","setTxtProgressBar","read.csv","unzip")
importFrom(soiltexture,"TT.points.in.classes","TT.normalise.sum")
importFrom(FuzzyAHP, "pairwiseComparisonMatrix", "consistencyRatio", "calculateWeights", "calculateAHP")
importFrom(Hmisc,"histbackback")
importFrom(stats,"ks.test", "as.formula", "fitted", "lm", "cor", "sd", "splinefun")
import(caret)
importFrom(randomForest,"randomForest")
importFrom(methods, "as","is")
importFrom(e1071, "svm")
importFrom(nnet,"nnet")
importFrom(deSolve,"ode")
importFrom(terra,"crs","ifel","rast")
importFrom(graphics, "box", "grid", "legend", "mtext", "par")
importFrom(googledrive,"drive_deauth","drive_download","as_id")
importFrom(png,"readPNG")
importFrom(grid,"grid.raster")
importFrom(curl,"has_internet")
importFrom(httr,"http_error","GET","message_for_status","timeout")
importFrom(withr,"with_options")

erosivFUN = function(rain,A,B, model="linear") {
  total <- 20
  MFI=rain
  if(model=="linear"){erosivity=rain*B+A}
  else if(model=="Fourier"){erosivity=A*MFI^B}
  else if(model=="power"){erosivity=A*rain^B}
  else if(model=="logarithmic"){erosivity=B*log(rain)+A}
  else if(model=="exponential"){erosivity=A*exp(B*rain)}

  for(i in 1:20){
    Sys.sleep(0.1)
    setTxtProgressBar((txtProgressBar(min = 0, max = total, style = 3)), i)
  }
  return(erosivity)
}

pedoTransfer=function(method="linear", df, ...){
  dv=as.character(sapply(substitute(list(...))[-1], deparse))
  fml <- as.formula(paste(dv[1],paste((dv[2:length(dv)]),collapse="+"),sep="~"))
  names(fml)<-sub(".*\\$", "",names(fml))
  df=data.frame(df)
  (na.cols=function(x){
    y <- sapply(x, function(xx)any(is.na(xx)))
    names(y[y])
  })
  if(any(is.na(df))){stop(paste("Remove NA in columns: ", paste(na.cols(df), collapse=", ")))}

  if(method=="linear"){
    hk.lm=lm(fml,data=df)
    W=(dv[1])
    df$B=df[,grepl(W, colnames(df))]
    df$dv1=fitted(hk.lm)
    hk=hk.lm
  }

  if(method=="randomforest"){
    hk.rf=randomForest(fml,data=df, importance = TRUE)
    W=(dv[1])
    df$B=df[,grepl(W, colnames(df))]
    df$dv1=hk.rf$predicted
    RF_R2=cor(df$dv1,df$B)^2
    hk=hk.rf
  }
  if(method=="svm"){
    hk.sv=svm(fml,data=df)
    W=(dv[1])
    df$B=df[,grepl(W, colnames(df))]
    df$dv1=fitted(hk.sv)
    SV_R2=cor(df$dv1,df$B)^2
    hk=hk.sv
  }
  if(method=="neuralnetwork"){
    hk.nn= nnet(fml,data=df,size=10, linout=TRUE, skip=TRUE, MaxNWts=10000, trace=FALSE, maxit=100)
    W=(dv[1])
    df$B=df[,grepl(W, colnames(df))]
    df$dv1=fitted(hk.nn)
    NN_R2=cor(df$dv1,df$B)^2
    hk=hk.nn
  }
  return(hk)

}

SASglobeData=function(dframe="ecse",ISO="ISO", Region=NULL){
  drive_deauth()
  temp <- tempfile(fileext = ".zip")
  if(is.null(Region)){
  if(missing(ISO)){stop("ISO code is missing")}

  {  if(dframe=="ecse"){
    patch <- drive_download(
      as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
    out <- unzip(temp, exdir = tempdir())
    dframe <- read.csv(out, sep = ",")
    dframe=dframe[,c(1:5,15,16)]
    dframe=dframe[dframe$ECse==1,]
    }
  else if(dframe=="ec2"){
    patch <- drive_download(
      as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
    out <- unzip(temp, exdir = tempdir())
    dframe <- read.csv(out, sep = ",")
    dframe=dframe[,c(1:4,6,15,16)]
    dframe=dframe[dframe$EC2==1,]
    }
  else if(dframe=="ec2.5"){
    patch <- drive_download(
      as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
    out <- unzip(temp, exdir = tempdir())
    dframe <- read.csv(out, sep = ",")
    dframe=dframe[,c(1:4,7,15,16)]
    dframe=dframe[dframe$EC2.5==1,]
  }
  else if(dframe=="ec5"){
    patch <- drive_download(
      as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
    out <- unzip(temp, exdir = tempdir())
    dframe <- read.csv(out, sep = ",")
    dframe=dframe[,c(1:4,8,15,16)]
    dframe=dframe[dframe$EC5==1,]
  }
  else if(dframe=="ph"){
    patch <- drive_download(
      as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
    out <- unzip(temp, exdir = tempdir())
    dframe <- read.csv(out, sep = ",")
    dframe=dframe[,c(1:4,9,15,16)]
    dframe=dframe[dframe$ph==1,]
  }
  else if(dframe=="phkcl"){
    patch <- drive_download(
      as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
    out <- unzip(temp, exdir = tempdir())
    dframe <- read.csv(out, sep = ",")
    dframe=dframe[,c(1:4,10,15,16)]
    dframe=dframe[dframe$phkcl==1,]
  }
  else if(dframe=="phcacl2"){
    patch <- drive_download(
      as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
    out <- unzip(temp, exdir = tempdir())
    dframe <- read.csv(out, sep = ",")
    dframe=dframe[,c(1:4,11,15,16)]
    dframe=dframe[dframe$phcacl2==1,]
  }
  else if(dframe=="sand"){
    patch <- drive_download(
      as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
    out <- unzip(temp, exdir = tempdir())
    dframe <- read.csv(out, sep = ",")
    dframe=dframe[,c(1:4,12,15,16)]
    dframe=dframe[dframe$Sand==1,]
  }
  else if(dframe=="silt"){
    patch <- drive_download(
      as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
    out <- unzip(temp, exdir = tempdir())
    dframe <- read.csv(out, sep = ",")
    dframe=dframe[,c(1:4,13,15,16)]
    dframe=dframe[dframe$Silt==1,]
  }
    else if(dframe=="clay"){
    patch <- drive_download(
      as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
    out <- unzip(temp, exdir = tempdir())
    dframe <- read.csv(out, sep = ",")
    dframe=dframe[,c(1:4,14,15,16)]
    dframe=dframe[dframe$Clay==1,]
  }} ##Region NUll and ISO not missing

  Ddata=dframe[dframe$ISO==ISO,]
  if(ISO=="All"){Ddata=dframe}

  }
else {
  if(missing(ISO)){stop("ISO code is missing")}
  {  if(dframe=="ecse"){
    patch <- drive_download(
      as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
    out <- unzip(temp, exdir = tempdir())
    dframe <- read.csv(out, sep = ",")
    dframe=dframe[,c(1:5,15,16)]
    dframe=dframe[dframe$ECse==1,]
  }
    else if(dframe=="ec2"){
      patch <- drive_download(
        as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
      out <- unzip(temp, exdir = tempdir())
      dframe <- read.csv(out, sep = ",")
      dframe=dframe[,c(1:4,6,15,16)]
      dframe=dframe[dframe$EC2==1,]
    }
    else if(dframe=="ec2.5"){
      patch <- drive_download(
        as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
      out <- unzip(temp, exdir = tempdir())
      dframe <- read.csv(out, sep = ",")
      dframe=dframe[,c(1:4,7,15,16)]
      dframe=dframe[dframe$EC2.5==1,]
    }
    else if(dframe=="ec5"){
      patch <- drive_download(
        as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
      out <- unzip(temp, exdir = tempdir())
      dframe <- read.csv(out, sep = ",")
      dframe=dframe[,c(1:4,8,15,16)]
      dframe=dframe[dframe$EC5==1,]
    }
    else if(dframe=="ph"){
      patch <- drive_download(
        as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
      out <- unzip(temp, exdir = tempdir())
      dframe <- read.csv(out, sep = ",")
      dframe=dframe[,c(1:4,9,15,16)]
      dframe=dframe[dframe$ph==1,]
    }
    else if(dframe=="phkcl"){
      patch <- drive_download(
        as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
      out <- unzip(temp, exdir = tempdir())
      dframe <- read.csv(out, sep = ",")
      dframe=dframe[,c(1:4,10,15,16)]
      dframe=dframe[dframe$phkcl==1,]
    }
    else if(dframe=="phcacl2"){
      patch <- drive_download(
        as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
      out <- unzip(temp, exdir = tempdir())
      dframe <- read.csv(out, sep = ",")
      dframe=dframe[,c(1:4,11,15,16)]
      dframe=dframe[dframe$phcacl2==1,]
    }
    else if(dframe=="sand"){
      patch <- drive_download(
        as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
      out <- unzip(temp, exdir = tempdir())
      dframe <- read.csv(out, sep = ",")
      dframe=dframe[,c(1:4,12,15,16)]
      dframe=dframe[dframe$Sand==1,]
    }
    else if(dframe=="silt"){
      patch <- drive_download(
        as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
      out <- unzip(temp, exdir = tempdir())
      dframe <- read.csv(out, sep = ",")
      dframe=dframe[,c(1:4,13,15,16)]
      dframe=dframe[dframe$Silt==1,]
    }
    else if(dframe=="clay"){
      patch <- drive_download(
        as_id("1o3jNM5dSy1svfiqKWTvD7qLFHCqDSM23"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
      out <- unzip(temp, exdir = tempdir())
      dframe <- read.csv(out, sep = ",")
      dframe=dframe[,c(1:4,14,15,16)]
      dframe=dframe[dframe$Clay==1,]
    }}
      Ddata=dframe[dframe$Regions==Region,]
      Ddata=Ddata[Ddata$ISO==ISO,]
  if (ISO=="All"){Ddata=dframe[dframe$Regions==Region,]}

  }
  return(Ddata)
}

tempSuit=function(value,crop="wheat"){
  #Temperature suitability requirements for cereals
  if(crop=="wheat"){suitclass=ifelse(value>34,4,ifelse(value>29,3,ifelse(value>26,2,ifelse(value>20,1,ifelse(value>18,2,ifelse(value>14,3,4))))))}
  else if(crop=="rice"){suitclass=ifelse(value>40,4,ifelse(value>38,3,ifelse(value>34,2,ifelse(value>30,1,ifelse(value>21,2,ifelse(value>15,3,4))))))}
  else if(crop=="maize"){suitclass=ifelse(value>40,4,ifelse(value>38,3,ifelse(value>33,2,ifelse(value>20,1,ifelse(value>15,2,ifelse(value>12,3,4))))))}
  else if(crop=="sorghum"){suitclass=ifelse(value>40,4,ifelse(value>35,3,ifelse(value>31,2,ifelse(value>26,1,ifelse(value>24,2,ifelse(value>20,3,4))))))}
  else if(crop=="barley"){suitclass=ifelse(value>40,4,ifelse(value>38,3,ifelse(value>33,2,ifelse(value>20,1,ifelse(value>15,2,ifelse(value>12,3,4))))))}
  else if(crop=="oat"){suitclass=ifelse(value>40,4,ifelse(value>38,3,ifelse(value>30,2,ifelse(value>25,1,ifelse(value>20,2,ifelse(value>16,3,4))))))}
  else if(crop=="millet"){suitclass=ifelse(value>40,4,ifelse(value>38,3,ifelse(value>34,2,ifelse(value>28,1,ifelse(value>24,2,ifelse(value>20,3,4))))))}

  #Temperature suitability requirements for legumes
  else if(crop=="groundnut"){suitclass=ifelse(value>40,4,ifelse(value>34,3,ifelse(value>31,2,ifelse(value>24,1,ifelse(value>22,2,ifelse(value>20,3,4))))))}
  else if(crop=="pea"){suitclass=ifelse(value>40,4,ifelse(value>38,3,ifelse(value>34,2,ifelse(value>28,1,ifelse(value>25,2,ifelse(value>20,3,4))))))}
  else if(crop=="gram"){suitclass=ifelse(value>40,4,ifelse(value>30,3,ifelse(value>26,2,ifelse(value>20,1,ifelse(value>15,2,ifelse(value>5,3,4))))))}
  else if(crop=="bean"){suitclass=ifelse(value>45,4,ifelse(value>41,3,ifelse(value>36,2,ifelse(value>20,1,ifelse(value>18,2,ifelse(value>15,3,4))))))}
  else if(crop=="soybean"){suitclass=ifelse(value>36,4,ifelse(value>33,3,ifelse(value>28,2,ifelse(value>25,1,ifelse(value>15,2,ifelse(value>10,3,4))))))}
  else if(crop=="lentil"){suitclass=ifelse(value>30,4,ifelse(value>27,3,ifelse(value>20,2,ifelse(value>18,1,ifelse(value>12,2,ifelse(value>10,3,4))))))}

  #Temperature suitability requirements for forests
  else if(crop=="poplar"){suitclass=ifelse(value>40,4,ifelse(value>34,3,ifelse(value>31,2,ifelse(value>24,1,ifelse(value>22,2,ifelse(value>20,3,4))))))}
  else if(crop=="grevillea"){suitclass=ifelse(value>40,4,ifelse(value>38,3,ifelse(value>34,2,ifelse(value>28,1,ifelse(value>25,2,ifelse(value>20,3,4))))))}
  else if(crop=="sesbania"){suitclass=ifelse(value>40,4,ifelse(value>30,3,ifelse(value>26,2,ifelse(value>20,1,ifelse(value>15,2,ifelse(value>5,3,4))))))}
  else if(crop=="calliandra"){suitclass=ifelse(value>45,4,ifelse(value>41,3,ifelse(value>36,2,ifelse(value>20,1,ifelse(value>18,2,ifelse(value>15,3,4))))))}
  else if(crop=="leucaena"){suitclass=ifelse(value>36,4,ifelse(value>33,3,ifelse(value>28,2,ifelse(value>25,1,ifelse(value>15,2,ifelse(value>10,3,4))))))}
  else if(crop=="acacia"){suitclass=ifelse(value>30,4,ifelse(value>27,3,ifelse(value>20,2,ifelse(value>18,1,ifelse(value>12,2,ifelse(value>10,3,4))))))}
  else if(crop=="eucalyptus"){suitclass=ifelse(value>30,4,ifelse(value>27,3,ifelse(value>20,2,ifelse(value>18,1,ifelse(value>12,2,ifelse(value>10,3,4))))))}
  else if(crop=="teak"){suitclass=ifelse(value>30,4,ifelse(value>27,3,ifelse(value>20,2,ifelse(value>18,1,ifelse(value>12,2,ifelse(value>10,3,4))))))}
  else if(crop=="maple"){suitclass=ifelse(value>30,4,ifelse(value>27,3,ifelse(value>20,2,ifelse(value>18,1,ifelse(value>12,2,ifelse(value>10,3,4))))))}
  else if(crop=="ash"){suitclass=ifelse(value>30,4,ifelse(value>27,3,ifelse(value>20,2,ifelse(value>18,1,ifelse(value>12,2,ifelse(value>10,3,4))))))}
  

  #Temperature suitability requirements for oil crops
  if(crop=="sesame"){suitclass=ifelse(value>40,4,ifelse(value>38,3,ifelse(value>34,2,ifelse(value>30,1,ifelse(value>24,2,ifelse(value>20,3,4))))))}
  else if(crop=="sunflower"){suitclass=ifelse(value>40,4,ifelse(value>35,3,ifelse(value>31,2,ifelse(value>24,1,ifelse(value>20,2,ifelse(value>16,3,4))))))}
  else if(crop=="oilpalm"){suitclass=ifelse(value>40,4,ifelse(value>35,3,ifelse(value>33,2,ifelse(value>28,1,ifelse(value>26,2,ifelse(value>20,3,4))))))}
  else if(crop=="castor"){suitclass=ifelse(value>40,4,ifelse(value>36,3,ifelse(value>32,2,ifelse(value>26,1,ifelse(value>24,2,ifelse(value>15,3,4))))))}
  else if(crop=="safflower"){suitclass=ifelse(value>40,4,ifelse(value>34,3,ifelse(value>30,2,ifelse(value>28,1,ifelse(value>18,2,ifelse(value>15,3,4))))))}
  else if(crop=="rapeseed"){suitclass=ifelse(value>35,4,ifelse(value>33,3,ifelse(value>27,2,ifelse(value>20,1,ifelse(value>15,2,ifelse(value>10,3,4))))))}
  else if(crop=="mustard"){suitclass=ifelse(value>35,4,ifelse(value>33,3,ifelse(value>27,2,ifelse(value>20,1,ifelse(value>15,2,ifelse(value>10,3,4))))))}
  else if(crop=="olive"){suitclass=ifelse(value>40,4,ifelse(value>34,3,ifelse(value>30,2,ifelse(value>20,1,ifelse(value>15,2,ifelse(value>5,3,4))))))}

  #Temperature suitability requirements for nuts
  else if(crop=="coconut"){suitclass=ifelse(value>40,4,ifelse(value>34,3,ifelse(value>30,2,ifelse(value>26,1,ifelse(value>23,2,ifelse(value>20,3,4))))))}
  else if(crop=="cashew"){suitclass=ifelse(value>40,4,ifelse(value>36,3,ifelse(value>30,2,ifelse(value>25,1,ifelse(value>15,2,ifelse(value>12,3,4))))))}
  else if(crop=="almond"){suitclass=ifelse(value>40,2,ifelse(value>34,1,ifelse(value>25,2,ifelse(value>10,3,4))))}
  else if(crop=="pistachio"){suitclass=ifelse(value>40,2,ifelse(value>34,1,ifelse(value>25,2,ifelse(value>10,3,4))))}

  #Temperature suitability requirements for fibre/industrial (cotton,sugarcane, saffron)
  else if(crop=="cotton"){suitclass=ifelse(value>40,4,ifelse(value>35,3,ifelse(value>30,2,ifelse(value>20,1,ifelse(value>15,2,ifelse(value>10,3,4))))))}
  else if(crop=="sugarcane"){suitclass=ifelse(value>40,4,ifelse(value>38,3,ifelse(value>34,2,ifelse(value>30,1,ifelse(value>25,2,ifelse(value>20,3,4))))))}
  else if(crop=="saffron"){suitclass=ifelse(value>35,4,ifelse(value>28,3,ifelse(value>22,2,ifelse(value>10,1,ifelse(value>6,2,ifelse(value>0,3,4))))))}
  else if(crop=="tea"){suitclass=ifelse(value>30,4,ifelse(value>28,3,ifelse(value>25,2,ifelse(value>18,1,ifelse(value>15,2,ifelse(value>12,3,4))))))}
  else if(crop=="coffee"){suitclass=ifelse(value>28,4,ifelse(value>26,3,ifelse(value>24,2,ifelse(value>20,1,ifelse(value>15,2,ifelse(value>12,3,4))))))}
  else if(crop=="pyrethrum"){suitclass=ifelse(value>21,4,ifelse(value>19,3,ifelse(value>17,2,ifelse(value>12,1,ifelse(value>10,2,ifelse(value>7,3,4))))))}
  else if(crop=="rubber"){suitclass=ifelse(value>34,4,ifelse(value>32,3,ifelse(value>30,2,ifelse(value>25,1,ifelse(value>18,2,ifelse(value>12,3,4))))))}
  else if(crop=="jute"){suitclass=ifelse(value>43,4,ifelse(value>39,3,ifelse(value>35,2,ifelse(value>25,1,ifelse(value>22,2,ifelse(value>15,3,4))))))}
  else if(crop=="tobacco"){suitclass=ifelse(value>40,4,ifelse(value>33,3,ifelse(value>30,2,ifelse(value>25,1,ifelse(value>21,2,ifelse(value>15,3,4))))))}

  #Temperature suitability requirements for tuber
  else if(crop=="sweetpotato"){suitclass=ifelse(value>40,4,ifelse(value>35,3,ifelse(value>32,2,ifelse(value>25,1,ifelse(value>21,2,ifelse(value>15,3,4))))))}
  else if(crop=="cassava"){suitclass=ifelse(value>40,4,ifelse(value>33,3,ifelse(value>30,2,ifelse(value>23,1,ifelse(value>18,2,ifelse(value>12,3,4))))))}
  else if(crop=="potato"){suitclass=ifelse(value>32,4,ifelse(value>30,3,ifelse(value>26,2,ifelse(value>15,1,ifelse(value>13,2,ifelse(value>10,3,4))))))}
  else if(crop=="carrot"){suitclass=ifelse(value>35,4,ifelse(value>28,3,ifelse(value>22,2,ifelse(value>18,1,ifelse(value>13,2,ifelse(value>4,3,4))))))}
  else if(crop=="turnip"){suitclass=ifelse(value>40,4,ifelse(value>33,3,ifelse(value>25,2,ifelse(value>20,1,ifelse(value>15,2,ifelse(value>10,3,4))))))}
  else if(crop=="radish"){suitclass=ifelse(value>40,4,ifelse(value>30,3,ifelse(value>24,2,ifelse(value>18,1,ifelse(value>15,2,ifelse(value>10,3,4))))))}

  #Temperature suitability requirements for fruits
  else if(crop=="mango"){suitclass=ifelse(value>40,4,ifelse(value>36,3,ifelse(value>33,2,ifelse(value>28,1,ifelse(value>24,2,ifelse(value>20,3,4))))))}
  else if(crop=="grape"){suitclass=ifelse(value>40,4,ifelse(value>36,3,ifelse(value>30,2,ifelse(value>25,1,ifelse(value>21,2,ifelse(value>15,3,4))))))}
  else if(crop=="citrus"){suitclass=ifelse(value>40,4,ifelse(value>36,3,ifelse(value>30,2,ifelse(value>28,1,ifelse(value>25,2,ifelse(value>20,3,4))))))}
  else if(crop=="pomegranate"){suitclass=ifelse(value>40,4,ifelse(value>38,3,ifelse(value>34,2,ifelse(value>30,1,ifelse(value>25,2,ifelse(value>15,3,4))))))}
  else if(crop=="watermelon"){suitclass=ifelse(value>35,4,ifelse(value>32,3,ifelse(value>30,2,ifelse(value>24,1,ifelse(value>20,2,ifelse(value>18,3,4))))))}
  else if(crop=="avocado"){suitclass=ifelse(value>35,4,ifelse(value>30,3,ifelse(value>26,2,ifelse(value>22,1,ifelse(value>15,2,ifelse(value>10,3,4))))))}
  else if(crop=="banana"){suitclass=ifelse(value>40,4,ifelse(value>33,3,ifelse(value>25,2,ifelse(value>18,1,ifelse(value>15,2,ifelse(value>10,3,4))))))}
  else if(crop=="pineaple"){suitclass=ifelse(value>35,4,ifelse(value>30,3,ifelse(value>26,2,ifelse(value>20,1,ifelse(value>18,2,ifelse(value>16,3,4))))))}
  else if(crop=="pawpaw"){suitclass=ifelse(value>38,4,ifelse(value>34,3,ifelse(value>28,2,ifelse(value>24,1,ifelse(value>15,2,ifelse(value>8,3,4))))))}
  else if(crop=="melon"){suitclass=ifelse(value>35,4,ifelse(value>32,3,ifelse(value>30,2,ifelse(value>22,1,ifelse(value>20,2,ifelse(value>18,3,4))))))}

  #Temperature suitability requirements for vegetables
  else if(crop=="tomato"){suitclass=ifelse(value>36,4,ifelse(value>33,3,ifelse(value>28,2,ifelse(value>25,1,ifelse(value>21,2,ifelse(value>15,3,4))))))}
  else if(crop=="vegetable"){suitclass=ifelse(value>35,4,ifelse(value>30,3,ifelse(value>25,2,ifelse(value>20,1,ifelse(value>15,2,ifelse(value>10,3,4))))))}
  else if(crop=="cabbage"){suitclass=ifelse(value>35,4,ifelse(value>30,3,ifelse(value>25,2,ifelse(value>20,1,ifelse(value>15,2,ifelse(value>10,3,4))))))}
  else if(crop=="okra"){suitclass=ifelse(value>35,4,ifelse(value>30,3,ifelse(value>25,2,ifelse(value>20,1,ifelse(value>20,2,ifelse(value>15,3,4))))))}
  else if(crop=="cauliflower"){suitclass=ifelse(value>35,4,ifelse(value>30,3,ifelse(value>25,2,ifelse(value>20,1,ifelse(value>15,2,ifelse(value>10,3,4))))))}
  else if(crop=="broccoli"){suitclass=ifelse(value>35,4,ifelse(value>30,3,ifelse(value>25,2,ifelse(value>20,1,ifelse(value>15,2,ifelse(value>10,3,4))))))}

  #Temperature suitability requirements for spices
  else if(crop=="chilli"){suitclass=ifelse(value>38,4,ifelse(value>36,3,ifelse(value>33,2,ifelse(value>25,1,ifelse(value>21,2,ifelse(value>15,3,4))))))}
  else if(crop=="pepper"){suitclass=ifelse(value>40,4,ifelse(value>38,3,ifelse(value>35,2,ifelse(value>28,1,ifelse(value>21,2,ifelse(value>15,3,4))))))}
  else if(crop=="onion"){suitclass=ifelse(value>25,4,ifelse(value>23,3,ifelse(value>19,2,ifelse(value>16,1,ifelse(value>13,2,ifelse(value>10,3,4))))))}
  else if(crop=="ginger"){suitclass=ifelse(value>40,4,ifelse(value>33,3,ifelse(value>30,2,ifelse(value>25,1,ifelse(value>21,2,ifelse(value>15,3,4))))))}
  else if(crop=="tumeric"){suitclass=ifelse(value>40,4,ifelse(value>38,3,ifelse(value>33,2,ifelse(value>28,1,ifelse(value>19,2,ifelse(value>10,3,4))))))}
  else if(crop=="cardamom"){suitclass=ifelse(value>40,4,ifelse(value>38,3,ifelse(value>30,2,ifelse(value>25,1,ifelse(value>21,2,ifelse(value>15,3,4))))))}
  else if(crop=="lemongrass"){suitclass=ifelse(value>40,4,ifelse(value>38,3,ifelse(value>30,2,ifelse(value>25,1,ifelse(value>21,2,ifelse(value>15,3,4))))))}
  else if(crop=="vanilla"){suitclass=ifelse(value>40,4,ifelse(value>36,3,ifelse(value>33,2,ifelse(value>21,1,ifelse(value>15,2,ifelse(value>10,3,4))))))}

  #Temperature suitability requirements for other crops
  else if(crop=="alfalfa"){suitclass=ifelse(value>40,4,ifelse(value>32,3,ifelse(value>26,2,ifelse(value>23,1,ifelse(value>20,2,ifelse(value>15,3,4))))))}
  else if(crop=="rose"){suitclass=ifelse(value>36,4,ifelse(value>32,3,ifelse(value>30,2,ifelse(value>25,1,ifelse(value>21,2,ifelse(value>15,3,4))))))}
  else if(crop=="jasmine"){suitclass=ifelse(value>40,4,ifelse(value>35,3,ifelse(value>24,2,ifelse(value>18,1,ifelse(value>14,2,ifelse(value>10,3,4))))))}

  #Temperature suitability requirements for fleshy crops
  else if(crop=="yam"){suitclass=ifelse(value>40,4,ifelse(value>33,3,ifelse(value>30,2,ifelse(value>25,1,ifelse(value>21,2,ifelse(value>15,3,4))))))}
  else if(crop=="butternut"){suitclass=ifelse(value>40,4,ifelse(value>33,3,ifelse(value>30,2,ifelse(value>25,1,ifelse(value>21,2,ifelse(value>15,3,4))))))}
  else if(crop=="squash"){suitclass=ifelse(value>40,4,ifelse(value>33,3,ifelse(value>30,2,ifelse(value>25,1,ifelse(value>21,2,ifelse(value>15,3,4))))))}
  else if(crop=="pumpkin"){suitclass=ifelse(value>40,4,ifelse(value>33,3,ifelse(value>30,2,ifelse(value>25,1,ifelse(value>21,2,ifelse(value>15,3,4))))))}

  return(suitclass)
}

classCode=function(value,indicator="fertility"){
  if(indicator== "saltclass"){
    classcode=ifelse(value<1,"NotClassified",ifelse(value<2,"None",ifelse(value<3,"SlightSalinity",ifelse(value<4,"ModerateSalinity",ifelse(value<5,"StrongSalinity",ifelse(value<6,"Alkaline","NotClassified"))))))
  }
  else if(indicator=="saltseverity"){
    class0=ifelse(value<12,"Alkaline",ifelse(value<13,"Saline-sodic","NotClassified"))
    class1=ifelse(value<8,"SlightSodicity",ifelse(value<9,"ModerateSodicity",ifelse(value<10,"StrongSodicity",ifelse(value<11,"VeryStrongSodicity",class0))))
    classcode=ifelse(value<1,"NotClassified",ifelse(value<2,"None",ifelse(value<3,"SlightSalinity",ifelse(value<4,"ModerateSalinity",ifelse(value<5,"StrongSalinity",ifelse(value<6,"VeryStrongSalinity",ifelse(value<7,"ExtremeSalinity",class1)))))))
   }
  else if(indicator=="texture"){
    classcode=ifelse(value==1,"Cl",ifelse(value==2,"SiCl",ifelse(value==3,"SiClLo",ifelse(value==4,"SiLo",
              ifelse(value==5,"SaLo",ifelse(value==6,"Si",ifelse(value==7,"ClLo",ifelse(value==8,"SaCl",
              ifelse(value==9,"SaClLo",ifelse(value==10,"LoSa",ifelse(value==11,"Lo",ifelse(value==12,"Sa",
              ifelse(value==13,"CSa",ifelse(value==14,"MSa",ifelse(value==15,"FSa",ifelse(value==16,"HCl",
              "Texture not included"))))))))))))))))
  }
  else if(indicator=="suitability"){
    classcode=ifelse(value==1,"High",ifelse(value==2,"Moderate",ifelse(value==3,"Marginal",ifelse(value==4,"NotsuitableNow",ifelse(value==5,"Notsuitable", "NotClassified")))))
  }
  else if(indicator=="fertility"){
    classcode=ifelse(value<1.449,"High",ifelse(value<2.449,"Moderate",ifelse(value<3.449,"Low",ifelse(value<4.5,"VeryLow","NotClassified"))))
  }
  else if(indicator=="drainage"){
    #very poorly drained - VPD; poorly drained - PDr, Imperfectly drained - ImDr; Moderately drained - MoDr; well drained - WDr; somewhat excessively drained - Sdr; excessively drained - Exdr
    classcode=ifelse(value==1,"VPD",ifelse(value==2,"PDr",ifelse(value==3,"ImDr",ifelse(value==4,"MoDr",ifelse(value==5,"WDr",ifelse(value==6,"SDr",ifelse(value==7,"ExDr", "NotClassified")))))))
  }
  else if(indicator=="erodibility"){classcode=ifelse(value>0.01,"VeryLow",ifelse(value>0.1,"Low",ifelse(value>0.2,"Moderate",ifelse(value>0.6,"High",ifelse(value>0.7,"Extreme", "NotClassified")))))
  }
  else if(indicator=="permeability"){classcode=ifelse(value==1,"VerySlow",ifelse(value==2,"Slow",ifelse(value==3,"ModeratelySlow",ifelse(value==4,"Moderate",ifelse(value==5,"ModeratelyRapid",ifelse(value==6,"Rapid",ifelse(value==7,"VeryRapid","NotClassified")))))))}
  else if(indicator=="structure"){
    classcode=ifelse(structure==1,"Granular",ifelse(structure==2,"Crumby", ifelse(structure==3,"AngularBlocky",ifelse(structure==4,"Columnar",
                                                                                                                      ifelse(structure==5,"SubAngularBlocky", ifelse(structure==6,"Platty",ifelse(structure==7,"SingleGrain",ifelse(structure==8,"Massive",
                                                                                                                                                                                                                                    ifelse(structure==9,"Prismatic",ifelse(structure==10,"Cloddy","NotClassified"))))))))))
  }
  classcode=as.factor(classcode)
  return(classcode)
}

ECconversion3=function (x, A, B, method="linear")
{
  if(method=="linear"){
    .value <- A + x * B
    .grad <- array(0, c(length(.value), 2L), list(NULL, c("A", "B")))
    .grad[, "A"] <- 1
    .grad[, "B"] <- x
    attr(.value, "gradient") <- .grad
    .value}
  else if(method=="power"){
    .expr1 <- x^B
    .value <- A * .expr1
    .grad <- array(0, c(length(.value), 2L), list(NULL, c("A", "B")))
    .grad[, "A"] <- .expr1
    .grad[, "B"] <- A * (.expr1 * log(x))
    attr(.value, "gradient") <- .grad
    .value
  }
  else if (method=="exponential"){
    .expr2 <- exp(x * B)
    .value <- A * .expr2
    .grad <- array(0, c(length(.value), 2L), list(NULL, c("A","B")))
    .grad[, "A"] <- .expr2
    .grad[, "B"] <- A * (.expr2 * x)
    attr(.value, "gradient") <- .grad
    .value
  }
  else if (method=="log"){
    .expr1 <- x * B
    .expr2 <- log(.expr1)
    .value <- A * .expr2
    .grad <- array(0, c(length(.value), 2L), list(NULL, c("A", "B")))
    .grad[, "A"] <- .expr2
    .grad[, "B"] <- A * (x/.expr1)
    attr(.value, "gradient") <- .grad
    .value
  }
}

PHConversion=function(ph, model="kabala",phtype="kcl"){
  if(phtype=="kcl"){
    if(model=="kabala"){PHconvert=harmonization(log10(ph),11.58,-1.95)}
    else if (model=="sadovski"){PHconvert=harmonization(ph,0.88787,1.53466)}
  }
  else if(phtype=="cacl2"){
    if(model=="miller"){PHconvert=harmonization(ph,0.9259259,0.9009259)}
    else if(model=="davies"){PHconvert=harmonization(ph,0.9569378,0.8382775)}
    else if(model=="brennan"){PHconvert=harmonization(ph,1.089325,0.387364)}
    else if (model=="ahern"){PHconvert=harmonization(ph,1.083424,0.4041172)}
  }
  PHconvert=round(PHconvert,3)
  return(PHconvert)
}

permeabilityClass=function(texture){
  #permeability classes:1-VerySlow, 2-Slow; 3-ModerateSlow; 4-Moderate; 5-ModerateRapid; 6-Rapid; 7-VeryRapid
  if(missing(texture)){stop("texture missing")}
  if(is.character(texture)){
  if(texture=="Cl"){permclass=1}
  else if(texture=="SiCl"){permclass=2}
  else if(texture=="SiClLo"){permclass=3}
  else if(texture=="SiLo"){permclass=4}
  else if(texture=="SaLo"){permclass=5}
  else if(texture=="Si"){permclass=4}
  else if(texture=="ClLo"){permclass=3}
  else if(texture=="SaCl"){permclass=2}
  else if(texture=="SaClLo"){permclass=3}
  else if(texture=="LoSa"){permclass=6}
  else if(texture=="Lo"){permclass=4}
  else if(texture=="Sa"){permclass=6}
  else if(texture=="CSa"){permclass=7}
  else if(texture=="MSa"){permclass=7}
  else if(texture=="FSa"){permclass=7}
  else if(texture=="HCl"){permclass=1}
  else{warning("texture not defined")}
  }
  else {
    permclass=ifelse(texture==1,1,ifelse(texture==8,2,ifelse(texture==2,2,ifelse(texture==7,3,ifelse(texture==9,3,ifelse(texture==3,3,
                                                                                                                         ifelse(texture==15,4,ifelse(texture==11,4,ifelse(texture==4,4,ifelse(texture==6,4,ifelse(texture==5,5,ifelse(texture==10,6,
                                                                                                                                                                                                                                      ifelse(texture==12,6,ifelse(texture==13,7,ifelse(texture==16,1,0)))))))))))))))

  }
  return(permclass)
}

physicalSuit=function(value, crop="wheat"){
cropp1=c("maize","wheat","rice","sorghum","millet","oat","barley",
          "groundnut","bean","pea","gram","soybean","lentil",
          "alfalfa","rose","jasmine",
         "mango","grape","citrus","pomegranate","banana","watermelon","melon","pineaple","pawpaw","avocado",
         "yam","pumpkin","butternut","squash")
cropp2=c("poplar","gravillea","sesbania","calliandra","leucaena","acacia","eucalyptus","teak","maple","ash",
           "sesame","sunflower","oilpalm","castor","safflower","mustard","rapeseed","olive",
           "cashew","coconut","almond","pistachio"
          )
cropp3=c("cotton","sugarcane","tea","coffee","rubber","jute","saffron","pyrethrum","tobacco",
         "sweetpotato","cassava","potato","carrot","turnip","radish",
         "cabbage","tomato","vegetable","broccoli","cauliflower","okra"
         )
cropp4=c( "chilli","pepper","ginger","tumeric","vanilla","lemongrass","cardamom","onion","rosemary","parsley")
if(crop%in%cropp1){suitclass=getSuit(value,1.2,2,2.5,10)}
else if(crop%in%cropp2){suitclass=getSuit(value,1.2,2,3,10)}
else if(crop%in%cropp3){suitclass=getSuit(value,1.2,2,2.8,10)}
else if(crop%in%cropp4){suitclass=getSuit(value,1.2,2.1,2.6,10)}
else {stop("No crop chosen or crop not yet included in database")}
return(suitclass)
}

saltRating=function(ec,ph,criterion="FAO"){
  ph=round(ph*1,3)
  b1=ifelse(ec<0.75,6,ifelse(ec<2,8,ifelse(ec<4,9,ifelse(ec<8,10,ifelse(ec<15,11,12)))))
  b2=ifelse(ec<0.048,6,ifelse(ec<0.128,8,ifelse(ec<0.256,9,ifelse(ec<0.512,10,ifelse(ec<0.96,11,12)))))
    if(criterion=="FAO"){
    saltClass=ifelse(ph<8.2,b1,ifelse(ec<4,4,5))
  }
  else if(criterion=="USDA"){
    saltClass=ifelse(ph<8.5,b1,ifelse(ec<4,4,5))
  }
  else if(criterion=="PSALT"){
    saltClass=ifelse(ph<8.2,b2,ifelse(ec<0.25,4,5))
  }
  return(salinity=saltClass)
}

stoneSuit=function(value, crop="wheat"){
  cropp1=c("maize","rice","sorghum","millet","oat",
           "groundnut","bean","pea","gram","soybean","lentil",
           "poplar","gravillea","sesbania","calliandra","leucaena","acacia","eucalyptus","teak","maple","ash",
           "sesame","sunflower","oilpalm","castor","safflower","olive",
           "sweetpotato","cassava","potato","carrot","turnip","radish",
           "mango","grape","citrus","pomegranate","banana","watermelon","melon","pineaple","pawpaw","avocado",
           "cabbage","tomato","vegetable","broccoli","cauliflower","okra",
           "chilli","pepper","ginger","tumeric","vanilla","lemongrass","cardamom","onion","rosemary","parsley",
           "alfalfa","rose","jasmine",
           "yam","pumpkin","butternut","squash")
  cropp2=c("wheat","cashew","coconut","almond","pistachio","rapeseed","mustard","cotton","sugarcane","tea","coffee","rubber","jute","saffron","pyrethrum","tobacco")
  cropp3=c("barley","sweetpotato")

  if(crop%in%cropp1){suitclass=getSuit(value,5,15,35,100)}
  else if(crop%in%cropp2){suitclass=getSuit(value,15,35,50,100)}
  else if(crop%in%cropp3){suitclass=getSuit(value,0.2,0.5,0.75,100)}
  else {stop("No crop chosen or crop not yet included in database")}
  return(suitclass)
}

PHharm_Info=function(solution="cacl2"){
  fromServer1=("https://docs.google.com/spreadsheets/d/e/2PACX-1vScFSEj-QubwWOJIHDcYVGY-zZ_bbIgJQlvvePCnXy8r-nY9kHm9IebYtIcXwKPKfLtxqp1y59A1AgY/pub?output=csv")
  fromServer2=("https://docs.google.com/spreadsheets/d/e/2PACX-1vT-t0Ds8kMX8Wt1iceiPfseD_P3-q4mi1XVV3STS7gy9hL5pMen6SNJvO3Afd6yJMWitR_zjKPH9Mao/pub?output=csv")

  # Illustrate predictive performance
  plotf=function(x){
  inputInfo = read.csv(x)
  df1=as.matrix(inputInfo[,2:ncol(inputInfo)])
  row.names(df1)=c("Africa","N.America","Asia","Europe","LAC","NENA","Pacific")
  regioncol=c("blue","red","cyan","magenta","green","gray", "yellow")
  par(mgp=c(3,0.6,0),mar=c(5,4.5,1,1)+0.1)
  barplot(df1, las=2,beside = TRUE,xpd = FALSE,col=regioncol,ylim=c(0,1.2),horiz = FALSE, cex.names = 0.75,space = c(0.4, 4))
  grid (nx=NA, ny=NULL, lty = 6, col = "gray")
  legend("topleft", x.intersp=0.25,y.intersp=0,bg="transparent",text.width=11,legend = rownames(df1), fill = regioncol, box.lty = 0, cex = 0.6, horiz = TRUE)
  box(lty = 1, col = 'black')
  mtext(side=1, text="PH harmonization models", line=3.7)
  mtext(side=2, text="Performance index", line=2.5)
  }

  # Check internet
  get_info=function(x){
    if(is.null(checkInternet(x))){
      #stop("Stoping execution",.Call=FALSE)
      withr::with_options(
        list(show.error.messages = FALSE),
        {
          print("Internet connectivity to server is needed")
          stop(x)
        }
      )
    }
    plotf(x)
  }
  if(solution=="kcl"){
    get_info(fromServer1)
  }
  else if(solution == "cacl2"){
    get_info(fromServer2)
  }

}

predUncertain=function(indata,fgrid, k, z, model="rf"){
  total <- 20
  pb = txtProgressBar(min = 0, max = total, style = 3)
  for(j in 1:5){
    Sys.sleep(0.5)
    setTxtProgressBar(pb, j)}
  ssw=stack()
  z1=z/100
  z2=1-z1
  (na.cols=function(x){
    y <- sapply(x, function(xx)any(is.na(xx)))
    names(y[y])
  })
  if(any(is.na(data.frame(indata)))){stop(paste("Remove NA in columns: ", paste(na.cols(indata), collapse=", ")))}
  if(class(fgrid)[1]=="RasterStack"){{
  stack1=(fgrid)
  rasvali=extract(stack1,indata)
  rasvali=cbind(indata,rasvali)
  dfram=data.frame(rasvali)[,1:(ncol(rasvali))]
  for(j in 5:10){
    Sys.sleep(0.5)
    setTxtProgressBar(pb, j)}
if(model=="qrf") {
  nn <- ncol(dfram)
  colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
  faw=c(colnames(dfram)[2:nn])
  fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
  for(i in 1:k) {
    bound = floor((nrow(dfram)/(1.2*i))*1)
    butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
    rf1=train(fml,  data = butdat,  method = "qrf",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
    i= raster::predict(stack1, rf1)
    ssw <- stack(ssw, i)
    pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
    pred_sd = raster::calc(ssw,fun = sd)
     }
pred_width = (pred_interval[[2]] - pred_interval[[1]])
pred_out=stack(pred_width,pred_sd)
}
 else if(model=="lm"){
   nn <- ncol(dfram)
   colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
   faw=c(colnames(dfram)[2:nn])
   fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
   for(i in 1:k) {
     bound = floor((nrow(dfram)/(1.2*i))*1)
     butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
     rf1=train(fml,  data = butdat,  method = "lm",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
     i= raster::predict(stack1, rf1)
     ssw <- stack(ssw, i)
     pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
     pred_sd = raster::calc(ssw,fun = sd)
   }
   pred_width = (pred_interval[[2]] - pred_interval[[1]])
   pred_out=stack(pred_width,pred_sd)
 }
  else if(model=="rf"){
    nn <- ncol(dfram)
    colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
    faw=c(colnames(dfram)[2:nn])
    fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
    for(i in 1:k) {
      bound = floor((nrow(dfram)/(1.2*i))*1)
      butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
      rf1=train(fml,  data = butdat,  method = "rf",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
      i= raster::predict(stack1, rf1)
      ssw <- stack(ssw, i)
      pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
      pred_sd = raster::calc(ssw,fun = sd)
    }
    pred_width = (pred_interval[[2]] - pred_interval[[1]])
    pred_out=stack(pred_width,pred_sd)
  }
  else if(model=="ranger"){
    nn <- ncol(dfram)
    colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
    faw=c(colnames(dfram)[2:nn])
    fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
    for(i in 1:k) {
      bound = floor((nrow(dfram)/(1.2*i))*1)
      butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
      rf1=train(fml,  data = butdat,  method = "ranger",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
      i= raster::predict(stack1, rf1)
      ssw <- stack(ssw, i)
      pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
      pred_sd = raster::calc(ssw,fun = sd)
    }
    pred_width = (pred_interval[[2]] - pred_interval[[1]])
    pred_out=stack(pred_width,pred_sd)
  }
  else if(model=="cubist"){
    nn <- ncol(dfram)
    colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
    faw=c(colnames(dfram)[2:nn])
    fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
    for(i in 1:k) {
      bound = floor((nrow(dfram)/(1.2*i))*1)
      butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
      rf1=train(fml,  data = butdat,  method = "cubist",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
      i= raster::predict(stack1, rf1)
      ssw <- stack(ssw, i)
      pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
      pred_sd = raster::calc(ssw,fun = sd)
    }
    pred_width = (pred_interval[[2]] - pred_interval[[1]])
    pred_out=stack(pred_width,pred_sd)
  }
  else if(model=="rpart"){
    nn <- ncol(dfram)
    colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
    faw=c(colnames(dfram)[2:nn])
    fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
    for(i in 1:k) {
      bound = floor((nrow(dfram)/(1.2*i))*1)
      butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
      rf1=train(fml,  data = butdat,  method = "rpart",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
      i= raster::predict(stack1, rf1)
      ssw <- stack(ssw, i)
      pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
      pred_sd = raster::calc(ssw,fun = sd)
    }
    pred_width = (pred_interval[[2]] - pred_interval[[1]])
    pred_out=stack(pred_width,pred_sd)
  }
  else if(model=="treebag"){
    nn <- ncol(dfram)
    colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
    faw=c(colnames(dfram)[2:nn])
    fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
    for(i in 1:k) {
      bound = floor((nrow(dfram)/(1.2*i))*1)
      butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
      rf1=train(fml,  data = butdat,  method = "treebag",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
      i= raster::predict(stack1, rf1)
      ssw <- stack(ssw, i)
      pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
      pred_sd = raster::calc(ssw,fun = sd)
    }
    pred_width = (pred_interval[[2]] - pred_interval[[1]])
    pred_out=stack(pred_width,pred_sd)
  }
  else if(model=="svmLinear"){
    nn <- ncol(dfram)
    colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
    faw=c(colnames(dfram)[2:nn])
    fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
    for(i in 1:k) {
      bound = floor((nrow(dfram)/(1.2*i))*1)
      butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
      rf1=train(fml,  data = butdat,  method = "svmLinear",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
      i= raster::predict(stack1, rf1)
      ssw <- stack(ssw, i)
      pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
      pred_sd = raster::calc(ssw,fun = sd)
    }
    pred_width = (pred_interval[[2]] - pred_interval[[1]])
    pred_out=stack(pred_width,pred_sd)
  }
  else if(model=="bayesglm"){
    nn <- ncol(dfram)
    colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
    faw=c(colnames(dfram)[2:nn])
    fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
    for(i in 1:k) {
      bound = floor((nrow(dfram)/(1.2*i))*1)
      butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
      rf1=train(fml,  data = butdat,  method = "bayesglm",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
      i= raster::predict(stack1, rf1)
      ssw <- stack(ssw, i)
      pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
      pred_sd = raster::calc(ssw,fun = sd)
    }
    pred_width = (pred_interval[[2]] - pred_interval[[1]])
    pred_out=stack(pred_width,pred_sd)
  }
  else if(model=="qrnn"){
    nn <- ncol(dfram)
    colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
    faw=c(colnames(dfram)[2:nn])
    fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
    for(i in 1:k) {
      bound = floor((nrow(dfram)/(1.2*i))*1)
      butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
      rf1=train(fml,  data = butdat,  method = "qrnn",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
      i= raster::predict(stack1, rf1)
      ssw <- stack(ssw, i)
      pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
      pred_sd = raster::calc(ssw,fun = sd)
    }
    for(j in 10:15){
      Sys.sleep(0.5)
      setTxtProgressBar(pb, j)}

    pred_width = (pred_interval[[2]] - pred_interval[[1]])
    pred_out=stack(pred_width,pred_sd)
  }
  for(j in 15:total){
    Sys.sleep(0.5)
    setTxtProgressBar(pb, j)}}
  }
  else {
    {
      stack1=raster::stack(fgrid)
      rasvali=extract(stack1,indata)
      rasvali=cbind(indata,rasvali)
      dfram=data.frame(rasvali)[,1:(ncol(rasvali))]
      for(j in 5:10){
        Sys.sleep(0.5)
        setTxtProgressBar(pb, j)}
      if(model=="qrf") {
        nn <- ncol(dfram)
        colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
        faw=c(colnames(dfram)[2:nn])
        fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
        for(i in 1:k) {
          bound = floor((nrow(dfram)/(1.2*i))*1)
          butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
          rf1=train(fml,  data = butdat,  method = "qrf",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
          i= raster::predict(stack1, rf1)
          ssw <- stack(ssw, i)
          pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
          pred_sd = raster::calc(ssw,fun = sd)
        }
        pred_width = (pred_interval[[2]] - pred_interval[[1]])
        pred_out=stack(pred_width,pred_sd)
      }
      else if(model=="lm"){
        nn <- ncol(dfram)
        colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
        faw=c(colnames(dfram)[2:nn])
        fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
        for(i in 1:k) {
          bound = floor((nrow(dfram)/(1.2*i))*1)
          butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
          rf1=train(fml,  data = butdat,  method = "lm",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
          i= raster::predict(stack1, rf1)
          ssw <- stack(ssw, i)
          pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
          pred_sd = raster::calc(ssw,fun = sd)
        }
        pred_width = (pred_interval[[2]] - pred_interval[[1]])
        pred_out=stack(pred_width,pred_sd)
      }
      else if(model=="rf"){
        nn <- ncol(dfram)
        colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
        faw=c(colnames(dfram)[2:nn])
        fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
        for(i in 1:k) {
          bound = floor((nrow(dfram)/(1.2*i))*1)
          butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
          rf1=train(fml,  data = butdat,  method = "rf",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
          i= raster::predict(stack1, rf1)
          ssw <- stack(ssw, i)
          pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
          pred_sd = raster::calc(ssw,fun = sd)
        }
        pred_width = (pred_interval[[2]] - pred_interval[[1]])
        pred_out=stack(pred_width,pred_sd)
      }
      else if(model=="ranger"){
        nn <- ncol(dfram)
        colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
        faw=c(colnames(dfram)[2:nn])
        fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
        for(i in 1:k) {
          bound = floor((nrow(dfram)/(1.2*i))*1)
          butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
          rf1=train(fml,  data = butdat,  method = "ranger",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
          i= raster::predict(stack1, rf1)
          ssw <- stack(ssw, i)
          pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
          pred_sd = raster::calc(ssw,fun = sd)
        }
        pred_width = (pred_interval[[2]] - pred_interval[[1]])
        pred_out=stack(pred_width,pred_sd)
      }
      else if(model=="cubist"){
        nn <- ncol(dfram)
        colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
        faw=c(colnames(dfram)[2:nn])
        fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
        for(i in 1:k) {
          bound = floor((nrow(dfram)/(1.2*i))*1)
          butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
          rf1=train(fml,  data = butdat,  method = "cubist",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
          i= raster::predict(stack1, rf1)
          ssw <- stack(ssw, i)
          pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
          pred_sd = raster::calc(ssw,fun = sd)
        }
        pred_width = (pred_interval[[2]] - pred_interval[[1]])
        pred_out=stack(pred_width,pred_sd)
      }
      else if(model=="rpart"){
        nn <- ncol(dfram)
        colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
        faw=c(colnames(dfram)[2:nn])
        fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
        for(i in 1:k) {
          bound = floor((nrow(dfram)/(1.2*i))*1)
          butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
          rf1=train(fml,  data = butdat,  method = "rpart",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
          i= raster::predict(stack1, rf1)
          ssw <- stack(ssw, i)
          pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
          pred_sd = raster::calc(ssw,fun = sd)
        }
        pred_width = (pred_interval[[2]] - pred_interval[[1]])
        pred_out=stack(pred_width,pred_sd)
      }
      else if(model=="treebag"){
        nn <- ncol(dfram)
        colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
        faw=c(colnames(dfram)[2:nn])
        fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
        for(i in 1:k) {
          bound = floor((nrow(dfram)/(1.2*i))*1)
          butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
          rf1=train(fml,  data = butdat,  method = "treebag",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
          i= raster::predict(stack1, rf1)
          ssw <- stack(ssw, i)
          pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
          pred_sd = raster::calc(ssw,fun = sd)
        }
        pred_width = (pred_interval[[2]] - pred_interval[[1]])
        pred_out=stack(pred_width,pred_sd)
      }
      else if(model=="svmLinear"){
        nn <- ncol(dfram)
        colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
        faw=c(colnames(dfram)[2:nn])
        fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
        for(i in 1:k) {
          bound = floor((nrow(dfram)/(1.2*i))*1)
          butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
          rf1=train(fml,  data = butdat,  method = "svmLinear",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
          i= raster::predict(stack1, rf1)
          ssw <- stack(ssw, i)
          pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
          pred_sd = raster::calc(ssw,fun = sd)
        }
        pred_width = (pred_interval[[2]] - pred_interval[[1]])
        pred_out=stack(pred_width,pred_sd)
      }
      else if(model=="bayesglm"){
        nn <- ncol(dfram)
        colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
        faw=c(colnames(dfram)[2:nn])
        fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
        for(i in 1:k) {
          bound = floor((nrow(dfram)/(1.2*i))*1)
          butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
          rf1=train(fml,  data = butdat,  method = "bayesglm",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
          i= raster::predict(stack1, rf1)
          ssw <- stack(ssw, i)
          pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
          pred_sd = raster::calc(ssw,fun = sd)
        }
        pred_width = (pred_interval[[2]] - pred_interval[[1]])
        pred_out=stack(pred_width,pred_sd)
      }
      else if(model=="qrnn"){
        nn <- ncol(dfram)
        colnames(dfram)<-sub(".*\\$", "",colnames(dfram))
        faw=c(colnames(dfram)[2:nn])
        fml=as.formula(paste(colnames(dfram[1]),paste(faw,collapse = "+"),sep = "~"))
        for(i in 1:k) {
          bound = floor((nrow(dfram)/(1.2*i))*1)
          butdat <- dfram[sample(nrow(dfram)), ][1:bound, ]
          rf1=train(fml,  data = butdat,  method = "qrnn",trControl=trainControl( method = "cv",number=k,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
          i= raster::predict(stack1, rf1)
          ssw <- stack(ssw, i)
          pred_interval <- raster::calc(ssw, function(x) {quantile(x,probs = c(z2, z1),na.rm = TRUE)})
          pred_sd = raster::calc(ssw,fun = sd)
        }
        for(j in 10:15){
          Sys.sleep(0.5)
          setTxtProgressBar(pb, j)}

        pred_width = (pred_interval[[2]] - pred_interval[[1]])
        pred_out=stack(pred_width,pred_sd)
      }
      for(j in 15:total){
        Sys.sleep(0.5)
        setTxtProgressBar(pb, j)}}
  }

  names(pred_out)=c("pred_width","pred_sd")
  return(pred_out)
}

classnames=function(indicator="texture"){
  if(indicator=="salinity"){
    classcodes=matrix(c(1,"None",2,"Slight",7,"VerySlight",3,"Moderate",4,"Strong",5,"VeryStrong",6,"Extreme", 8,"Sodic", 9,"Saline-Sodic",10,"Salty"),nrow = 2,ncol = 10,byrow = FALSE)

  }
  if(indicator=="texture"){
    classcodes=matrix(c(1,"CL","Clay",2,"SiCl","SiltyCLay",3,"SiClLo","SiltyCLayLoam",4,"SiLo","SiltyLoam",5,"SaLo","SandyLoam",6,"Si","Silty",7,"ClLo","ClayLoam",8,"SaCl","SandyClay",9,"SaClLo","SandyClayLoam",10,"LoSa","LoamySand",11,"Lo","Loam",12,"Sa","Sandy",13,"CS","CoarseSand",14,"MS","MediumSand",15,"FS","FineSand",16,"HCL","HeavyClay"),nrow = 3,ncol = 16,byrow = FALSE)

  }
  if(indicator=="suitability"){
    classcodes=matrix(c(1,"High",2,"Moderate",3,"Marginal",4,"NotsuitableNow",5,"NotSuitable"),nrow = 2,ncol = 5,byrow = FALSE)

  }
  if(indicator=="drainage"){
    classcodes=matrix(c(1,"VPr","VeryPoorlyDrained",2,"PDr","PoorlyDrained",3,"Imp","ImperfectlyDrained",4,"Modr","ModeratelyDrained",5,"WDr","WellDrained",6,"SDr","SomewhatExcessivelyDrained", 7,"Exdr","ExcessivelyDrained"),nrow = 3,ncol = 7,byrow = FALSE)

  }
  if(indicator=="fertility"){
    classcodes=matrix(c(1,"High",2,"Moderate",3,"Low",4,"VeryLow"),nrow = 2,ncol = 4,byrow = FALSE)

  }
  if(indicator=="erodibility"){
    classcodes=matrix(c(1,"High",2,"Moderate",3,"Low",4,"VeryLow"),nrow = 2,ncol = 4,byrow = FALSE)
}
  if(indicator=="permeability"){
      classcodes=matrix(c(1,"VerySlow",2,"Slow", 3,"ModeratelySlow", 4,"Moderate", 5,"ModeratelyRapid",6,"Rapid",7,"VeryRapid"),nrow = 2,ncol = 7,byrow = FALSE)
    }
  if(indicator=="structure"){
      classcodes=matrix(c(1,"Granular",2,"Crumby", 3,"AngularBlocky", 4,"Columnar", 5,"SubAngularBlocky",6,"Platty",7,"SingleGrain",8,"Massive",9,"Prismatic",10,"Cloddy"),nrow = 2,ncol = 10,byrow = FALSE)
    }

return(classcodes)
}

saltClass=function(ec,ph,esp){
  ec=ec*1
  esp=esp*1
  ph=ph*1
  bb1=ifelse(negData("esp",esp)<15,4,13)
  bb2=ifelse(negData("esp",esp)<15,14,5)
  saltClass=ifelse(negData("ec",ec)<4,bb1,bb2)
  return(salinity=saltClass)
}

bulkdenSuit=function(value, crop="wheat"){
  cropp1=c("maize","wheat","rice","sorghum","millet","oat","barley",
           "groundnut","bean","pea","gram","soybean","lentil",
           "mango","grape","citrus","pomegranate","banana","watermelon","melon","pineaple","pawpaw","avocado",
           "alfalfa","rose","jasmine",
           "yam","pumpkin","butternut","squash","cassava")
  cropp2=c( "cabbage","tomato","vegetable","broccoli","cauliflower","okra",
            "chilli","pepper","ginger","tumeric","vanilla","lemongrass","cardamom","onion","rosemary","parsley")
  cropp3=c("sesame","sunflower","oilpalm","castor","safflower","mustard","rapeseed","olive",
           "cotton","sugarcane","tea","coffee","rubber","jute","saffron","pyrethrum","tobacco")
  cropp4=c("poplar","gravillea","sesbania","calliandra","leucaena","acacia","eucalyptus","teak","maple","ash",
           "cashew","coconut","almond","pistachio")
  if(crop%in%cropp1){suitclass=getSuit(value,1.2,1.3,1.5,2.6)}
  else if(crop%in%cropp2){suitclass=getSuit(value,1.2,1.3,1.45,2.6)}
  else if(crop%in%cropp3){suitclass=getSuit(value,1.2,1.3,1.55,2.6)}
  else if(crop%in%cropp4){suitclass=getSuit(value,1.2,1.3,1.6,2.6)}
  else {stop("No crop chosen or crop not yet included in database")}
  return(suitclass)
}

getSuit=function(x, lim1,lim2,lim3,lim4){
  if(is.numeric(x)){
    classj=ifelse(x<0,NA,ifelse(x>lim4,NA,ifelse(x>lim3,4,ifelse(x>lim2,3,ifelse(x>lim1,2,1)))))
  }
  else {
    classj=ifel(x<0,NA,ifel(x>lim4,NA,ifel(x>lim3,4,ifel(x>lim2,3,ifel(x>lim1,2,1)))))
    }
  return(classj)
}

predAccuracy=function(x,y){
  Bias=mean(y-x,na.rm=TRUE)
  RMSE=sqrt(sum((y-x)^2,na.rm=TRUE)/length((y-y)))
  Rsquared=cor(y,x,use = "na.or.complete",method = "pearson")^2
  NSE=1-sum((y-x)^2,na.rm=TRUE)/sum((y-mean(x,na.rm=TRUE))^2,na.rm=TRUE)
  statia=data.frame(Bias,RMSE,Rsquared,NSE)
  return(statia)
}

ECSuit=function(value, crop="wheat"){
  cropp1=c("cabbage","tomato","vegetable","broccoli","cauliflower","okra",
           "chilli","pepper","ginger","tumeric","vanilla","lemongrass","cardamom","onion","rosemary","parsley",
           "alfalfa","rose","jasmine",
           "yam","pumpkin","butternut","squash",
           "maize","millet","bean","soybean","lentil","gravillea",
           "calliandra","leucaena","acacia","eucalyptus","teak","maple","ash",
           "sesame","sunflower","castor","mustard","mustard","rubber","turnip","radish", "banana","pawpaw")
  cropp2=c("wheat","sorghum","groundnut","poplar","oilpalm","sweetpotato","cassava",
           "potato","carrot","melon", "avocado","pomegranate")
  cropp3=c("barley","rice","cotton","cashew","coconut","almond","pistachio",
           "safflower","pyrethrum", "sugarcane")
  cropp4=c("pea","gram","mango","grape", "citrus","tobacco","tea","coffee")

  if(crop%in%cropp1){suitclass=getSuit(value,1,2,4,1000)}
  else if(crop%in%cropp2){suitclass=getSuit(value,2,4,6,1000)}
  else if(crop%in%cropp3){suitclass=getSuit(value,2,6,15,1000)}
  else if(crop%in%cropp4){suitclass=getSuit(value,0.5,1,2,1000)}
  else {stop("No crop chosen or crop not yet included in database")}
  return(suitclass)
}

carbonateSuit=function(value, crop="wheat"){
  cropp1 = c("pea","soybean","lentil","sesbania","acacia","leucaena","eucalyptus","maple","cabbage","grevillea","ash",
           "sesame","bean","sunflower","oilpalm","castor","safflower","mustard","rapeseed","olive","alfalfa",
           "cotton","sugarcane","tea","coffee","rubber","jute","saffron","pyrethrum","tobacco","teak")
  cropp2 = c("rice","gram","calliandra","grape")
  cropp3 = c("chilli","pepper","ginger","tumeric","vanilla","lemongrass","cardamom","onion",
           "rosemary","parsley","rose","jasmine","yam","pumpkin","butternut","squash",
           "vegetable","broccoli","cauliflower","okra")
  cropp4 = c("sorghum","millet","oat","barley")
  cropp5 = c("cassava","mango","citrus","tomato")
  cropp6 = c("groundnut","poplar","cashew","coconut","almond","pistachio", "maize","wheat")
  cropp7 = c("pomegranate","banana","watermelon","melon","pineaple","pawpaw","avocado",
             "sweetpotato","potato","carrot","turnip","radish")

   if    (crop%in%cropp1){suitclass=getSuit(value,6,10,25,100)}
  else if(crop%in%cropp2){suitclass=getSuit(value,10,20,30,100)}
  else if(crop%in%cropp3){suitclass=getSuit(value,4,10,15,100)}
  else if(crop%in%cropp4){suitclass=getSuit(value,3,10,25,100)}
  else if(crop%in%cropp5){suitclass=getSuit(value,0.5,5,10,100)}
  else if(crop%in%cropp6){suitclass=getSuit(value,12,25,35,100)}
  else if(crop%in%cropp7){suitclass=getSuit(value,5,15,30,100)}
  else {stop("No crop chosen or crop not yet included in database")}
  return(suitclass)
}

ME_ECharm=function(EC,TEXCLASS, model="polynomial", soilsolution="1:2"){
  #TEXCLASS,Cl=1, ClLo =7,Lo=11,LoSa=10,Sa=12,SaCl=8,SaClLo=9,SaLo=5,SiCl=2,SiClLo=3,SiLo=4,Si=6,CS=13,MS=14,HCL=16,FS=15
  TEXCLASS2=ifelse(TEXCLASS=="Cl",1,ifelse(TEXCLASS=="ClLo",7,ifelse(TEXCLASS=="Lo",11, ifelse(TEXCLASS=="LoSa",10,
                                                                                               ifelse(TEXCLASS=="Sa",12,ifelse(TEXCLASS=="SaCl",8,ifelse(TEXCLASS=="SaClLo",9,
                                                                                                                                                         ifelse(TEXCLASS=="SaLo",5,ifelse(TEXCLASS=="SiCl",2,ifelse(TEXCLASS=="SiClLo",3,
                                                                                                                                                                                                                    ifelse(TEXCLASS=="SiLo",4,ifelse(TEXCLASS=="Si",6,ifelse(TEXCLASS=="CS",13,
                                                                                                                                                                                                                                                                             ifelse(TEXCLASS=="MS",14,ifelse(TEXCLASS=="HCl",16,ifelse(TEXCLASS=="FS",15,0))))))))))))))))

  if (soilsolution=="1:2"){
    dfm=data.frame(EC2=c(EC),TEXCLASS1=c(TEXCLASS2))
    if(model=="polynomial"){ECharm=predict(ME_ECharmserve[[1]],dfm)}
    else if(model=="sigmoid"){ECharm=predict(ME_ECharmserve[[2]],dfm)}
    else if(model=="spherical"){ECharm=predict(ME_ECharmserve[[3]],dfm)}
    else if(model=="gaussian"){ECharm=predict(ME_ECharmserve[[4]],dfm)}
    else if(model=="linear"){ECharm=predict(ME_ECharmserve[[5]],dfm)}
    else if(model=="power"){ECharm=predict(ME_ECharmserve[[6]],dfm)}
    else if(model=="exponential"){ECharm=predict(ME_ECharmserve[[7]],dfm)}}
  else if(soilsolution=="1:2.5"){
    dfm=data.frame(EC25=c(EC),TEXCLASS1=c(TEXCLASS2))
    if(model=="polynomial"){ECharm=predict(ME_ECharmserve[[8]],dfm)}
    else if(model=="sigmoid"){ECharm=predict(ME_ECharmserve[[9]],dfm)}
    else if(model=="spherical"){ECharm=predict(ME_ECharmserve[[10]],dfm)}
    else if(model=="gaussian"){ECharm=predict(ME_ECharmserve[[11]],dfm)}
    else if(model=="linear"){ECharm=predict(ME_ECharmserve[[12]],dfm)}
    else if(model=="power"){ECharm=predict(ME_ECharmserve[[13]],dfm)}
    else if(model=="exponential"){ECharm=predict(ME_ECharmserve[[14]],dfm)}}
  else if(soilsolution=="1:5"){
    dfm=data.frame(EC50=c(EC),TEXCLASS1=c(TEXCLASS2))
    if(model=="polynomial"){ECharm=predict(ME_ECharmserve[[15]],dfm)}
    else if(model=="sigmoid"){ECharm=predict(ME_ECharmserve[[16]],dfm)}
    else if(model=="spherical"){ECharm=predict(ME_ECharmserve[[17]],dfm)}
    else if(model=="gaussian"){ECharm=predict(ME_ECharmserve[[18]],dfm)}
    else if(model=="linear"){ECharm=predict(ME_ECharmserve[[19]],dfm)}
    else if(model=="power"){ECharm=predict(ME_ECharmserve[[20]],dfm)}
    else if(model=="exponential"){ECharm=predict(ME_ECharmserve[[21]],dfm)}}

  ECharm=ifelse(ECharm<0,0,ECharm)
  return(ECharm)
}

carbonTurnover=function(tt,clay,C0,In, Dr=1.44, effcts, solver="lsoda"){
    func0=function(Clay, Dr){
      k=c(10,0.3,0.66,0.02,0.0)
      o=Dr/(1+Dr)
      f = 1.67 * (1.85 + 1.6 * exp(-0.0786 * clay))
      aa=c(k[1],k[2],k[3],k[4])
      a3=0.46*aa/(f+1)
      a4=0.54*aa/(f+1)
    c(o=o,a31=a3[1],a32=a3[2],a33=a3[3],a34=a3[4],a41=a4[1],a42=a4[2],a43=a4[3],a44=a4[4])
  }
  pars1=func0(clay,Dr)
  if (length(C0) != 5) {
    stop("check the number of compartments for initial carbon pools MUST 5")}
   else {
     stat1=c(C1=C0[1],C2=C0[2],C3=C0[3],C4=C0[4],C5=C0[5])}
    if(length(effcts)==1)
      func1=function(tt){effcts}
    if(is(effcts,"data.frame")){
      uu1=effcts[,1]
      uu2=effcts[,2]
      func1=splinefun(uu1,uu2)
      }

   if (length(In) == 1)
     func2=function(tt){In}
    if (is(In,"data.frame")){
      uu3=In[,1]
      uu4=In[,2]
      func2=splinefun(uu3,uu4)
      }
    func3=function(tt,stat1,pars1){
    with(as.list(c(stat1,pars1)),{
      rr=func1(tt)
      pp=func2(tt)
      dC1=o*pp-(C1*10)*rr
      dC2=(1-o)*pp-(C2*0.3)*rr
      dC3=(a31*C1+a32*C2+(-0.66+a33)*C3+a34*C4)*rr
      dC4=(a41*C1+a42*C2+a43*C3+(-0.02+a44)*C4)*rr
      dC5=0.0
      return(list(c(dC1,dC2,dC3,dC4,dC5)))
    })
  }
  pools <- ode(y = stat1, times = tt, func = func3, parms = pars1, method = solver)
  return(pools)
}

textureSuit=function(value,crop="wheat"){
  #Soil texture suitability raing for cereals
  if(crop=="wheat"){suitclass=ifelse(value==11,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==9,1,ifelse(value==8,2,ifelse(value==2,2,ifelse(value==1,2,ifelse(value==10,2,ifelse(value==3,2,ifelse(value==5,2,ifelse(value==16,3,4)))))))))))}
  else if(crop=="maize"){suitclass=ifelse(value==11,1,ifelse(value==7,1,ifelse(value==9,1,ifelse(value==4,1,ifelse(value==5,2,ifelse(value==3,2,ifelse(value==2,2,ifelse(value==13,3,ifelse(value==10,3,4)))))))))}
  else if(crop=="rice"){suitclass=ifelse(value==1,1,ifelse(value==2,1,ifelse(value==7,1,ifelse(value==3,1,ifelse(value==8,1,ifelse(value==9,2,ifelse(value==4,2,ifelse(value==11,2,ifelse(value==5,3,ifelse(value==10,3,4))))))))))}
  else if(crop=="sorghum"){suitclass=ifelse(value==1,1,ifelse(value==7,1,ifelse(value==3,1,ifelse(value==8,1,ifelse(value==11,2,ifelse(value==4,2,ifelse(value==2,2,ifelse(value==5,3,ifelse(value==10,3,4)))))))))}
  else if(crop=="millet"){suitclass=ifelse(value==11,1,ifelse(value==4,1,ifelse(value==5,1,ifelse(value==7,1,ifelse(value==3,1,ifelse(value==9,1,ifelse(value==2,2,ifelse(value==1,2,ifelse(value==8,2,ifelse(value==10,3,ifelse(value==16,3,4)))))))))))}
  else if(crop=="barley"){suitclass=ifelse(value==1,1,ifelse(value==7,1,ifelse(value==3,1,ifelse(value==6,1,ifelse(value==8,2,ifelse(value==9,2,ifelse(value==16,2,ifelse(value==5,3,ifelse(value==10,3,4)))))))))}
  else if(crop=="oat"){suitclass=ifelse(value==1,1,ifelse(value==7,1,ifelse(value==3,1,ifelse(value==6,1,ifelse(value==8,2,ifelse(value==9,2,ifelse(value==16,2,ifelse(value==5,3,ifelse(value==10,3,4)))))))))}

  #soil texture suitability ratings for legumes
  else if (crop=="groundnut"){suitclass=ifelse(value==11,1,ifelse(value==5,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==8,1,ifelse(value==10,2,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==16,3,4))))))))))}
  else if (crop=="gram"){suitclass=ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==9,1,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==5,3,ifelse(value==16,3,4)))))))))}
  else if(crop=="pea"){suitclass=ifelse(value==5,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==9,1,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==10,3,4))))))))}
  else if(crop=="bean"){suitclass=ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==9,1,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==5,2,ifelse(value==16,3,ifelse(value==10,3,4))))))))))}
  else if(crop=="soybean"){suitclass=ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==9,1,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==5,2,ifelse(value==16,3,ifelse(value==10,3,4))))))))))}
  else if(crop=="lentil"){suitclass=ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==9,1,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==5,2,ifelse(value==16,3,ifelse(value==10,3,4))))))))))}

  #soil texture suitability ratings for forests
  else if (crop=="poplar"){suitclass=ifelse(value==11,1,ifelse(value==5,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==8,1,ifelse(value==10,2,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==16,3,4))))))))))}
  else if (crop=="grevillea"){suitclass=ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==9,1,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==5,3,ifelse(value==16,3,4)))))))))}
  else if(crop=="sesbania"){suitclass=ifelse(value==5,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==9,1,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==10,3,4))))))))}
  else if(crop=="calliandra"){suitclass=ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==9,1,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==5,2,ifelse(value==16,3,ifelse(value==10,3,4))))))))))}
  else if(crop=="leucaena"){suitclass=ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==9,1,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==5,2,ifelse(value==16,3,ifelse(value==10,3,4))))))))))}
  else if(crop=="acacia"){suitclass=ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==9,1,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==5,2,ifelse(value==16,3,ifelse(value==10,3,4))))))))))}
  else if(crop=="eucalyptus"){suitclass=ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==9,1,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==5,2,ifelse(value==16,3,ifelse(value==10,3,4))))))))))}
  else if(crop=="teak"){suitclass=ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==9,1,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==5,2,ifelse(value==16,3,ifelse(value==10,3,4))))))))))}
  else if(crop=="maple"){suitclass=ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==9,1,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==5,2,ifelse(value==16,3,ifelse(value==10,3,4))))))))))}
  else if(crop=="ash"){suitclass=ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==9,1,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==5,2,ifelse(value==16,3,ifelse(value==10,3,4))))))))))}
  
  #SOil texture suitability rating for oilcrops
  else if(crop=="sesame"){suitclass=ifelse(value==3,1,ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==5,1,ifelse(value==2,2,ifelse(value==8,2,ifelse(value==1,2,ifelse(value==10,3,ifelse(value==16,3,4))))))))))}
  else if(crop=="sunflower"){suitclass=ifelse(value==11,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==8,1,ifelse(value==9,2,ifelse(value==2,2,ifelse(value==1,2,ifelse(value==16,3,ifelse(value==5,3,4)))))))))}
  else if(crop=="oilpalm"){suitclass=ifelse(value==11,1,ifelse(value==9,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==5,2,ifelse(value==1,3,ifelse(value==10,3,ifelse(value==12,3,4))))))))))}
  else if(crop=="castor"){suitclass=ifelse(value==11,1,ifelse(value==9,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==5,1,ifelse(value==3,2,ifelse(value==2,2,ifelse(value==8,2,ifelse(value==10,3,ifelse(value==1,3,4))))))))))}
  else if(crop=="safflower"){suitclass=ifelse(value==11,1,ifelse(value==9,1,ifelse(value==4,2,ifelse(value==7,1,ifelse(value==5,2,ifelse(value==3,1,ifelse(value==2,2,ifelse(value==8,2,ifelse(value==10,3,ifelse(value==1,3,4))))))))))}
  else if(crop=="mustard"){suitclass=ifelse(value==11,1,ifelse(value==9,1,ifelse(value==4,1,ifelse(value==10,1,ifelse(value==5,1,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==8,2,ifelse(value==7,2,ifelse(value==12,3,ifelse(value==16,3,4)))))))))))}
  else if(crop=="rapeseed"){suitclass=ifelse(value==11,1,ifelse(value==9,1,ifelse(value==4,1,ifelse(value==10,1,ifelse(value==5,1,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==8,2,ifelse(value==7,2,ifelse(value==12,3,ifelse(value==16,3,4)))))))))))}
  else if(crop=="olive"){suitclass=ifelse(value==11,1,ifelse(value==9,1,ifelse(value==4,1,ifelse(value==10,1,ifelse(value==5,1,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==8,2,ifelse(value==7,2,ifelse(value==12,3,ifelse(value==16,3,4)))))))))))}

  #soil texture suitability rating for nut crops
  else if(crop=="cashew"){suitclass=ifelse(value==11,1,ifelse(value==5,1,ifelse(value==9,1,ifelse(value==7,2,ifelse(value==4,2,ifelse(value==10,2,ifelse(value==12,2,ifelse(value==2,3,ifelse(value==1,3,ifelse(value==16,3,4))))))))))}
  else if(crop=="almond"){suitclass=ifelse(value==11,1,ifelse(value==5,1,ifelse(value==9,1,ifelse(value==7,2,ifelse(value==4,2,ifelse(value==10,2,ifelse(value==12,2,ifelse(value==2,3,ifelse(value==1,3,ifelse(value==16,3,4))))))))))}
  else if(crop=="pistachio"){suitclass=ifelse(value==11,1,ifelse(value==5,1,ifelse(value==9,1,ifelse(value==7,2,ifelse(value==4,2,ifelse(value==10,2,ifelse(value==12,2,ifelse(value==2,3,ifelse(value==1,3,ifelse(value==16,3,4))))))))))}
  else if(crop=="coconut"){suitclass=ifelse(value==7,1,ifelse(value==9,1,ifelse(value==8,1,ifelse(value==3,1,ifelse(value==4,1,ifelse(value==5,2,ifelse(value==1,2,ifelse(value==2,2,ifelse(value==16,3,ifelse(value==10,3,ifelse(value==12,3,4)))))))))))}

  #soil texture suitability rating for industrial crops
  else if(crop=="cotton"){suitclass=ifelse(value==2,1,ifelse(value==1,1,ifelse(value==3,2,ifelse(value==7,2,ifelse(value==6,3,ifelse(value==4,3,ifelse(value==8,3,ifelse(value==9,3,ifelse(value==11,3,4)))))))))}
  else if(crop=="sugarcane"){suitclass=ifelse(value==11,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==3,1,ifelse(value==8,1,ifelse(value==9,1,ifelse(value==1,2,ifelse(value==5,2,ifelse(value==16,3,4)))))))))}
  else if(crop=="tea"){suitclass=ifelse(value==11,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==5,1,ifelse(value==3,2,ifelse(value==9,1,ifelse(value==1,2,ifelse(value==2,2,ifelse(value==16,3,ifelse(value==10,3,ifelse(value==12,3,4)))))))))))}
  else if(crop=="coffee"){suitclass=ifelse(value==11,1,ifelse(value==7,1,ifelse(value==8,1,ifelse(value==1,1,ifelse(value==3,1,ifelse(value==9,1,ifelse(value==5,3,ifelse(value==2,2,ifelse(value==16,3,4)))))))))}
  else if(crop=="rubber"){suitclass=ifelse(value==11,1,ifelse(value==9,1,ifelse(value==4,2,ifelse(value==3,2,ifelse(value==8,3,ifelse(value==1,3,4))))))}
  else if(crop=="jute"){suitclass=ifelse(value==11,1,ifelse(value==7,1,ifelse(value==5,1,ifelse(value==8,2,ifelse(value==3,2,ifelse(value==9,1,ifelse(value==1,3,ifelse(value==2,2,ifelse(value==10,3,4)))))))))}
  else if(crop=="saffron"){suitclass=ifelse(value==4,1,ifelse(value==5,1,ifelse(value==9,2,ifelse(value==8,2,ifelse(value==1,2,ifelse(value==16,3,4))))))}
  else if(crop=="tobacco"){suitclass=ifelse(value==11,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==5,1,ifelse(value==3,1,ifelse(value==9,1,ifelse(value==1,3,ifelse(value==2,2,ifelse(value==16,2,ifelse(value==10,1,ifelse(value==12,1,4)))))))))))}
  else if(crop=="pyrethrum"){suitclass=ifelse(value==1,1,ifelse(value==11,1,ifelse(value==9,2,ifelse(value==16,2,ifelse(value==5,3,ifelse(value==10,3,4))))))}

  #soil texture suitability rating for tuber crops
  else if(crop=="sweetpotato"){suitcalss=ifelse(value==2,1,ifelse(value==3,1,ifelse(value==6,1,ifelse(value==11,1,ifelse(value==9,1,ifelse(value==8,1,ifelse(value==1,2,ifelse(value==5,2,ifelse(value==10,3,ifelse(value==12,3,4))))))))))}
  else if(crop=="cassava"){suitclass=ifelse(value==5,1,ifelse(value==8,1,ifelse(value==1,1,ifelse(value==2,1,ifelse(value==3,1,ifelse(value==10,2,ifelse(value==15,2,ifelse(value==12,3,ifelse(value==13,3,4)))))))))}
  else if (crop=="potato"){suitclass=ifelse(value==5,1,ifelse(value==11,1,ifelse(value==10,1,ifelse(value==12,2,ifelse(value==3,2,ifelse(value==4,2,ifelse(value==7,3,4)))))))}
  else if(crop=="carrot"){suitcalss=ifelse(value==5,1,ifelse(value==11,1,ifelse(value==4,2,ifelse(value==7,3,ifelse(value==9,3,ifelse(value==10,3,4))))))}
  else if(crop=="turnip"){suitcalss=ifelse(value==5,1,ifelse(value==11,1,ifelse(value==4,2,ifelse(value==7,3,ifelse(value==9,3,ifelse(value==10,3,4))))))}
  else if(crop=="radish"){suitcalss=ifelse(value==5,1,ifelse(value==11,1,ifelse(value==4,2,ifelse(value==7,3,ifelse(value==9,3,ifelse(value==10,3,4))))))}

  #soil texture suitability rating for fruits
  else if(crop=="mango"){suitclass=ifelse(value==8,1,ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==5,2,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,3,4))))))))}
  else if(crop=="grape"){suitclass=ifelse(value==9,1,ifelse(value==11,1,ifelse(value==7,1,ifelse(value==5,2,ifelse(value==8,2,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,3,4))))))))}
  else if(crop=="citrus"){suitclass=ifelse(value==9,1,ifelse(value==11,1,ifelse(value==3,1,ifelse(value==7,1,ifelse(value==12,1,ifelse(value==8,2,ifelse(1,2,ifelse(value==16,3,4))))))))}
  else if(crop=="pomegranate"){suitclass=ifelse(value==8,1,ifelse(value==9,1,ifelse(value==11,1,ifelse(value==7,1,ifelse(value==1,2,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==12,3,ifelse(value==10,3,4)))))))))}
  else if(crop=="banana"){suitclass=ifelse(value==8,1,ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==5,3,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,3,4))))))))}
  else if(crop=="watermelon"){suitclass=ifelse(value==8,1,ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,2,ifelse(value==10,2,ifelse(value==2,2,ifelse(value==3,1,ifelse(value==1,3,ifelse(value==12,2,4)))))))))}
  else if(crop=="melon"){suitclass=ifelse(value==8,1,ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,2,ifelse(value==10,2,ifelse(value==2,2,ifelse(value==3,1,ifelse(value==1,3,ifelse(value==12,2,4)))))))))}
  else if(crop=="pineaple"){suitclass=ifelse(value==8,1,ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,2,ifelse(value==5,1,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==1,3,4))))))))}
  else if(crop=="avocado"){suitclass=ifelse(value==8,1,ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==5,1,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==12,2,ifelse(value==1,3,ifelse(value==16,3,4))))))))))}
  else if(crop=="pawpaw"){suitclass=ifelse(value==8,1,ifelse(value==11,1,ifelse(value==4,1,ifelse(value==7,1,ifelse(value==5,1,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==12,2,ifelse(value==1,3,ifelse(value==16,3,4))))))))))}

  #soil testure suitability rating for vegetables
  else if(crop=="tomato"){suitclass=ifelse(value==11,1,ifelse(value==5,1,ifelse(value==7,1,ifelse(value==9,1,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==8,2,ifelse(value==1,3,4))))))))}
  else if(crop=="cabbage"){suitclass=ifelse(value==5,1,ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==10,2,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==8,2,ifelse(value==1,3,4))))))))))}
  else if(crop=="vegetable"){suitclass=ifelse(value==5,1,ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==10,2,ifelse(value==2,3,ifelse(value==3,2,ifelse(value==8,2,ifelse(value==1,3,4))))))))))}
  else if(crop=="broccoli"){suitclass=ifelse(value==5,1,ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==10,2,ifelse(value==2,3,ifelse(value==3,2,ifelse(value==8,2,ifelse(value==1,3,4))))))))))}
  else if(crop=="cauliflower"){suitclass=ifelse(value==5,1,ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==10,2,ifelse(value==2,3,ifelse(value==3,2,ifelse(value==8,2,ifelse(value==1,3,4))))))))))}
  else if(crop=="okra"){suitclass=ifelse(value==5,1,ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==10,2,ifelse(value==2,3,ifelse(value==3,2,ifelse(value==8,2,ifelse(value==1,3,4))))))))))}

  #soil testure suitability rating for spices
  else if(crop=="chilli"){suitclass=ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==5,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==10,3,ifelse(value==12,3,ifelse(value==16,3,4))))))))))}
  else if(crop=="pepper"){suitclass=ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==8,1,ifelse(value==5,2,ifelse(value==3,2,ifelse(value==4,2,ifelse(value==10,3,ifelse(value==1,3,ifelse(value==16,3,4))))))))))}
  else if(crop=="ginger"){suitclass=ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==5,1,ifelse(value==8,2,ifelse(value==3,2,ifelse(value==1,3,ifelse(value==10,3,ifelse(value==12,3,ifelse(value==13,3,4))))))))))}
  else if(crop=="vanilla"){suitclass=ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==5,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==10,3,ifelse(value==12,3,ifelse(value==16,3,4))))))))))}
  else if(crop=="lemongrass"){suitclass=ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==5,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==10,3,ifelse(value==12,3,ifelse(value==16,3,4))))))))))}
  else if(crop=="onion"){suitclass=ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==5,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==10,3,ifelse(value==12,3,ifelse(value==16,3,4))))))))))}
  else if(crop=="cardamom"){suitclass=ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==5,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==10,3,ifelse(value==12,3,ifelse(value==16,3,4))))))))))}
  else if(crop=="tumeric"){suitclass=ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==5,2,ifelse(value==3,2,ifelse(value==1,2,ifelse(value==10,3,ifelse(value==12,3,ifelse(value==16,3,4))))))))))}

  #soil testure suitability rating for other crops
  else if(crop=="alfalfa"){suitclass=ifelse(value==5,1,ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==10,2,ifelse(value==2,2,ifelse(value==3,1,ifelse(value==8,1,ifelse(value==1,1,ifelse(value==16,2,ifelse(value==15,2,4))))))))))))}
  else if(crop=="rose"){suitclass=ifelse(value==5,1,ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==10,4,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==8,2,ifelse(value==1,3,4))))))))))}
  else if(crop=="jasmine"){suitclass=ifelse(value==5,1,ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==10,4,ifelse(value==2,2,ifelse(value==3,2,ifelse(value==8,2,ifelse(value==1,3,4))))))))))}

  #soil testure suitability rating for fleshy crops
  else if(crop=="pumpkin"){suitclass=ifelse(value==5,1,ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==10,2,ifelse(value==2,3,ifelse(value==3,2,ifelse(value==8,2,ifelse(value==1,3,4))))))))))}
  else if(crop=="squash"){suitclass=ifelse(value==5,1,ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==10,2,ifelse(value==2,3,ifelse(value==3,2,ifelse(value==8,2,ifelse(value==1,3,4))))))))))}
  else if(crop=="butternut"){suitclass=ifelse(value==5,1,ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==10,2,ifelse(value==2,3,ifelse(value==3,2,ifelse(value==8,2,ifelse(value==1,3,4))))))))))}
  else if(crop=="yam"){suitclass=ifelse(value==5,1,ifelse(value==11,1,ifelse(value==9,1,ifelse(value==7,1,ifelse(value==4,1,ifelse(value==10,2,ifelse(value==2,3,ifelse(value==3,2,ifelse(value==8,2,ifelse(value==1,3,4))))))))))}

  return(suitclass)
}

ECconversion1=function(ec,texture,method="FAO", extract="1:5",oc=NULL,clay=NULL){
     OM = oc*1.721
   { a1=ifelse(OM<0.5,5,ifelse(OM<1,6,ifelse(OM<2,8,ifelse(OM<4,13,ifelse(OM<8,21,35)))))
    a2=ifelse(OM<0.5,8,ifelse(OM<1,9,ifelse(OM<2,11,ifelse(OM<4,16,ifelse(OM<8,24,38)))))
    a3=ifelse(OM<0.5,10,ifelse(OM<1,11,ifelse(OM<2,13,ifelse(OM<4,18,ifelse(OM<8,26,40)))))
    a4=ifelse(OM<0.5,14,ifelse(OM<1,15,ifelse(OM<2,17,ifelse(OM<4,22,ifelse(OM<8,30,45)))))
    a5=ifelse(OM<0.5,17,ifelse(OM<1,18,ifelse(OM<2,20,ifelse(OM<4,25,ifelse(OM<8,34,49)))))
    a6= ifelse(OM<0.5,19,ifelse(OM<1,20,ifelse(OM<2,22,ifelse(OM<4,27,ifelse(OM<8,36,51)))))
    a7=ifelse(OM<0.5,22,ifelse(OM<1,23,ifelse(OM<2,26,ifelse(OM<4,31,ifelse(OM<8,39,55)))))
    a8=ifelse(OM<0.5,25,ifelse(OM<1,26,ifelse(OM<2,29,ifelse(OM<4,34,ifelse(OM<8,42,58)))))
    a9=ifelse(OM<0.5,28,ifelse(OM<1,29,ifelse(OM<2,32,ifelse(OM<4,37,ifelse(OM<8,46,62)))))
    a10= ifelse(OM<0.5,32,ifelse(OM<1,33,ifelse(OM<2,36,ifelse(OM<4,41,ifelse(OM<8,50,67)))))
    a11= ifelse(OM<0.5,44,ifelse(OM<1,46,ifelse(OM<2,48,ifelse(OM<4,53,ifelse(OM<8,63,80)))))
    a12= ifelse(OM<0.5,51,ifelse(OM<1,53,ifelse(OM<2,55,ifelse(OM<4,60,ifelse(OM<8,70,88)))))
    a13= ifelse(OM<0.5,63,ifelse(OM<1,65,ifelse(OM<2,68,ifelse(OM<4,73,ifelse(OM<8,83,102)))))
    a14= ifelse(OM<0.5,105,ifelse(OM<1,107,ifelse(OM<2,110,ifelse(OM<4,116,ifelse(OM<8,126,147)))))

  }
    a15=ifelse(clay<10,a4,a7)
    a16=ifelse(clay<10,a5,a9)
  
   textu=ifelse(texture=="SaCl",3,ifelse(texture=="SiCl",3,
                                        ifelse(texture=="Cl",3,ifelse(texture=="HCl",3,ifelse(texture=="SiCl",4,
                                                                                              ifelse(texture=="Si",2,ifelse(texture=="ClLo",2,ifelse(texture=="SaClLo",2,ifelse(texture=="SiClLo",2,1)))))))))

  {ccfactor=ifelse(texture=="CS",a1,ifelse(texture=="MS",a2,ifelse(texture=="FS",a3,ifelse(texture=="LoSa",a4,
                                                                                           ifelse(texture=="SiLo",a16,ifelse(texture=="Si",a6,
                                                                                                                             ifelse(texture=="SaLo",a15,ifelse(texture=="Lo",a8,ifelse(texture=="SaClLo",a10,ifelse(texture=="ClLo",a11,
                                                                                                                                                                                                                    ifelse(texture==8,a12,ifelse(texture==2,a13,ifelse(texture==3,a11,ifelse(texture==1,a13,a14))))))))))))))}
  if (method=="FAO")  {
    if(is.null(oc))stop("OC is missing")
    else if(is.null(clay))stop("Clay content is missing")
    else if(extract=="1:1"){ElectConduct=ec*100/ccfactor}
    else if(extract=="1:1.25"){ElectConduct=ec*125/ccfactor}
    else if(extract=="1:1.5"){ElectConduct=ec*150/ccfactor}
    else if(extract=="1:2"){ElectConduct=ec*200/ccfactor}
    else if(extract=="1:2.5"){ElectConduct=ec*250/ccfactor}
    else if(extract=="1:3"){ElectConduct=ec*300/ccfactor}
    else if(extract=="1:5"){ElectConduct=ec*500/ccfactor}
    else if(extract=="1:10"){ElectConduct=ec*1000/ccfactor}

  }
  else if(method=="sonmez") {
    if(extract=="1:1"){ElectConduct=ifelse(textu==3,harmonization(ec,2.72,-1.27),ifelse(textu==2,harmonization(ec,2.15,-0.44),harmonization(ec,2.03,-0.41)))}
    else if(extract=="1:2.5"){ElectConduct=ifelse(textu==3,harmonization(ec,4.3,0.17),ifelse(textu==2,harmonization(ec,3.84,0.35),harmonization(ec,3.68,0.22)))}
    else if(extract=="1:5"){ElectConduct=ifelse(textu==3,harmonization(ec,8.22,-0.33),ifelse(textu==2,harmonization(ec,7.58,0.06),harmonization(ec,7.36,-0.24)))}
  }
  else if(method=="hogg") {
    if(extract=="1:1"){ElectConduct=ifelse(textu==3,harmonization(ec,3.01,-0.06),ifelse(textu==2,harmonization(ec,3.01,-0.77),harmonization(ec,2.66,-0.97)))}
    else if(extract=="1:2"){ElectConduct=ifelse(textu==3,harmonization(ec,3.58,0.10),ifelse(textu==2,harmonization(ec,3.23,-0.67),harmonization(ec,3.12,-0.59)))}
  }


  return(ElectConduct)
}

reclassifyMap=function(fgrid,df){
    if(class(fgrid)[1]=="SpatialGridDataFrame"){
    name1=names(fgrid@data[1])
    ccode=methods::as(fgrid[name1],"RasterLayer")
    bcode=reclassify(ccode,df)
    bclass=methods::as(bcode,"SpatialGridDataFrame")
    classcode=bclass@data[[1]]
  }
  else{
    classcode=reclassify(fgrid,df)
  }
  return(classcode)
}

ESPSuit=function(value, crop="wheat"){
  cropp1=c("cabbage","tomato","vegetable","broccoli","cauliflower","okra",
           "chilli","pepper","ginger","tumeric","vanilla","lemongrass","cardamom","onion","rosemary","parsley",
           "alfalfa","rose","jasmine",
           "yam","pumpkin","butternut","squash",
           "maize","sorghum","barley","oat",
           "groundnut","pea","gram","soybean","lentil",
           "gravillea","sesbania","calliandra","leucaena","acacia","eucalyptus","teak","maple","ash",
           "cassava","potato","carrot","turnip","radish",
           "sesame","sunflower","safflower","mustard","rapeseed","olive",
           "mango","grape","citrus","pomegranate","banana","avocado",
           "mango","grape","citrus","pomegranate","banana","watermelon","melon","pineaple","pawpaw","avocado",
           "sugarcane","tea","coffee","rubber","jute","saffron","pyrethrum","tobacco")
  cropp2=c("cotton","poplar","bean","pineaple","watermelon","melon","pawpaw","castor","oilpalm")
  cropp3=c("cashew","alfalfa","rice")
  cropp4=c("sweetpotato","wheat")

  if(crop%in%cropp1){suitclass=getSuit(value,2,10,15,1000)}
  else if(crop%in%cropp2){suitclass=getSuit(value,5,10,20,1000)}
  else if(crop%in%cropp3){suitclass=getSuit(value,10,20,50,1000)}
  else if(crop%in%cropp4){suitclass=getSuit(value,3,5,10,1000)}
  else {stop("No crop chosen or crop not yet included in database")}
  return(suitclass)
}

VegCOV=function(pcover, model="cai"){
  fg=ifelse(pcover<0,NA,ifelse(pcover>100,100,pcover))
  covexpr1=function(x,A,B){
    y=A*exp(B*x)
    return(y)}
  if(model=="cai"){cafc=ifelse(fg<0.0001,1,ifelse(fg<78.4,0.6508-0.3436*log10(fg),0.001))}
  if(model=="xu"){cafc=harmonization(fg,A=-0.01, B=1)}
  if(model=="hurni"){cafc=covexpr1(fg,A=0.25, B=-0.0529)}
  if(model=="jin"){cafc=covexpr1(fg,A=0.992, B=-0.034)}
  if(model=="liu"){cafc=0.221-0.595*log10(fg/100)}
  cover=ifelse(cafc<0,NA,ifelse(cafc>1,1,cafc))
  return(cover)
}

slopeSuit=function (x,crop="wheat"){
  if(!missing(x)){warning("slope must be in degrees")}
  cropp1=c("wheat","groundnut","pea","gram","poplar","maple","sunflower","castor","almond","pistachio",
           "mango","grape","citrus","pomegranate","ash",
           "cabbage","tomato","vegetable","broccoli","cauliflower","okra",
           "chilli","pepper","ginger","tumeric","vanilla","lemongrass","cardamom","onion","rosemary","parsley",
           "alfalfa","rose","jasmine","sesame","rapeseed",
           "yam","pumpkin","butternut","squash")
  cropp2=c("banana","potato","olive","mustard","gravillea","sorghum","bean")
  cropp3=c("barley","oat","lentil","calliandra","leucaena","acacia","eucalyptus","teak","safflower","cassava","potato","carrot","turnip","radish",
           "pineaple","pawpaw","avocado","oilplam")
  cropp4=c("millet","soybean","sesbania","rubber","coffee","tea","saffron","pyrethrum",
           "sweetpotato","melon","cashew","coconut")
  value=tan(x*pi/180)*100
  if(crop%in%cropp1){suitclass=getSuit(value,0.118,0.196,0.393,90)}
  else if(crop%in%cropp2){suitclass=getSuit(value,0.118,0.314,0.589,90)}
  else if(crop%in%cropp3){suitclass=getSuit(value,0.157,0.314,0.628,90)}
  else if(crop%in%cropp4){suitclass=getSuit(value,0.314,0.628,2,90)}
  else if(crop=="rice"){suitclass=getSuit(value,0.039,0.118,0.196,90)}
  else {stop("No crop chosen or crop not yet included in database")}
  return(suitclass)
}

sloplenFUN=function(ls,slope,method="WSmith"){
  if(!missing(slope)){warning("slope must be in degrees")}
     slope=slope*pi/180
    slop_pct=tan(slope)*100
  if(method=="WSmith"){
    m=ifelse(slop_pct<1,0.2,ifelse(slop_pct<3.5,0.3,ifelse(slop_pct<4.5,0.4,0.5)))
    SL=(ls/22.13)^m*((65.41*sin(slope)^2)+(4.56*sin(slope)+0.065))# Wischmieir and Smith (1978)
  }

  else if(method=="Remortel"){
    B=sin(slope)/(0.56+3*(sin(slope))^0.8)
    m=B/(1+B)
    S=ifelse(slop_pct<9,(0.03+10.8*sin(slope)),(16.8*sin(slope)-0.05))
    L=(ls/22.13)^m
    SL=L*S
  }
 else if(method=="Zhang"){
   m=ifelse(slop_pct<1.7,0.2,ifelse(slop_pct<5.2,0.3,ifelse(slop_pct<9,0.4,0.5)))
   S=ifelse(slop_pct<9,(0.03+10.8*sin(slope)),ifelse(slop_pct<17.6,(16.8*sin(slope)-0.05),(21.9*sin(slope)-0.96)))
   L=(ls/22.13)^m
   SL=L*S
 }
  else if(method=="Renard"){
    B=sin(slope)/(0.0896*(3*sin(slope)^0.8+0.56))
    m=B/(1+B)
    L=(ls/22.13)^m
    S=ifelse(L<6,(3*sin(slope)^0.8+0.56),ifelse(slop_pct<9,(10.8*sin(slope)+0.03),(16.8*sin(slope)-0.5)))
    SL=L*S
  }
  else if(method=="Nearing"){
    m=ifelse(slop_pct<1,0.2,ifelse(slop_pct<3.5,0.3,ifelse(slop_pct<4.5,0.4,0.5)))
    L=(ls/22.13)^m
    S1=((65.41*sin(slope)^2)+(4.56*sin(slope)+0.065))
    S2=-1.5+17/(1+exp(2.3-6.1*sin(slope)))
    S=ifelse(slope<14,S1,S2)
    SL=S*L
  }
  else if(method=="Smith"){
    m=ifelse(slop_pct<1,0.2,ifelse(slop_pct<3.5,0.3,ifelse(slop_pct<4.5,0.4,0.5)))
    L=(ls/22.13)^m
    S=0.0065*(slop_pct)^2+0.0453*slop_pct+0.065
    SL=L*S
  }
  else if(method=="Foster"){
    m=ifelse(slop_pct<1,0.2,ifelse(slop_pct<3.5,0.3,ifelse(slop_pct<4.5,0.4,0.5)))
    L=(ls/22.13)^m
    S=0.56+3*sin(slope)^0.8
    SL=L*S
  }
  else if(method=="McCool"){
    m=ifelse(slop_pct<1,0.2,ifelse(slop_pct<3.5,0.3,ifelse(slop_pct<4.5,0.4,0.5)))
    L=(ls/22.13)^m
    S=ifelse(slop_pct<9,(0.03+10.6*sin(slope)),(sin(slope)/0.0896)^0.6)
    SL=L*S
  }
  else if(method=="David"){SL=0.021*(slop_pct)^(4/3)}#David (1988)
  else if(method=="Morgan"){SL=(ls/22)^0.5*(0.065+0.045*slop_pct+0.0065*(slop_pct)^2)}
  else if (method=="Moore"){SL=1.5*((ls/22.13)^0.5)*(sin(slope)/0.09)^1.2}
  return(SL)
}

checkInternet <- function(dbase_file) {
  try_GET <- function(x, ...) {
    tryCatch(
      GET(url = x, timeout(10), ...),
      error = function(e) conditionMessage(e),
      warning = function(w) conditionMessage(w)
    )
  }
  is_response <- function(x) {
    class(x) == "response"
  }

  # First check internet connection
  if (!curl::has_internet()) {
    message("No internet connection.")
    return(invisible(NULL))
  }
  # second check for timeout problems
  resp <- try_GET(dbase_file)
  if (!is_response(resp)) {
    message(resp)
    return(invisible(NULL))
  }
  # Third check for bad url and stop if status > 400
  if (httr::http_error(resp)) {
    message_for_status(resp)
    return(invisible(NULL))
  }
  InputFile=read.csv(dbase_file)
  return(InputFile)
}

calcSuit=function(x,lm1,lm2,lm3,lm4){
 if(is.numeric(x)){
   classj=ifelse(x<0,NA,ifelse(x>lm4,NA,ifelse(x>lm3,1,ifelse(x>lm2,2,ifelse(x>lm1,3,4)))))
 }
  else {
    classj=ifel(x<0,NA,ifel(x>lm4,NA,ifel(x>lm3,1,ifel(x>lm2,2,ifel(x>lm1,3,4)))))
  }
  return(classj)
}

PHSuit=function(value, crop="wheat"){
  cropp1=c("wheat","groundnut","gram","lentil","poplar","calliandra","acacia","eucalyptus","teak","maple",
           "ash","sugarcane")
  cropp2=c("maize","sorghum","millet","oat","bean","pea","soybean","grevillea","sesbania","leucaena",
           "sesame","sunflower","oilpalm","castor","safflower","mustard","rapeseed","olive",
           "cashew","cotton","jute","tobacco","sweetpotato","cassava","potato","carrot","turnip","radish",
           "mango","pomegranate","banana","cabbage","tomato","vegetable","okra", "alfalfa","rose","jasmine",
           "chilli","pepper","tumeric")
  cropp3=c("rice","barley","coconut","almond","pistachio","coffee","saffron","grape","citrus","watermelon",
           "melon","pawpaw","broccoli","cauliflower","onion","ginger","lemongrass","cardamom")
  cropp4=c("tea","pyrethrum","rubber","pineaple","avocado","yam","pumpkin","butternut","squash","vanilla"
           )
  if(crop%in%cropp1){suitclass=getSuit(value,6.5,7.5,8,14)}
  else if(crop%in%cropp2){suitclass=getSuit(value,5.6,7,8.1,14)}
  else if(crop%in%cropp3){suitclass=getSuit(value,5.2,6,7.8,14)}
  else if(crop%in%cropp4){suitclass=getSuit(value,5,6.1,7.5,14)}
  else {stop("No crop chosen or crop not yet included in database")}

   return(suitclass)
}

createTexturedata=function(clay, silt, sand){
  total <- 20
  pb = txtProgressBar(min = 0, max = total, style = 3)
  if(is(clay,"SpatialGridDataFrame")){
    clay=as(clay,"RasterLayer")
    silt=as(silt, "RasterLayer")
    sand=as(sand, "RasterLayer")
    soilc=stack(clay,silt,sand)
    soilp =as(soilc, 'SpatialPixelsDataFrame')
    names(soilp@data) =c('CLAY', 'SILT', 'SAND')
    soilp@data =round(soilp@data, 2)
    soilp@data$raw_totals =rowSums(soilp@data[, 1:3])
    soilp_norm =TT.normalise.sum(tri.data = soilp@data, residuals = T)
    colnames(soilp_norm)[1:3] =paste0(colnames(soilp_norm)[1:3], "_n")
    soilp@data =cbind(soilp@data, round(soilp_norm, 2))
    for(i in 1:10){
      Sys.sleep(0.5)
      setTxtProgressBar(pb, i)}
  }

  else if(is(clay,"RasterLayer")){
    soilc=stack(clay,silt,sand)
    soilp =as(soilc, 'SpatialPixelsDataFrame')
    names(soilp@data) =c('CLAY', 'SILT', 'SAND')
    soilp@data =round(soilp@data, 2)
    soilp@data$raw_totals =rowSums(soilp@data[, 1:3])
    soilp_norm =TT.normalise.sum(tri.data = soilp@data, residuals = T)
    colnames(soilp_norm)[1:3] =paste0(colnames(soilp_norm)[1:3], "_n")
    soilp@data =cbind(soilp@data, round(soilp_norm, 2))

    for(i in 10:total){
      Sys.sleep(0.5)
      setTxtProgressBar(pb, i)}
  }
  else {

    soilp=as.data.frame(cbind(clay,silt,sand))
    names(soilp)=c("CLAY","SILT","SAND")
    soilp=round(soilp,2)
    soilp$raw_totals <- rowSums(soilp[, 1:3])
    SSCP_norm = TT.normalise.sum(tri.data = soilp, residuals = T)
    colnames(SSCP_norm)[1:3] <- paste0(colnames(SSCP_norm)[1:3], "_n")
    soilp = cbind(soilp, round(SSCP_norm, 2))
    for(i in 10:total){
      Sys.sleep(0.5)
      setTxtProgressBar(pb, i)}

  }
  return(soilp)
}

appendTextureclass=function(df, method="USDA"){
  soilp=df
  total <- 20
  pb = txtProgressBar(min = 0, max = total, style = 3)
  switch(method,
         USDA={soilj =cbind(soilp, "TEXCLASS" = TT.points.in.classes(tri.data  = soilp[, c('CLAY_n', 'SILT_n',  'SAND_n')],css.names = c('CLAY_n', 'SILT_n', 'SAND_n'),class.sys = "USDA.TT", PiC.type  = "t",collapse  = ', '))
         },
         European={soilj =cbind(soilp, "TEXCLASS" = TT.points.in.classes(tri.data  = soilp[, c('CLAY_n', 'SILT_n',  'SAND_n')],css.names = c('CLAY_n', 'SILT_n', 'SAND_n'),class.sys = "HYPRES.TT", PiC.type  = "t",collapse  = ', '))
         },
         French={soilj =cbind(soilp, "TEXCLASS" = TT.points.in.classes(tri.data  = soilp[, c('CLAY_n', 'SILT_n',  'SAND_n')],css.names = c('CLAY_n', 'SILT_n', 'SAND_n'),class.sys = "FR.AISNE.TT", PiC.type  = "t",collapse  = ', '))
         },
         German={soilj =cbind(soilp, "TEXCLASS" = TT.points.in.classes(tri.data  = soilp[, c('CLAY_n', 'SILT_n',  'SAND_n')],css.names = c('CLAY_n', 'SILT_n', 'SAND_n'),class.sys = "DE.BK94.TT", PiC.type  = "t",collapse  = ', '))
         },
         UK={soilj =cbind(soilp, "TEXCLASS" = TT.points.in.classes(tri.data  = soilp[, c('CLAY_n', 'SILT_n',  'SAND_n')],css.names = c('CLAY_n', 'SILT_n', 'SAND_n'),class.sys = "UK.SSEW.TT", PiC.type  = "t",collapse  = ', '))
         },
         Australia={soilpj =cbind(soilp, "TEXCLASS" = TT.points.in.classes(tri.data  = soilp[, c('CLAY_n', 'SILT_n',  'SAND_n')],css.names = c('CLAY_n', 'SILT_n', 'SAND_n'),class.sys = "AU2.TT", PiC.type  = "t",collapse  = ', '))
         },
         Belgian = {soilj =cbind(soilp, "TEXCLASS" = TT.points.in.classes(tri.data  = soilp[, c('CLAY_n', 'SILT_n',  'SAND_n')],css.names = c('CLAY_n', 'SILT_n', 'SAND_n'),class.sys = "BE.TT", PiC.type  = "t",collapse  = ', '))
         },
         Canadian ={ soilj =cbind(soilp, "TEXCLASS" = TT.points.in.classes(tri.data  = soilp[, c('CLAY_n', 'SILT_n',  'SAND_n')],css.names = c('CLAY_n', 'SILT_n', 'SAND_n'),class.sys = "CA.ET.TT", PiC.type  = "t",collapse  = ', '))
         },
         FAO = {soilj =cbind(soilp, "TEXCLASS" = TT.points.in.classes(tri.data  = soilp[, c('CLAY_n', 'SILT_n',  'SAND_n')],css.names = c('CLAY_n', 'SILT_n', 'SAND_n'),class.sys = "ISSS.TT", PiC.type  = "t",collapse  = ', '))
         },
         Romania={soilj =cbind(soilp, "TEXCLASS" = TT.points.in.classes(tri.data  = soilp[, c('CLAY_n', 'SILT_n',  'SAND_n')],css.names = c('CLAY_n', 'SILT_n', 'SAND_n'),class.sys = "ROM.TT", PiC.type  = "t",collapse  = ', '))
         },
         Polish = {soilj =cbind(soilp, "TEXCLASS" = TT.points.in.classes(tri.data  = soilp[, c('CLAY_n', 'SILT_n',  'SAND_n')],css.names = c('CLAY_n', 'SILT_n', 'SAND_n'),class.sys = "PL.TT", PiC.type  = "t",collapse  = ', '))
         },
         Brazil = {soilj =cbind(soilp, "TEXCLASS" = TT.points.in.classes(tri.data  = soilp[, c('CLAY_n', 'SILT_n',  'SAND_n')],css.names = c('CLAY_n', 'SILT_n', 'SAND_n'),class.sys = "BRASIL.TT", PiC.type  = "t",collapse  = ', '))
         },
         stop("No texture classification method chosen")
  )
  for(i in 1:total){
    Sys.sleep(0.5)
    setTxtProgressBar(pb, i)
  }
  return(soilj)

}

surveyPoints=function(soilmap,scorpan,conditionclass,mapproportion){
  if(is(soilmap,"RasterLayer")){
  map=soilmap;
  w=scorpan;
  b=conditionclass;
  j=mapproportion
  tagt<-map==b
  area=length(subset(getValues(tagt), getValues(tagt) == 1)) * res(tagt)^2
  w=ifelse(w<1,1,ifelse(w>5,5,w))
  area=area[1]
  samplnum=(j/100)*area*(1/(4*w*res(tagt)))^2
  samplnum=round(samplnum[1],0)
  ndat=sampleRandom(tagt,samplnum, xy=TRUE, sp=TRUE)
  ndat=subset(ndat,ndat$layer>0)}
  else {
    w=scorpan;
    b=conditionclass;
    j=ifelse(mapproportion<0,0,ifelse(mapproportion>100,100,mapproportion))
    tagt<-map==b
    area=length(subset(getValues(tagt), getValues(tagt) == 1)) * res(tagt)^2
    w=ifelse(w<1,1,ifelse(w>5,5,w))
    area=area[1]
    samplnum=(j/100)*area*(1/(4*w*res(tagt)))^2
    samplnum=round(samplnum[1],0)
    ndat=sampleRandom(tagt,samplnum, xy=TRUE, sp=TRUE)
    ndat=subset(ndat,ndat$layer>0)}
    return(ndat)
}

ECharm_Info=function(solution="1:2.5"){
  fromServer2=("https://docs.google.com/spreadsheets/d/e/2PACX-1vTRcGLaM3PyMDB0abd8r1VE0OW6TWQ5QzrINjW00oiwS_SYBXM2RIJhqw9hnAeP9ePATdix7HyDjgda/pub?output=csv")
  fromServer2.5=("https://docs.google.com/spreadsheets/d/e/2PACX-1vRs69jpFKSO-t-iCJAL_5Y76H6N1s39XXBQcgTDx9cZ6N0chf1fI13FkxiaQYLX2n-34wEqOQSTTTTb/pub?output=csv")
  fromServer5=("https://docs.google.com/spreadsheets/d/e/2PACX-1vQBDSv0JeMNwIevV4BgnhKCrsSG_EcseHxPxGCNAgMSAN1ikMg88mb7r05KCP7HEopna-J1Jkb3BjNO/pub?output=csv")

  # Illustrate predictive performance
  plotf=function(x){
    inputInfo = read.csv(x)
    df1=as.matrix(inputInfo[,2:ncol(inputInfo)])
    row.names(df1)=c("Africa","N.America","Asia","Europe","LAC","NENA","Pacific")
    regioncol=c("blue","red","cyan","magenta","green","gray", "yellow")
    par(mgp=c(3,0.6,0),mar=c(5,4.5,1,1)+0.1)
    barplot(df1, las=2,beside = TRUE,xpd = FALSE,col=regioncol,ylim=c(0,1.2),horiz = FALSE, cex.names = 0.75,space = c(0.4, 4))
    grid (nx=NA, ny=NULL, lty = 6, col = "gray")
    legend("topleft", x.intersp=0.25,y.intersp=0,bg="transparent",text.width=11,legend = rownames(df1), fill = regioncol, box.lty = 0, cex = 0.6, horiz = TRUE)
    box(lty = 1, col = 'black')
    mtext(side=1, text="EC harmonization models", line=3.7)
    mtext(side=2, text="Performance index", line=2.5)
  }
  # Check internet
  get_info=function(x){
    if(is.null(checkInternet(x))){
      #stop("Stoping execution",.Call=FALSE)
      withr::with_options(
        list(show.error.messages = FALSE),
        {
          print("Internet connectivity to server is needed")
          stop(x)
        }
      )
    }
    plotf(x)
  }
  if(solution=="1:2"){
    get_info(fromServer2)
  }
  else if(solution == "1:2.5"){
    get_info(fromServer2.5)
  }
  else if(solution == "1:5"){
    get_info(fromServer5)
  }
}

regmodelSuit=function(df, ...){
  total <- 20
  pb = txtProgressBar(min = 0, max = total, style = 3)

  dv=as.character(sapply(substitute(list(...))[-1], deparse))
  fml <- as.formula(paste(dv[1],paste((dv[2:length(dv)]),collapse="+"),sep="~"))
  names(fml)<-sub(".*\\$", "",names(fml))
  dat=data.frame(df)
  (na.cols=function(x){
    y <- sapply(x, function(xx)any(is.na(xx)))
    names(y[y])
  })
  if(any(is.na(dat))){stop(paste("Remove NA in columns: ", paste(na.cols(dat), collapse=", ")))}
  for(i in 1:5){
    Sys.sleep(0.5)
    setTxtProgressBar(pb, i)}
  LM= train(fml,  data = dat,  method = "lm", trControl=trainControl( method = "cv",number=5,savePredictions = TRUE, verboseIter = FALSE))
  RF= train(fml,  data = dat,  method = "rf", trControl=trainControl( method = "cv",number=5,savePredictions = TRUE, verboseIter = FALSE))
  SVM= train(fml,  data = dat,  method = "svmLinear", trControl=trainControl( method = "cv",number=5,savePredictions = TRUE, verboseIter = FALSE))
  BGLM= train(fml,  data = dat,  method = "bayesglm", trControl=trainControl( method = "cv",number=5,savePredictions = TRUE, verboseIter = FALSE))
  CARTB= train(fml,  data = dat,  method = "treebag", trControl=trainControl( method = "cv",number=5,savePredictions = TRUE, verboseIter = FALSE))
  CUB= train(fml,  data = dat,  method = "cubist",trControl=trainControl( method = "cv",number=5,returnResamp = "all",savePredictions = TRUE, search = "random",verboseIter = FALSE))
  CART= train(fml,  data = dat,  method = "rpart", trControl=trainControl( method = "cv",number=5,savePredictions = TRUE, verboseIter = FALSE))
  RANGE= train(fml,  data = dat,  method = "ranger", trControl=trainControl( method = "cv",number=5,savePredictions = TRUE, verboseIter = FALSE))
  QRF= train(fml,  data = dat,  method = "qrf", trControl=trainControl( method = "cv",number=5,savePredictions = TRUE, verboseIter = FALSE))
  QRNN= train(fml,  data = dat,  method = "qrnn", trControl=trainControl( method = "cv",number=5,savePredictions = TRUE, verboseIter = FALSE))
  for(i in 5:10){
    Sys.sleep(0.5)
    setTxtProgressBar(pb, i)}

  { LM_MAE=mean(LM$results$MAE)
    RF_MAE=mean(RF$results$MAE)
    SVM_MAE=mean(SVM$results$MAE)
    BGLM_MAE=mean(BGLM$results$MAE)
    CARTB_MAE=mean(CARTB$results$MAE)
    CUB_MAE=mean(CUB$results$MAE)
    CART_MAE=mean(CART$results$MAE)
    RAN_MAE=mean(RANGE$results$MAE)
    QRF_MAE=mean(QRF$results$MAE)
    QRNN_MAE=mean(QRNN$results$MAE)

    LM_RMSE=mean(LM$results$RMSE)
    RF_RMSE=mean(RF$results$RMSE)
    SVM_RMSE=mean(SVM$results$RMSE)
    BGLM_RMSE=mean(BGLM$results$RMSE)
    CARTB_RMSE=mean(CARTB$results$RMSE)
    CUB_RMSE=mean(CUB$results$RMSE)
    CART_RMSE=mean(CART$results$RMSE)
    RAN_RMSE=mean(RANGE$results$RMSE)
    QRF_RMSE=mean(QRF$results$RMSE)
    QRNN_RMSE=mean(QRNN$results$RMSE)

    LM_Rsquared=mean(LM$results$Rsquared)
    RF_Rsquared=mean(RF$results$Rsquared)
    SVM_Rsquared=mean(SVM$results$Rsquared)
    BGLM_Rsquared=mean(BGLM$results$Rsquared)
    CARTB_Rsquared=mean(CARTB$results$Rsquared)
    CUB_Rsquared=mean(CUB$results$Rsquared)
    CART_Rsquared=mean(CART$results$Rsquared)
    RAN_Rsquared=mean(RANGE$results$Rsquared)
    QRF_Rsquared=mean(QRF$results$Rsquared)
    QRNN_Rsquared=mean(QRNN$results$Rsquared)}
  for(i in 10:12){
    Sys.sleep(0.5)
    setTxtProgressBar(pb, i)}
  drt=data.frame(dat[1],fitted(LM),fitted(RF),predict(SVM),fitted(BGLM),fitted(CARTB),fitted(CUB),fitted(CART),fitted(RANGE),fitted(QRF),fitted(QRNN))#
  colnames(drt)=c("measured","LM","RF","SVM","BGLM","CARTB","CUB","CART","RANGE","QRF","QRNN")
  SSE_LM=1-sum((drt$LM-drt$measured)^2,na.rm=TRUE)/sum((drt$LM-mean(drt$measured,na.rm=TRUE))^2,na.rm=TRUE)
  SSE_RF=1-sum((drt$RF-drt$measured)^2,na.rm=TRUE)/sum((drt$RF-mean(drt$measured,na.rm=TRUE))^2,na.rm=TRUE)
  SSE_SVM=1-sum((drt$SVM-drt$measured)^2,na.rm=TRUE)/sum((drt$SVM-mean(drt$measured,na.rm=TRUE))^2,na.rm=TRUE)
  SSE_BGLM=1-sum((drt$BGLM-drt$measured)^2,na.rm=TRUE)/sum((drt$BGLM-mean(drt$measured,na.rm=TRUE))^2,na.rm=TRUE)
  SSE_CARTB=1-sum((drt$CARTB-drt$measured)^2,na.rm=TRUE)/sum((drt$CARTB-mean(drt$measured,na.rm=TRUE))^2,na.rm=TRUE)
  SSE_CUB=1-sum((drt$CUB-drt$measured)^2,na.rm=TRUE)/sum((drt$CUB-mean(drt$measured,na.rm=TRUE))^2,na.rm=TRUE)
  SSE_CART=1-sum((drt$CART-drt$measured)^2,na.rm=TRUE)/sum((drt$CART-mean(drt$measured,na.rm=TRUE))^2,na.rm=TRUE)
  SSE_RAN=1-sum((drt$RANGE-drt$measured)^2,na.rm=TRUE)/sum((drt$RANGE-mean(drt$measured,na.rm=TRUE))^2,na.rm=TRUE)
  SSE_QRF=1-sum((drt$QRF-drt$measured)^2,na.rm=TRUE)/sum((drt$QRF-mean(drt$measured,na.rm=TRUE))^2,na.rm=TRUE)
  SSE_QRNN=1-sum((drt$QRNN-drt$measured)^2,na.rm=TRUE)/sum((drt$QRNN-mean(drt$measured,na.rm=TRUE))^2,na.rm=TRUE)

  for(i in 12:15){
    Sys.sleep(0.5)
    setTxtProgressBar(pb, i)}

  twy=matrix(c(LM_MAE,RF_MAE,SVM_MAE,BGLM_MAE,CARTB_MAE,CUB_MAE,CART_MAE,RAN_MAE,QRF_MAE,QRNN_MAE,
               LM_RMSE,RF_RMSE,SVM_RMSE,BGLM_RMSE,CARTB_RMSE,CUB_RMSE,CART_RMSE,RAN_RMSE,QRF_RMSE,QRNN_RMSE,
               LM_Rsquared,RF_Rsquared,SVM_Rsquared,BGLM_Rsquared,CARTB_Rsquared,CUB_Rsquared,CART_Rsquared,RAN_Rsquared,QRF_Rsquared,QRNN_Rsquared,
               SSE_LM,SSE_RF,SSE_SVM,SSE_BGLM,SSE_CARTB,SSE_CUB,SSE_CART,SSE_RAN,SSE_QRF,SSE_QRNN),nrow=10,ncol = 4,byrow = FALSE)
  colnames(twy)=c("ME","RMSE","R2","NSE")
  rownames(twy)=c("Linear","RandomForest","SVM","BayesianGLM","BaggedCART","Cubist","CART","Ranger","QuantRandForest","QuantNeuralNT")

  for(i in 15:total){
    Sys.sleep(0.5)
    setTxtProgressBar(pb, i)}
  return(twy)

}

ME_PHharm=function(ph,TEXCLASS, model="polynomial", phtype="cacl2"){
  TEXCLASS2=ifelse(TEXCLASS=="Cl",1,ifelse(TEXCLASS=="ClLo",7,ifelse(TEXCLASS=="Lo",11, ifelse(TEXCLASS=="LoSa",10,
                                                                                               ifelse(TEXCLASS=="Sa",12,ifelse(TEXCLASS=="SaCl",8,ifelse(TEXCLASS=="SaClLo",9,
                                                                                                                                                         ifelse(TEXCLASS=="SaLo",5,ifelse(TEXCLASS=="SiCl",2,ifelse(TEXCLASS=="SiClLo",3,
                                                                                                                                                                                                                    ifelse(TEXCLASS=="SiLo",4,ifelse(TEXCLASS=="Si",6,ifelse(TEXCLASS=="CS",13,
                                                                                                                                                                                                                                                                             ifelse(TEXCLASS=="MS",14,ifelse(TEXCLASS=="HCl",16,ifelse(TEXCLASS=="FS",15,0))))))))))))))))

  if(phtype=="cacl2"){
    dfm=data.frame(PHCA=c(ph),TEXCLASS1=c(TEXCLASS2))
    if(model=="polynomial"){PHharm=predict(ME_PHharmserve[[1]],dfm)}
    else if(model=="sigmoid"){PHharm=predict(ME_PHharmserve[[2]],dfm)}
    else if(model=="spherical"){PHharm=predict(ME_PHharmserve[[3]],dfm)}
    else if(model=="gaussian"){PHharm=predict(ME_PHharmserve[[4]],dfm)}
    else if(model=="exponential"){PHharm=predict(ME_PHharmserve[[5]],dfm)}
    else if(model=="power"){PHharm=predict(ME_PHharmserve[[6]],dfm)}
    else if(model=="linear"){PHharm=predict(ME_PHharmserve[[7]],dfm)}
  }
  else if(phtype=="kcl"){
    dfm=data.frame(PHKC=c(ph),TEXCLASS1=c(TEXCLASS2))
    if(model=="polynomial"){PHharm=predict(ME_PHharmserve[[8]],dfm)}
    else if(model=="sigmoid"){PHharm=predict(ME_PHharmserve[[9]],dfm)}
    else if(model=="spherical"){PHharm=predict(ME_PHharmserve[[10]],dfm)}
    else if(model=="gaussian"){PHharm=predict(ME_PHharmserve[[11]],dfm)}
    else if(model=="exponential"){PHharm=predict(ME_PHharmserve[[12]],dfm)}
    else if(model=="power"){PHharm=predict(ME_PHharmserve[[13]],dfm)}
    else if(model=="linear"){PHharm=predict(ME_PHharmserve[[14]],dfm)}
  }
  PHharm=ifelse(PHharm<1,"NA",ifelse(PHharm>14,"NA",PHharm))
  return(PHharm)
}

suitability=function(df,data){
  total <- 20
  amtx = pairwiseComparisonMatrix(df)
  wts = calculateWeights(amtx)
  for(i in 1:10){
    Sys.sleep(0.5)
    setTxtProgressBar((txtProgressBar(min = 0, max = total, style = 3)), i)
  }
  outdat=calculateAHP(wts, data)

  for(i in 10:total){
    Sys.sleep(0.5)
    setTxtProgressBar((txtProgressBar(min = 0, max = total, style = 3)), i)
  }
  return(outdat)
}

NPPmodel=function(rain,temperature,model="miami"){
  if(model=="miami"){
  npprain=3000*(1-exp(-0.000664*rain))
  npptemp=3000/(1+exp(1.315-0.119*temperature))
  npp=min(npprain,npptemp)}
  else if(model=="schuur"){
    npprain=(0.005215*(rain)^1.12363)/exp(0.000459532*rain)
    npptemp=17.6243/(1+exp(1.3496-0.071514*temperature))
    npp=min(npprain,npptemp)*200
  }
  else if(model=="NCEAS"){
    npprain=(0.551*(rain)^1.055)/exp(0.000306*rain)
    npptemp=2540/(1+exp(1.584-0.0622*temperature))
    npp=min(npprain,npptemp)*2
  }
  return(npp)
}

RotCmoistcorrection=function(P, E, S.Thick, clay, pE, fk)
{
  MTSMD = -(20 + 1.3 * clay - 0.01 * (clay^2)) * (S.Thick/23) *(1/fk)
  Moistdeficit = P - E * pE
  ATSMD = 0
  for (i in 2:length(Moistdeficit)) {
    ATSMD[1] = ifelse(Moistdeficit[1] > 0, 0, Moistdeficit[1])
    if (ATSMD[i - 1] + Moistdeficit[i] < 0) {
      ATSMD[i] = ATSMD[i - 1] + Moistdeficit[i]
    }
    else (ATSMD[i] = 0)
    if (ATSMD[i] <= MTSMD) {
      ATSMD[i] = MTSMD
    }
  }
  b = ifelse(ATSMD > 0.444 * MTSMD, 1, (0.2 + (1-0.2) * ((MTSMD - ATSMD)/(MTSMD - 0.444 * MTSMD))))
  return(b)
}

ECconversion2=function(ec, method="USDA", extract="1:1"){

  if(method=="landon"){
    if(extract=="1:1"){ElectConduct=harmonization(ec,2.2,0)}
    else if(extract=="1:5"){ElectConduct=harmonization(ec,6.4,0)}
    else if(extract=="1:3"){ElectConduct=harmonization(ec,3.81,0)}
  }
  else if(method=="kargas"){
    if(extract=="1:1"){ElectConduct=harmonization(ec,1.83,0.117)}
    else if(extract=="1:5"){ElectConduct=harmonization(ec,6.53,-0.108)}
  }
  else if(method=="ozkan"){
    if(extract=="1:1"){ElectConduct=harmonization(ec,1.93,-0.57)}
    else if(extract=="1:2.5"){ElectConduct=harmonization(ec,3.3,-0.2)}
    else if(extract=="1:5"){ElectConduct=harmonization(ec,5.97,-1.17)}
  }
  else if(method=="USDA") {
    if(extract=="1:1"){ElectConduct=harmonization(ec,3,0)}
    else if(extract=="1:5"){ElectConduct=harmonization(ec,4.5,0)}
    else if(extract=="1:2"){ElectConduct=harmonization(ec,5,0)}
  }
  else if(method=="hogg") {
    if(extract=="1:1"){ElectConduct=harmonization(ec,1.75,-0.37)}
    else if(extract=="1:2"){ElectConduct=harmonization(ec,1.38,-0.14)}
  }
  else if(method=="zhang") {
    if(extract=="1:1"){ElectConduct=harmonization(ec,1.79,1.46)}
  }
  else if(method=="chi") {
    if(extract=="1:5"){ElectConduct=harmonization(ec,11.68,-5.77)}
  }
  else if(method=="park") {
    if(extract=="1:5"){ElectConduct=harmonization(ec,8.7,0)}
  }
  else if(method=="viscounti") {
    if(extract=="1:5"){ElectConduct=harmonization(ec,6.53,-0.108)}
  }
  else if(method=="khorsandi") {
    if(extract=="1:5"){ElectConduct=harmonization(ec,5.4,-0.61)}
  }
  else if(method=="shahid") {
    if(extract=="1:2.5"){ElectConduct=harmonization(ec,4.77,0)}
  }
  else if(method=="klaustermeier") {
    if(extract=="1:5"){ElectConduct=10^(1.256*log10(ec) +0.766)}
  }
  else if(method=="he") {
    if(extract=="1:5"){ElectConduct=exp(0.7*log(ec)+1.78)}
  }
  else if(method=="aboukila") {
    if(extract=="1:5"){ElectConduct=harmonization(ec,11.74,-6.15)}
  }
  else if(method=="halder") {
    if(extract=="1:5"){ElectConduct=harmonization(ec,4.834,0.437)}
  }

  return(ElectConduct)
}

drainageSuit=function(value,crop="wheat"){
  #drainage suitability rating for cereals
  if(crop=="wheat"){suitclass=ifelse(value==1,4,ifelse(value==7,4,ifelse(value==2,3,ifelse(value==3,2,1))))}
  else if(crop=="maize"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,ifelse(value==7,3,2))))}
  else if(crop=="rice"){suitclass=ifelse(value==3,1,ifelse(value==4,2,ifelse(value==7,4,3)))}
  else if(crop=="sorghum"){suitclass=ifelse(value==1,4,ifelse(value==3,2,ifelse(value==2,3,ifelse(value==7,3,1))))}
  else if(crop=="millet"){suitclass=ifelse(value==1,4,ifelse(value==3,2,ifelse(value==2,3,ifelse(value==7,3,1))))}
  else if(crop=="oat"){suitclass=ifelse(value==1,4,ifelse(value==5,1,ifelse(value==2,3,ifelse(value==7,3,2))))}
  else if(crop=="barley"){suitclass=ifelse(value==1,4,ifelse(value==5,1,ifelse(value==2,3,ifelse(value==7,3,1))))}

  #drainage suitability for legumes
  else if(crop=="bean"){suitclass=ifelse(value==1,4,ifelse(value==2,3,ifelse(value==3,2,1)))}
  else if(crop=="pea"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,ifelse(value==7,3,2))))}
  else if(crop=="gram"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,ifelse(value==7,3,2))))}
  else if(crop=="groundnut"){suitclass=ifelse(value==5,1,ifelse(value==2,4,ifelse(value==3,3,2)))}
  else if(crop=="soybean"){suitclass=ifelse(value==5,1,ifelse(value==2,4,ifelse(value==3,3,2)))}
  else if(crop=="lentil"){suitclass=ifelse(value==5,1,ifelse(value==2,4,ifelse(value==3,3,2)))}

    #drainage suitability for Forests
  else if(crop=="poplar"){suitclass=ifelse(value==1,4,ifelse(value==2,3,ifelse(value==3,2,1)))}
  else if(crop=="grevillea"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,ifelse(value==7,3,2))))}
  else if(crop=="sesbania"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,ifelse(value==7,3,2))))}
  else if(crop=="calliandra"){suitclass=ifelse(value==5,1,ifelse(value==2,4,ifelse(value==3,3,2)))}
  else if(crop=="leucaena"){suitclass=ifelse(value==5,1,ifelse(value==2,4,ifelse(value==3,3,2)))}
  else if(crop=="acacia"){suitclass=ifelse(value==5,1,ifelse(value==2,4,ifelse(value==3,3,2)))}
  else if(crop=="eucalyptus"){suitclass=ifelse(value==5,1,ifelse(value==2,4,ifelse(value==3,3,2)))}
  else if(crop=="teak"){suitclass=ifelse(value==5,1,ifelse(value==2,4,ifelse(value==3,3,2)))}
  else if(crop=="maple"){suitclass=ifelse(value==5,1,ifelse(value==2,4,ifelse(value==3,3,2)))}
  else if(crop=="ash"){suitclass=ifelse(value==5,1,ifelse(value==2,4,ifelse(value==3,3,2)))}
  
  #drainage suitability for oilcrops
  else if(crop=="sesame"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==4,2,3)))}
  else if(crop=="sunflower"){suitclass=ifelse(value==5,1,ifelse(value==2,4,ifelse(value==3,3,2)))}
  else if(crop=="castor"){suitclass=ifelse(value==5,1,ifelse(value==2,4,ifelse(value==3,3,2)))}
  else if(crop=="oilpalm"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if(crop=="safflower"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if(crop=="mustard"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if(crop=="rapeseed"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if(crop=="olive"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}

  #drainage suitability for industrial crops
  else if (crop=="cotton"){suitclass=ifelse(value==5,1,ifelse(value==4,1,ifelse(value==3,2,ifelse(value==2,3,ifelse(value==6,3,4)))))}
  else if (crop=="sugarcane"){suitclass=ifelse(value==5,1,ifelse(value==2,3,ifelse(value==4,2,ifelse(value==3,2,4))))}
  else if (crop=="tea"){suitclass=ifelse(value==5,1,ifelse(value==2,3,ifelse(value==4,2,ifelse(value==3,2,4))))}
  else if (crop=="coffee"){suitclass=ifelse(value==5,1,ifelse(value==2,3,ifelse(value==4,2,ifelse(value==3,3,4))))}
  else if (crop=="rubber"){suitclass=ifelse(value==5,1,ifelse(value==3,3,ifelse(value==1,4,ifelse(value==7,4,2))))}
  else if (crop=="saffron"){suitclass=ifelse(value==5,1,ifelse(value==2,3,ifelse(value==4,2,ifelse(value==3,2,4))))}
  else if (crop=="tobacco"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,ifelse(value==3,2,2))))}
  else if (crop=="pyrethrum"){suitclass=ifelse(value==5,1,ifelse(value==6,2,ifelse(value==7,3,4)))}
  else if (crop=="jute"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,ifelse(value==4,2,2))))}

  #drainage suitability for fruits
  else if (crop=="mango"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="citrus"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="grape"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="pomegranate"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="pineaple"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="banana"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="avocado"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="watermelon"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="melon"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="pawpaw"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}

  #drainage suitability for nuts
  else if (crop=="cashew"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="pistachio"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="almond"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="coconut"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}

  #drainage suitability rating for tubers
  else if (crop=="potato"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="sweetpotato"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="cassava"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="carrot"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="turnip"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="radish"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}

  #drainage suitability rating for vegetables
  else if (crop=="tomato"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="cabbage"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="vegetable"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="cauliflower"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="broccoli"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="okra"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}

  #drainage suitability rating for spices
  else if (crop=="chilli"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="pepper"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="tumeric"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="onion"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="vanilla"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="lemongrass"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="ginger"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="cardamom"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}

  #drainage suitability rating for other
  else if (crop=="alfalfa"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="rose"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="jasmine"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}

  #drainage suitability rating for fleshy
  else if (crop=="yam"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="butternut"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="squash"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}
  else if (crop=="pumpkin"){suitclass=ifelse(value==5,1,ifelse(value==1,4,ifelse(value==2,3,2)))}

  return(suitclass)
}

SASdata_densityInfo=function(data="ec"){
  drive_deauth()
  temp <- tempfile(fileext = ".zip")
  if(data=="ec"){
  patch <- drive_download(
    as_id("1AndDSIl5ZIvCXNu2B_EkBxbffCUAg6m_"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
  }
  else if(data=="ph"){
    patch <- drive_download(
      as_id("13OQFLxb4SiH7Fc2Fbqwtjg0j8TldlRdr"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
  }
    else if(data=="texture"){
       patch <- drive_download(
        as_id("1a2yhsGnoPRLEda0E7hVKSip9Z3eSdChW"), path = temp, overwrite = TRUE, options(googledrive_quiet = TRUE))
     }
  out <- unzip(temp, exdir = tempdir())
  img=readPNG(out)
  grid::grid.raster(img)
}

classLUT=function(fgrid, indicator="salinity"){
  total <- 20
  if(indicator=="saltseverity"){

    fgrid@data$value=as.character(fgrid@data[,1])
    fgrid@data$mapvalue=as.factor(fgrid@data$value)
    fgrid@data$classcode=as.numeric(fgrid@data[,1])
    for(i in 1:12){
      Sys.sleep(0.5)
      setTxtProgressBar(txtProgressBar(min = 0, max = total, style = 3), i)
    }
    LUT = data.frame(unique(fgrid@data[, c('classcode', 'mapvalue')]))

    for(i in 12:total){
      Sys.sleep(0.5)
      setTxtProgressBar((txtProgressBar(min = 0, max = total, style = 3)), i)
    }

  }
  else if(indicator=="texture"){

    fgrid@data$value=as.character(fgrid@data[,1])
    fgrid@data$mapvalue=as.factor(fgrid@data$value)
    fgrid@data$classcode=as.numeric(fgrid@data[,1])
    for(i in 1:12){
      Sys.sleep(0.5)
      setTxtProgressBar((txtProgressBar(min = 0, max = total, style = 3)), i)
    }
    LUT = data.frame(unique(fgrid@data[, c('classcode', 'mapvalue')]))

    for(i in 12:total){
      Sys.sleep(0.5)
      setTxtProgressBar((txtProgressBar(min = 0, max = total, style = 3)), i)
    }

  }
  else if(indicator=="suitability"){

    fgrid@data$value=as.character(fgrid@data[,1])
    fgrid@data$mapvalue=as.factor(fgrid@data$value)
    fgrid@data$classcode=as.numeric(fgrid@data[,1])
    for(i in 1:12){
      Sys.sleep(0.5)
      setTxtProgressBar((txtProgressBar(min = 0, max = total, style = 3)), i)
    }
    LUT = data.frame(unique(fgrid@data[, c('classcode', 'mapvalue')]))

    for(i in 12:total){
      Sys.sleep(0.5)
      setTxtProgressBar((txtProgressBar(min = 0, max = total, style = 3)), i)
    }

  }
  else if(indicator=="fertility"){

    fgrid@data$value=as.character(fgrid@data[,1])
    fgrid@data$mapvalue=as.factor(fgrid@data$value)
    fgrid@data$classcode=as.numeric(fgrid@data[,1])
    for(i in 1:12){
      Sys.sleep(0.5)
      setTxtProgressBar((txtProgressBar(min = 0, max = total, style = 3)), i)
    }
    LUT = data.frame(unique(fgrid@data[, c('classcode', 'mapvalue')]))

    for(i in 12:total){
      Sys.sleep(0.5)
      setTxtProgressBar((txtProgressBar(min = 0, max = total, style = 3)), i)
    }

  }
  else if(indicator=="drainage"){

    fgrid@data$value=as.character(fgrid@data[,1])
    fgrid@data$mapvalue=as.factor(fgrid@data$value)
    fgrid@data$classcode=as.numeric(fgrid@data[,1])
    for(i in 1:12){
      Sys.sleep(0.5)
      setTxtProgressBar((txtProgressBar(min = 0, max = total, style = 3)), i)
    }
    LUT = data.frame(unique(fgrid@data[, c('classcode', 'mapvalue')]))

    for(i in 12:total){
      Sys.sleep(0.5)
      setTxtProgressBar((txtProgressBar(min = 0, max = total, style = 3)), i)
    }

  }
  else if(indicator=="erodibility"){

    fgrid@data$value=as.character(fgrid@data[,1])
    fgrid@data$mapvalue=as.factor(fgrid@data$value)
    fgrid@data$classcode=as.numeric(fgrid@data[,1])
    for(i in 1:12){
      Sys.sleep(0.5)
      setTxtProgressBar((txtProgressBar(min = 0, max = total, style = 3)), i)
    }
    LUT = data.frame(unique(fgrid@data[, c('classcode', 'mapvalue')]))

    for(i in 12:total){
      Sys.sleep(0.5)
      setTxtProgressBar((txtProgressBar(min = 0, max = total, style = 3)), i)
    }

  }
  return(LUT)
}

rainSuit=function(value,crop="wheat"){
  #rainfed crop suitability requirements for cereals
  if(crop=="wheat"){suitclass=ifelse(value>1200,4,ifelse(value>1000,3,ifelse(value>950,2,ifelse(value>500,1,ifelse(value>350,2,ifelse(value>250,3,4))))))}#rainfed wheat
  else if(crop=="rice"){suitclass=ifelse(value>1250,1,ifelse(value>900,2,ifelse(value>750,3,4)))}
  else if(crop=="sorghum"){suitclass=ifelse(value>650,1,ifelse(value>550,2,ifelse(value>450,3,4)))}
  else if(crop=="maize"){suitclass=ifelse(value>1800,4,ifelse(value>1600,3,ifelse(value>1250,2,ifelse(value>850,1,ifelse(value>650,2,ifelse(value>500,3,4))))))}
  else if(crop=="barley"){suitclass=ifelse(value>1250,4,ifelse(value>1000,3,ifelse(value>750,2,ifelse(value>400,1,ifelse(value>300,2,ifelse(value>200,3,4))))))}
  else if(crop=="oat"){suitclass=ifelse(value>1250,4,ifelse(value>1000,3,ifelse(value>750,2,ifelse(value>450,1,ifelse(value>350,2,ifelse(value>280,3,4))))))}
  else if(crop=="millet"){suitclass=ifelse(value>750,1,ifelse(value>600,2,ifelse(value>450,3,4)))}

  #rainfed crop suitability requirements for legumes
  else if(crop=="groundnut"){suitclass=ifelse(value>1000,4,ifelse(value>700,1,ifelse(value>500,2,ifelse(value>350,3,4))))}
  else if(crop=="gram"){suitclass=ifelse(value>1250,3,ifelse(value>800,1,ifelse(value>600,2,ifelse(value>400,3,4))))}
  else if(crop=="pea"){suitclass=ifelse(value>1250,3,ifelse(value>800,1,ifelse(value>600,2,ifelse(value>400,3,4))))}
  else if(crop=="bean"){suitclass=ifelse(value>1000,4,ifelse(value>900,3,ifelse(value>750,1,ifelse(value>600,2,ifelse(value>500,3,4)))))}
  else if(crop=="soybean"){suitclass=ifelse(value>1900,4,ifelse(value>1600,3,ifelse(value>1100,2,ifelse(value>600,1,ifelse(value>350,2,ifelse(value>250,3,4))))))}
  else if(crop=="lentil"){suitclass=ifelse(value>1000,4,ifelse(value>800,3,ifelse(value>700,2,ifelse(value>450,1,ifelse(value>350,2,ifelse(value>300,3,4))))))}

  #rainfed crop suitability requirements for forests
  else if(crop=="poplar"){suitclass=ifelse(value>1500,1,ifelse(value>1000,2,ifelse(value>700,3,4)))}
  else if(crop=="grevillea"){suitclass=ifelse(value>1250,1,ifelse(value>800,2,ifelse(value>600,3,4)))}
  else if(crop=="sesbania"){suitclass=ifelse(value>1250,1,ifelse(value>800,2,ifelse(value>600,3,ifelse(value>400,3,4))))}
  else if(crop=="calliandra"){suitclass=ifelse(value>1300,1,ifelse(value>1000,2,ifelse(value>750,3,4)))}
  else if(crop=="leucaena"){suitclass=ifelse(value>1000,1,ifelse(value>900,2,ifelse(value>600,3,4)))}
  else if(crop=="acacia"){suitclass=ifelse(value>1200,1,ifelse(value>600,2,ifelse(value>400,3,4)))}
  else if(crop=="eucalyptus"){suitclass=ifelse(value>1500,1,ifelse(value>1200,2,ifelse(value>900,3,4)))}
  else if(crop=="teak"){suitclass=ifelse(value>1800,1,ifelse(value>1200,2,ifelse(value>1000,3,4)))}
  else if(crop=="maple"){suitclass=ifelse(value>1400,1,ifelse(value>1100,2,ifelse(value>900,3,4)))}
  else if(crop=="ash"){suitclass=ifelse(value>1400,1,ifelse(value>1100,2,ifelse(value>900,3,4)))}
  
  #rainfed crop suitability requirements for oil crops
  if(crop=="sesame"){suitclass=ifelse(value>600,3,ifelse(value>500,1,ifelse(value>400,2,ifelse(value>300,3,4))))}
  else if(crop=="sunflower"){suitclass=ifelse(value>700,3,ifelse(value>600,1,ifelse(value>500,2,ifelse(value>400,3,4))))}
  else if(crop=="oilpalm"){suitclass=ifelse(value>2000,1,ifelse(value>1500,2,ifelse(value>1000,3,4)))}
  else if(crop=="castor"){suitclass=ifelse(value>800,3,ifelse(value>600,1,ifelse(value>400,2,ifelse(value>250,3,4))))}
  else if(crop=="safflower"){suitclass=ifelse(value>1000,3,ifelse(value>600,1,ifelse(value>400,2,ifelse(value>300,3,4))))}
  else if(crop=="rapeseed"){suitclass=ifelse(value>1000,3,ifelse(value>650,1,ifelse(value>500,2,ifelse(value>400,3,4))))}
  else if(crop=="mustard"){suitclass=ifelse(value>1000,3,ifelse(value>650,1,ifelse(value>500,2,ifelse(value>350,3,4))))}
  else if(crop=="olive"){suitclass=ifelse(value>1000,3,ifelse(value>600,1,ifelse(value>450,2,ifelse(value>350,3,4))))}

  #rainfed crop suitability requirements for nuts
  else if(crop=="coconut"){suitclass=ifelse(value>800,3,ifelse(value>600,1,ifelse(value>400,2,ifelse(value>250,3,4))))}
  else if(crop=="cashew"){suitclass=ifelse(value>2000,1,ifelse(value>1000,2,ifelse(value>500,3,4)))}
  else if(crop=="almond"){suitclass=ifelse(value>900,1,ifelse(value>600,2,ifelse(value>250,3,4)))}
  else if(crop=="pistachio"){suitclass=ifelse(value>700,1,ifelse(value>400,2,ifelse(value>250,3,4)))}

  #rainfed crop suitability requirements for fibre/industrial
  else if(crop=="cotton"){suitclass=ifelse(value>1200,3,ifelse(value>1000,2,ifelse(value>700,1,ifelse(value>500,2,4))))}
  else if(crop=="sugarcane"){suitclass=ifelse(value>1600,1,ifelse(value>1200,2,ifelse(value>900,3,4)))}
  else if(crop=="saffron"){suitclass=ifelse(value>300,1,ifelse(value>250,2,ifelse(value>200,3,4)))}
  else if(crop=="tea"){suitclass=ifelse(value>1800,1,ifelse(value>1600,2,ifelse(value>1000,3,4)))}
  else if(crop=="coffee"){suitclass=ifelse(value>1150,1,ifelse(value>1000,2,ifelse(value>800,3,4)))}
  else if(crop=="pyrethrum"){suitclass=ifelse(value>1600,4,ifelse(value>1400,3,ifelse(value>1200,2,ifelse(value>1100,1,ifelse(value>1000,2,ifelse(value>950,3,4))))))}
  else if(crop=="rubber"){suitclass=ifelse(value>6000,4,ifelse(value>3000,3,ifelse(value>1750,1,ifelse(value>1500,2,ifelse(value>1250,3,4)))))}
  else if(crop=="jute"){suitclass=ifelse(value>1500,1,ifelse(value>1000,2,ifelse(value>850,3,4)))}
  else if(crop=="tobacco"){suitclass=ifelse(value>1400,3,ifelse(value>1200,2,ifelse(value>850,1,ifelse(value>600,2,ifelse(value>400,3,4)))))}

  #rainfed crop suitability requirements for tuber
  else if(crop=="sweetpotato"){suitclass=ifelse(value>1300,1,ifelse(value>800,1,ifelse(value>500,3,4)))}
  else if(crop=="cassava"){suitclass=ifelse(value>900,1,ifelse(value>700,2,ifelse(value>500,3,4)))}
  else if(crop=="potato"){suitclass=ifelse(value>1300,1,ifelse(value>800,2,ifelse(value>500,3,4)))}
  else if(crop=="carrot"){suitclass=ifelse(value>1200,4,ifelse(value>600,3,ifelse(value>400,3,ifelse(value>350,2,ifelse(value>250,3,4)))))}
  else if(crop=="turnip"){suitclass=ifelse(value>1000,1,ifelse(value>800,2,ifelse(value>650,3,4)))}
  else if(crop=="radish"){suitclass=ifelse(value>1200,1,ifelse(value>900,2,ifelse(value>800,3,4)))}

  #rainfed crop suitability requirements for fruits
  else if(crop=="mango"){suitclass=ifelse(value>1000,1,ifelse(value>500,2,ifelse(value>250,3,4)))}
  else if(crop=="grape"){suitclass=ifelse(value>900,3,ifelse(value>600,1,ifelse(value>400,2,ifelse(value>250,3,4))))}
  else if(crop=="citrus"){suitclass=ifelse(value>1200,1,ifelse(value>1000,2,ifelse(value>800,3,4)))}
  else if(crop=="pomegranate"){suitclass=ifelse(value>1000,1,ifelse(value>500,2,ifelse(value>250,3,4)))}
  else if(crop=="watermelon"){suitclass=ifelse(value>1000,1,ifelse(value>500,2,ifelse(value>250,3,4)))}
  else if(crop=="avocado"){suitclass=ifelse(value>2000,2,ifelse(value>1500,1,ifelse(value>1200,2,ifelse(value>770,3,4))))}
  else if(crop=="banana"){suitclass=ifelse(value>1500,1,ifelse(value>1250,2,ifelse(value>1000,3,4)))}
  else if(crop=="pineaple"){suitclass=ifelse(value>2000,3,ifelse(value>1600,2,ifelse(value>1000,1,ifelse(value>800,2,ifelse(value>600,3,4)))))}
  else if(crop=="pawpaw"){suitclass=ifelse(value>2000,2,ifelse(value>1000,1,ifelse(value>800,2,ifelse(value>600,3,4))))}
  else if(crop=="melon"){suitclass=ifelse(value>1000,3,ifelse(value>700,2,ifelse(value>400,1,ifelse(value>300,2,ifelse(value>200,3,4)))))}

  #rainfed crop suitability requirements for vegetables
  else if(crop=="tomato"){suitclass=ifelse(value>1200,4,ifelse(value>1000,3,ifelse(value>750,2,ifelse(value>600,1,ifelse(value>500,2,ifelse(value>400,3,4))))))}
  else if(crop=="vegetable"){suitclass=ifelse(value>1200,1,ifelse(value>1000,2,ifelse(value>850,3,4)))}
  else if(crop=="cabbage"){suitclass=ifelse(value>1000,3,ifelse(value>700,2,ifelse(value>550,1,ifelse(value>400,2,ifelse(value>200,3,4)))))}
  else if(crop=="okra"){suitclass=ifelse(value>1200,1,ifelse(value>800,2,ifelse(value>550,3,4)))}
  else if(crop=="cauliflower"){suitclass=ifelse(value>1200,1,ifelse(value>900,2,ifelse(value>550,3,4)))}
  else if(crop=="broccoli"){suitclass=ifelse(value>1200,1,ifelse(value>1000,2,ifelse(value>850,3,4)))}

  #rainfed crop suitability requirements for spices
  else if(crop=="chilli"){suitclass=ifelse(value>1200,3,ifelse(value>900,2,ifelse(value>750,1,ifelse(value>600,2,ifelse(value>500,3,4)))))}
  else if(crop=="pepper"){suitclass=ifelse(value>2000,1,ifelse(value>1500,2,ifelse(value>850,3,4)))}
  else if(crop=="onion"){suitclass=ifelse(value>1600,4,ifelse(value>800,3,ifelse(value>600,2,ifelse(value>400,1,ifelse(value>350,2,ifelse(value>250,3,4))))))}
  else if(crop=="ginger"){suitclass=ifelse(value>3000,1,ifelse(value>2500,2,ifelse(value>2000,3,4)))}
  else if(crop=="tumeric"){suitclass=ifelse(value>1500,1,ifelse(value>1000,2,ifelse(value>800,3,4)))}
  else if(crop=="cardamom"){suitclass=ifelse(value>3000,1,ifelse(value>2500,2,ifelse(value>2000,3,4)))}
  else if(crop=="lemongrass"){suitclass=ifelse(value>1750,1,ifelse(value>1000,2,ifelse(value>750,3,4)))}
  else if(crop=="vanilla"){suitclass=ifelse(value>1200,1,ifelse(value>800,2,ifelse(value>600,3,4)))}

  #rainfed crop suitability requirements for other crops
  else if(crop=="alfalfa"){suitclass=ifelse(value>1600,4,ifelse(value>1400,3,ifelse(value>1200,2,ifelse(value>800,1,ifelse(value>600,2,ifelse(value>400,3,4))))))}
  else if(crop=="rose"){suitclass=ifelse(value>1200,1,ifelse(value>1000,2,ifelse(value>850,3,4)))}
  else if(crop=="jasmine"){suitclass=ifelse(value>1200,1,ifelse(value>1000,2,ifelse(value>850,3,4)))}

  #rainfed crop suitability requirements for fleshy crops
  else if(crop=="yam"){suitclass=ifelse(value>1200,1,ifelse(value>1000,2,ifelse(value>850,3,4)))}
  else if(crop=="butternut"){suitclass=ifelse(value>1200,1,ifelse(value>1000,2,ifelse(value>850,3,4)))}
  else if(crop=="squash"){suitclass=ifelse(value>1000,1,ifelse(value>800,2,ifelse(value>450,3,4)))}
  else if(crop=="pumpkin"){suitclass=ifelse(value>1000,1,ifelse(value>800,2,ifelse(value>450,3,4)))}

  return(suitclass)
}

DataAvailabilityIndex=function(Boundary, Scale, CP,Data){
  if(is(Boundary, 'SpatialPolygonsDataFrame')){
    Boundary=as(Boundary,"SpatialPolygons")
  }

  else if (is(Boundary,"data.frame")){
    if(nrow(Boundary)>3){
    p = Polygon(Boundary)
    ps = Polygons(list(p),1)
    Boundary = SpatialPolygons(list(ps))
    }
    else{
      pol = st_polygon(
        list(
          cbind(
            Boundary[,1][c(1,2,2,1,1)],
            Boundary[,2][c(1,1,2,2,1)])
        )
      )
     }
  }
  else {Boundary=Boundary
  if(is.na(crs(Boundary))) {
    crs(Boundary)=CP
    }
  }
  Boundary=st_as_sfc(Boundary)
  st_crs(Boundary) = CP
  Boundary=st_transform(Boundary,4326)
  if(Scale<=0.1){stop("Selected assessment area is too small and must be greater than zero")}

  Boundary=as(Boundary,"Spatial")
  crs(Boundary)="+proj=longlat +datum=WGS84 +no_defs"
  ext <-  extent(Boundary)
  xy <- abs(apply(as.matrix(bbox(ext)), 1, diff))
  if(round(xy[1]/(Scale/111),0)<=1){stop("selected assessment area is too large")}
  w <- raster(ext, ncol=round(xy[1]/(Scale/111),0), nrow=round(xy[2]/(Scale/111),0))
  ww <-rasterize(Boundary, w)
  Data=st_as_sfc(Data,crs=CP)
  Data = st_transform(Data,4326)
  Data=as(Data,"Spatial")
  crs(Data)="+proj=longlat +datum=WGS84 +no_defs"
  pts_in<-Data[!is.na(over(Data,Boundary)),]

  pointcount = function(r, pts){
    b2 = r
    b2[] = 0
    counts = table(cellFromXY(r,pts))
    b2[as.numeric(names(counts))] = counts
    return(b2)
  }

  w2=pointcount(ww,pts_in)
  crs(w2)=CP
  return(w2)
}

suitabilityClass=function(value,crop,factor="rain"){
  if(factor=="rain"){
    crop==crop
    suitclass=rainSuit(value,crop)
  }
  else if(factor=="lgp"){
    crop==crop
    suitclass=LGPSuit(value,crop)
  }
  else if(factor=="temperature"){
    crop==crop
    suitclass=tempSuit(value,crop)

  }
  else if(factor=="carbon"){
    crop==crop
    suitclass=SOCSuit(value,crop)
  }
  else if(factor=="depth"){
    crop==crop
    suitclass=depthSuit(value,crop)
  }
  else if(factor=="carbonate"){
    crop==crop
    suitclass=carbonateSuit(value,crop)
  }
  else if(factor=="EC"){
    crop==crop
    suitclass=ECSuit(value,crop)
  }
  else if(factor=="ph"){
    crop==crop
    suitclass=PHSuit(value,crop)
  }
  else if(factor=="stone"){
    crop==crop
    suitclass=stoneSuit(value,crop)
  }
  else if(factor=="CEC"){
    crop==crop
    suitclass=CECSuit(value,crop)
  }
  else if(factor=="texture"){
    crop==crop
    suitclass=textureSuit(value,crop)
  }
  else if(factor=="slope"){
    crop==crop
    suitclass=slopeSuit(value,crop)
  }
  else if(factor=="drainage"){
    crop==crop
    suitclass=drainageSuit(value,crop)
  }
  else if(factor=="ESP"){
    crop==crop
    suitclass=ESPSuit(value,crop)
  }
  else if(factor=="fertility"){
    crop==crop
    suitclass=fertilitySuit(value,crop)
  }
  return(suitclass)
}

porositySuit=function(value, crop="wheat"){
  cropp1 =c("maize","wheat","rice","sorghum","millet","oat","barley",
           "groundnut","bean","pea","gram","soybean","lentil",
           "poplar","gravillea","sesbania","calliandra","leucaena","acacia","eucalyptus","teak","maple","ash",
           "sesame","sunflower","oilpalm","castor","safflower","mustard","rapeseed","olive",
           "cashew","coconut","almond","pistachio",
           "cotton","sugarcane","tea","coffee","rubber","jute","saffron","pyrethrum","tobacco",
           "sweetpotato","cassava","potato","carrot","turnip","radish")
  cropp2=c("mango","grape","citrus","pomegranate","banana","watermelon","melon","pineaple","pawpaw","avocado",
           "cabbage","tomato","vegetable","broccoli","cauliflower","okra",
           "chilli","pepper","ginger","tumeric","vanilla","lemongrass","cardamom","onion","rosemary","parsley",
           "alfalfa","rose","jasmine",
           "yam","pumpkin","butternut","squash")

  if(crop%in%cropp1){suitclass=calcSuit(value,30,40,48,100)}
  else if(crop%in%cropp2){suitclass=calcSuit(value,33,40,48,100)}

  return(suitclass)
}

featureRep=function(fgrid,df){
 if(is(fgrid,"RasterLayer")){
  df$y=extract(fgrid,df)#x.over[,1]
  options(digits=1)
  dist.histbb <- histbackback(df$y, values(fgrid), font.lab=5 ,probability=TRUE, xlab=c("Sample Points","Feature Map"), ylab = "Data range")

 }
  else if(is(fgrid,"SpatialGridDataFrame")){
    x.over=over(df,fgrid)
    df$y=x.over[,1]
    dist.histbb <- histbackback(df$y, fgrid@data[,1], font.lab=5 ,probability=TRUE, xlab=c("Sample Points","Feature Map"), ylab = "Data range")
  }
  else {
    dist.histbb <- histbackback(fgrid, df, font.lab=5 ,probability=TRUE, xlab=c("Sample Points","Feature Map"), ylab = "Data range")

  }
  barplot(-dist.histbb$left, col="dark grey" , horiz=TRUE, space=0, add=TRUE,axes=FALSE)
  barplot(dist.histbb$right, col="blue", horiz=TRUE, space=0, add=TRUE, axes=FALSE)
  ks.test(dist.histbb$left, dist.histbb$right, exact = FALSE)
}

saltSeverity=function(ec,ph,esp,criterion="FAO"){
  esp=esp*1
  ec=ec*1
  ph=round(ph*1,2)
  if(criterion=="FAO"){
    sal=ifelse(negData("ec",ec)<0.75,1,ifelse(negData("ec",ec)<2,2,ifelse(negData("ec",ec)<4,3,ifelse(negData("ec",ec)<8,4,ifelse(negData("ec",ec)<15,5,6)))))
    sod=ifelse(negData("esp",esp)<15,1,(ifelse(negData("esp",esp)<30,7,ifelse(negData("esp",esp)<50,8,ifelse(negData("esp",esp)<70,9,10)))))
    intenclass=ifelse(negData("ph",ph)<8.2,ifelse(esp<15,sal,ifelse(ec<4,13,12)),ifelse(esp<15,ifelse(ec<4,11,13),ifelse(ec<4,sod,13)))
   }
  if(criterion=="USDA"){
    sal=ifelse(negData("ec",ec)<2,1,ifelse(negData("ec",ec)<4,2,ifelse(negData("ec",ec)<8,3,ifelse(negData("ec",ec)<16,4,6))))
    sod=ifelse(negData("esp",esp)<15,1,(ifelse(negData("esp",esp)<30,7,ifelse(negData("esp",esp)<50,8,ifelse(negData("esp",esp)<70,9,10)))))
    intenclass=ifelse(negData("ph",ph)<8.5,ifelse(negData("esp",esp)<15,sal,ifelse(negData("ec",ec)<4,13,12)),ifelse(negData("esp",esp)<15,ifelse(negData("ec",ec)<4,11,13),ifelse(negData("ec",ec)<4,sod,13)))
  }
  else if(criterion=="Amrhein"){
    sal=ifelse(negData("ec",ec)<0.75,1,ifelse(negData("ec",ec)<2,2,ifelse(negData("ec",ec)<4,3,ifelse(negData("ec",ec)<8,4,ifelse(negData("ec",ec)<15,5,6)))))
    sod=ifelse(negData("esp",esp)<6,1,(ifelse(negData("esp",esp)<10,7,ifelse(negData("esp",esp)<15,8,10))))
    intenclass=ifelse(negData("ph",ph)<8.5,ifelse(negData("esp",esp)<15,sal,ifelse(negData("ec",ec)<4,13,12)),ifelse(negData("esp",esp)<15,ifelse(negData("ec",ec)<4,11,13),ifelse(negData("ec",ec)<4,sod,13)))
  }
  else if(criterion=="PSALT"){
    sal=ifelse(negData("ec",ec)<0.25,1,ifelse(negData("ec",ec)<0.5,2,ifelse(negData("ec",ec)<1,3,ifelse(negData("ec",ec)<2,4,6))))
    sod=ifelse(negData("esp",esp)<15,1,(ifelse(negData("esp",esp)<30,7,ifelse(negData("esp",esp)<50,8,ifelse(negData("esp",esp)<70,9,10)))))
    intenclass=ifelse(negData("ph",ph)<8.5,ifelse(negData("esp",esp)<15,sal,ifelse(negData("ec",ec)<0.25,13,12)),ifelse(negData("esp",esp)<15,ifelse(negData("ec",ec)<0.25,11,13),ifelse(negData("ec",ec)<0.25,sod,13)))
  }
  return(intenclass)
}

SASmodels=function(data="ec",extract="1:1"){
  if(data=="ec"){
    if(extract=="1:1"){
      ff=data.frame(extract=rep("1:1",9),
                    model=c("FAO","sonmez","hogg","landon","kargas","ozkan","USDA","hogg","zhang"),
                    texture=c(rep("yes",3),rep("no",6)))
    }
    if(extract=="1:2"){
        ff=data.frame(extract=rep("1:2",10),
                      model=c("FAO","hogg","USDA","polynomial","power","sigmoid","spherical",
                              "linear","gaussian","exponential"),
                      texture=c(rep("yes",2),"no",rep("yes",7)))
      }
    if(extract=="1:1.25"){
        ff=data.frame(extract=c("1:1.25"),model=c("FAO"),texture=c("yes"))
      }
    if(extract=="1:1.5"){
        ff=data.frame(extract=c("1:1.5"),model=c("FAO"),texture=c("yes"))
      }
    if(extract=="1:2.5"){
        ff=data.frame(extract=rep("1:2.5",11),model=c("polynomial","power","sigmoid",
                                                      "spherical","linear","gaussian","exponential",
                                                      "FAO","sonmez","ozkan","shahid"),
                      texture=c(rep("yes",9),rep("no",2)))
      }
    if(extract=="1:3"){
        ff=data.frame(extract=rep("1:3",2),model=c("landon","FAO"),texture=c("no","yes"))
      }
    if(extract=="1:5"){
        ff=data.frame(extract=rep("1:5",21),model=c("polynomial","power","sigmoid","spherical",
                                                    "linear","gaussian","exponential","FAO","sonmez",
                                                    "landon","kargas","ozkan","USDA","chi","park",
                                                    "viscounti","khorsandi","klaustermeier","he",
                                                    "aboukila","halder"),
                      texture=c(rep("yes",9),rep("no",12)))
      }
    if (extract=="1:10"){
        ff=data.frame(extract=c("1:10"),model=c("FAO"),texture=c("yes"))
      }
    }
    if(data=="ph"){
    if(extract=="kcl"){
      ff=data.frame(extract=rep("kcl",9),model=c("kabala","sadovski","polynomial","power","sigmoid",
                                                 "spherical","linear","gaussian","exponential"),
                    texture=c(rep("no",2),rep("yes",7)))
    }
    if (extract=="cacl2"){
      ff=data.frame(extract=rep("cacl2",11),model=c("miller","davis","brennan","ahern",
                                                    "polynomial","power","sigmoid","spherical","linear",
                                                    "gaussian","exponential"),
                    texture=c(rep("no",4),rep("yes",7)))
    }
  }

  return(ff)
}

fertilityRating=function(value,indicator="nitrogen"){
  if(indicator=="nitrogen"){CLSS=ifelse(value<0.01,4,ifelse(value<0.05,3,ifelse(value<0.15,2,1)))}
  else if(indicator=="phosphorus"){CLSS=ifelse(value<8,4,ifelse(value<16,3,ifelse(value<24,2,1)))}
  else if(indicator=="potassium"){CLSS=ifelse(value<39,4,ifelse(value<78,3,ifelse(value<156,2,1)))}
  else if(indicator=="carbon"){CLSS=ifelse(value<0.15,4,ifelse(value<0.75,3,ifelse(value<2.25,2,1)))}
  else if(indicator=="iron"){CLSS=ifelse(value<2,4,ifelse(value<4,3,ifelse(value<6,2,1)))}
  else if(indicator=="zinc"){CLSS=ifelse(value<0.5,4,ifelse(value<1,3,ifelse(value<3.5,2,1)))}
  else if(indicator=="manganese"){CLSS=ifelse(value<0.5,4,ifelse(value<1.2,3,ifelse(value<3.5,2,1)))}
  else if(indicator=="boron"){CLSS=ifelse(value<0.05,4,ifelse(value<0.2,3,ifelse(value<0.65,2,1)))}
  else if(indicator=="sulfur"){CLSS=ifelse(value<3,4,ifelse(value<10,3,ifelse(value<20,2,1)))}
  else if(indicator=="cec") {CLSS=ifelse(value<3,4,ifelse(value<10,3,ifelse(value<20,2,1)))}
  else if(indicator=="copper"){CLSS=ifelse(value<0.1,4,ifelse(value<0.3,3,ifelse(value<0.8,2,1)))}
  return(CLSS)

}

ECconversion4=function(x,target="TDS"){

  if(target=="TDS"){
    outSalt=ifelse(x<3200.001,x/640,x/800)
  }
  else if(target=="TSS"){
    outSalt=x/10
  }
  
  else if(target=="mmho"){
    outSalt=1*x
  }
   return(outSalt)
}

SOCSuit=function(value,crop="wheat"){
  cropp1=c("groundnut","bean","pea","gram","soybean","lentil","cotton","sugarcane","tea","coffee","rubber","jute",
           "poplar","gravillea","sesbania","calliandra","leucaena","acacia","eucalyptus","teak","maple","ash",
           "sesame","sunflower","oilpalm","castor","maize","grape",
           "potato","carrot","turnip","radish")
  cropp2=c("chilli","pepper","ginger","tumeric","vanilla","lemongrass","cardamom","onion","rosemary","parsley",
            "alfalfa","rose","jasmine","rice","cashew","coconut","almond","pistachio",
            "yam","pumpkin","butternut","squash","citrus","pomegranate","banana","watermelon","melon","pineaple","pawpaw","avocado",
            "cabbage","vegetable","broccoli","cauliflower","okra","cassava","rose","jasmine"
            )
  cropp3=c("wheat","sorghum","millet","oat")
  cropp4=c("vanilla","ginger","alfalfa","ginger","tumeric","vanilla","barley","safflower","mustard","rapeseed","olive",
           "saffron","pyrethrum","tobacco","sweetpotato","mango","tomato")

  if(crop%in%cropp1){suitclass=calcSuit(value,0.3,0.8,1.2,100)}
  else if(crop%in%cropp2){suitclass=calcSuit(value,0.3,0.8,1.5,100)}
  else if(crop%in%cropp3){suitclass=calcSuit(value,0.2,0.5,0.75,100)}
  else if(crop%in%cropp4){suitclass=calcSuit(value,0.5,0.98,2,100)}
  else {stop("No crop chosen or crop not yet included in database")}
  return(suitclass)
}

LGPSuit=function(value,crop="wheat"){
  #lgp (length of growing season/period) suitability requirements for cereals
  if(crop=="wheat"){suitclass=ifelse(value>150,1,ifelse(value>120,2,ifelse(value>90,3,4)))}
  else if(crop=="rice"){suitclass=ifelse(value>110,1,ifelse(value>90,2,ifelse(value>80,3,4)))}
  else if(crop=="maize"){suitclass=ifelse(value>100,1,ifelse(value>80,2,ifelse(value>60,3,4)))}
  else if(crop=="sorghum"){suitclass=ifelse(value>150,1,ifelse(value>120,2,ifelse(value>90,3,4)))}
  else if(crop=="millet"){suitclass=ifelse(value>110,1,ifelse(value>90,2,ifelse(value>60,3,4)))}
  else if(crop=="barley"){suitclass=ifelse(value>150,1,ifelse(value>120,2,ifelse(value>90,3,4)))}
  else if(crop=="oat"){suitclass=ifelse(value>180,1,ifelse(value>120,2,ifelse(value>90,3,4)))}

  #lgp (length of growing season/period) suitability requirements for legumes
  else if(crop=="groundnut"){suitclass=ifelse(value>100,1,ifelse(value>90,2,ifelse(value>75,3,4)))}
  else if(crop=="groundnut"){suitclass=ifelse(value>120,1,ifelse(value>90,2,ifelse(value>70,3,4)))}
  else if(crop=="gram"){suitclass=ifelse(value>110,1,ifelse(value>90,2,ifelse(value>70,3,4)))}
  else if(crop=="pea"){suitclass=ifelse(value>120,1,ifelse(value>100,2,ifelse(value>80,3,4)))}
  else if(crop=="soybean"){suitclass=ifelse(value>120,1,ifelse(value>100,2,ifelse(value>85,3,4)))}
  else if(crop=="lentil"){suitclass=ifelse(value>120,1,ifelse(value>100,2,ifelse(value>80,3,4)))}

  #lgp (length of growing season/period) suitability requirements for forests
  else if(crop=="poplar"){suitclass=ifelse(value>100,1,ifelse(value>90,2,ifelse(value>75,3,4)))}
  else if(crop=="grevillea"){suitclass=ifelse(value>120,1,ifelse(value>90,2,ifelse(value>70,3,4)))}
  else if(crop=="sesbania"){suitclass=ifelse(value>110,1,ifelse(value>90,2,ifelse(value>70,3,4)))}
  else if(crop=="calliandra"){suitclass=ifelse(value>120,1,ifelse(value>100,2,ifelse(value>80,3,4)))}
  else if(crop=="leucaena"){suitclass=ifelse(value>120,1,ifelse(value>100,2,ifelse(value>85,3,4)))}
  else if(crop=="acacia"){suitclass=ifelse(value>120,1,ifelse(value>100,2,ifelse(value>80,3,4)))}
  else if(crop=="eucalyptus"){suitclass=ifelse(value>120,1,ifelse(value>100,2,ifelse(value>80,3,4)))}
  else if(crop=="teak"){suitclass=ifelse(value>120,1,ifelse(value>100,2,ifelse(value>80,3,4)))}
  else if(crop=="maple"){suitclass=ifelse(value>120,1,ifelse(value>100,2,ifelse(value>80,3,4)))}
  else if(crop=="ash"){suitclass=ifelse(value>120,1,ifelse(value>100,2,ifelse(value>80,3,4)))}
  
  #lgp (length of growing season/period) suitability requirements for oil crops
  else if(crop=="sesame"){suitclass=ifelse(value>90,1,ifelse(value>70,2,ifelse(value>60,3,4)))}
  else if(crop=="oilpalm"){suitclass=ifelse(value>120,4,ifelse(value>100,3,ifelse(value>90,2,1)))}
  else if(crop=="castor"){suitclass=ifelse(value>150,1,ifelse(value>120,2,ifelse(value>90,3,4)))}
  else if(crop=="mustard"){suitclass=ifelse(value>100,1,ifelse(value>90,2,ifelse(value>75,3,4)))}
  else if(crop=="safflower"){suitclass=ifelse(value>160,1,ifelse(value>120,2,ifelse(value>90,3,4)))}
  else if(crop=="rapeseed"){suitclass=ifelse(value>100,1,ifelse(value>85,2,ifelse(value>75,3,4)))}
  else if(crop=="olive"){stop("not included")}

  #lgp (length of growing season/period) suitability requirements for nuts
  else if(crop=="cashew"){suitclass=ifelse(value>210,1,ifelse(value>150,2,ifelse(value>90,3,4)))}
  else if(crop=="coconut"){stop("not included")}
  else if(crop=="pistachio"){stop("not included")}
  else if(crop=="almond"){stop("not included")}

  #lgp crop suitability requirements for industrial crops
  else if(crop=="cotton"){suitclass=ifelse(value>240,1,ifelse(value>180,2,ifelse(value>120,3,4)))}
  else if(crop=="sugarcane"){stop("not included")}
  else if(crop=="tea"){suitclass=ifelse(value>240,1,ifelse(value>180,2,ifelse(value>120,3,4)))}
  else if(crop=="coffee"){suitclass=ifelse(value>320,1,ifelse(value>240,2,ifelse(value>180,3,4)))}
  else if(crop=="saffron"){suitclass=ifelse(value>150,1,ifelse(value>110,2,ifelse(value>90,3,4)))}
  else if(crop=="jute"){suitclass=ifelse(value>120,1,ifelse(value>100,2,ifelse(value>90,3,4)))}
  else if(crop=="tobacco"){suitclass=ifelse(value>120,1,ifelse(value>100,2,ifelse(value>90,3,4)))}
  else if(crop=="pyrethrum"){suitclass=ifelse(value>120,1,ifelse(value>100,2,ifelse(value>80,3,4)))}
  else if(crop=="rubber"){stop("not included")}

  #lgp crop suitability requirements for tuber
  else if(crop=="potato"){suitclass=ifelse(value>120,1,ifelse(value>100,2,ifelse(value>80,3,4)))}
  else if(crop=="cassava"){suitclass=ifelse(value>120,1,ifelse(value>100,2,ifelse(value>80,3,4)))}
  else if(crop=="turnip"){suitclass=ifelse(value>60,1,ifelse(value>40,2,ifelse(value>30,3,4)))}
  else if(crop=="radish"){suitclass=ifelse(value>60,1,ifelse(value>40,2,ifelse(value>30,3,4)))}
  else if(crop=="sweetpotato"){suitclass=ifelse(value>120,1,ifelse(value>100,2,ifelse(value>80,3,4)))}
  else if(crop=="carrot"){suitclass=ifelse(value>60,1,ifelse(value>40,2,ifelse(value>30,3,4)))}

  #lgp crop suitability requirements for fruits
  else if(crop=="mango"){suitclass=ifelse(value>180,1,ifelse(value>150,2,ifelse(value>120,3,4)))}
  else if(crop=="grapes"){stop("not included")}
  else if(crop=="citrus"){suitclass=ifelse(value>240,1,ifelse(value>180,2,ifelse(value>150,3,4)))}
  else if(crop=="pomegranate"){suitclass=ifelse(value>150,1,ifelse(value>120,2,ifelse(value>90,3,4)))}
  else if(crop=="banana"){stop("not included")}
  else if(crop=="watermelon"){suitclass=ifelse(value>110,1,ifelse(value>90,2,ifelse(value>60,3,4)))}
  else if(crop=="melon"){suitclass=ifelse(value>90,1,ifelse(value>70,2,ifelse(value>60,3,4)))}
  else if(crop=="pineaple"){stop("not included")}
  else if(crop=="pawpaw"){stop("not included")}
  else if(crop=="avocado"){stop("not included")}

  #lgp crop suitability requirements for vegetables
  else if(crop=="cabbages"){suitclass=ifelse(value>180,1,ifelse(value>120,2,ifelse(value>90,3,4)))}
  else if(crop=="vegetable"){suitclass=ifelse(value>150,1,ifelse(value>120,2,ifelse(value>90,3,4)))}
  else if(crop=="tomato"){suitclass=ifelse(value>150,1,ifelse(value>120,2,ifelse(value>90,3,4)))}
  else if(crop=="broccoli"){suitclass=ifelse(value>150,1,ifelse(value>120,2,ifelse(value>90,3,4)))}
  else if(crop=="okra"){suitclass=ifelse(value>100,1,ifelse(value>70,2,ifelse(value>60,3,4)))}
  else if(crop=="cauliflower"){suitclass=ifelse(value>90,1,ifelse(value>70,2,ifelse(value>60,3,4)))}

  #lgp crop suitability requirements for spices
  else if(crop=="chilli"){suitclass=ifelse(value>180,1,ifelse(value>120,2,ifelse(value>90,3,4)))}
  else if(crop=="pepper"){suitclass=ifelse(value>180,1,ifelse(value>120,2,ifelse(value>90,3,4)))}
  else if(crop=="onion"){suitclass=ifelse(value>110,1,ifelse(value>90,2,ifelse(value>70,3,4)))}
  else if(crop=="ginger"){stop("not included")}
  else if(crop=="tumeric"){stop("not included")}
  else if(crop=="lemongrass"){suitclass=ifelse(value>210,1,ifelse(value>180,2,ifelse(value>150,3,4)))}
  else if(crop=="cardamom"){stop("not included")}
  else if(crop=="vanilla"){stop("not included")}

  #lgp crop suitability requirements for others
  else if(crop=="alfalfa"){stop("not included")}
  else if(crop=="rose"){stop("not included")}
  else if(crop=="jasmine"){stop("not included")}

  #lgp crop suitability requirements for fleshy
  else if(crop=="yam"){stop("not included")}
  else if(crop=="butternut"){suitclass=ifelse(value>120,1,ifelse(value>90,2,ifelse(value>80,3,4)))}
  else if(crop=="pumpkin"){suitclass=ifelse(value>150,1,ifelse(value>110,2,ifelse(value>90,3,4)))}
  else if(crop=="squash"){suitclass=ifelse(value>180,1,ifelse(value>110,2,ifelse(value>90,3,4)))}

  return(suitclass)
}

NDVIcoverfactor=function(ndvi,model="kniff"){
  ndvi=ifelse(ndvi<0,NA,ndvi)
  ndvi = ifelse(ndvi>1,NA,ndvi)
  if(model=="patil"){cafc=harmonization(ndvi,A=-1.21,B=1.02)}
  if(model=="almagro"){cafc=harmonization(ndvi,A=-0.05, B=0.05)}
  if(model=="jamshidi"){cafc=harmonization(ndvi,A=-4.61333,B=1.2079)}
  if(model=="dejong"){cafc=harmonization(ndvi,A=-0.805, B=0.431)}
  if(model=="toumi") {cafc=harmonization(ndvi,A=-1.1667, B=0.9167)}
  if(model=="gitas") {cafc=harmonization(ndvi,A=-0.5953, B=0.407)}
  if(model=="joshi") {cafc=harmonization(ndvi,A=-1.612,  B=1.056)}
  if(model=="durigon"){cafc=harmonization(ndvi,A=-0.5, B=0.5)}
  covexpr1=function(x,A,B){
    y=A*exp(B*x)
    return(y)}
    if(model=="wickama"){cafc=covexpr1(ndvi, A=0.227, B=-0.997)}
  if(model=="suriyaprasit"){cafc=covexpr1(ndvi, A=0.227, B=-7.337)}
  if(model=="kniff"){cafc=exp(-2*ndvi/(1-ndvi))}
  if(model=="lin"){cafc=1.1119*ndvi^2-2.0967*ndvi+0.9944}
  if(model=="bahrawi"){cafc=0.625*ndvi^2-1.4793*ndvi+0.8771}
  if(model=="kulikov"){cafc=exp(-2.9298*ndvi-0.7842)}
  if(model=="power"){cafc=((1-ndvi)/2)^(1+ndvi)}

  if(model=="modis"){
    fg = 108.49*ndvi+0.717
    cafc=ifelse(fg<0.11,1,ifelse(fg<78.4,0.6508-0.3436*log10(ndvi),0.0001))
  }

  cover=ifelse(cafc<0,NA,ifelse(cafc>1,1,cafc))
  return(cover)
}

depthharm<- function(soildata, var.name, lam = 0.1, d = t(c(0,5,10,20,40,80,160,200))){
  if (is(soildata,"SoilProfileCollection") == TRUE){
    depthcols = soildata@depthcols
    idcol = soildata@idcol
    soildata@horizons = soildata@horizons[,c(idcol, depthcols, var.name)]
    sdata<- as.data.frame(soildata@horizons)}
  vlow = 0; vhigh = 1000; progress=TRUE
  if (is(soildata,"data.frame") == TRUE){
    sdata<- as.data.frame(soildata[,c(1:3,which(colnames(soildata)==var.name))])}
  soildata@horizons <- soildata@horizons[!soildata@horizons[,depthcols[1]]<0 & !soildata@horizons[,depthcols[2]]<0,]
  if (is(soildata,"data.frame") == FALSE & is(soildata,"SoilProfileCollection") == FALSE){
    stop("ERROR:: soildata must be either a data.frame or SoilProfileCollection")}
  maxdata<- max(d)
  s2<- (0.05*mean(sdata[,4]))^2
  sp_dat<-split(sdata,sdata[,1])
  nl<- length(lam)
  matrix_yfit<- matrix(NA,ncol=length(c(1:maxdata)),nrow=length(sp_dat))
  y.avg<- matrix(NA,ncol=length(d),nrow=length(sp_dat))
  sse<- matrix(NA,ncol=length(lam),nrow=1)
  sset<- matrix(NA,ncol=length(lam),nrow=length(sp_dat))
  mat_id<- sdata[0,]
  d.avg<- sdata[1,]
  d.avg$predicted<- 0
  d.avg$FID<- 0
  d.avg<- d.avg[0,]
  message("Harmonizing depth intervals...")
  if (progress) pb <- txtProgressBar(min=0, max=length(sp_dat), style=3)
  cnt<- 1
  for(st in 1:length(sp_dat)) {
    subs<-sp_dat[[st]]
    subs<-as.matrix(subs)
    mat_id[st,1]<- subs[1,1]
    ir<- c(1:nrow(subs))
    ir<-as.matrix(t(ir))
    u<- as.numeric(subs[ir,2])
    u<-as.matrix(t(u))
    v<- as.numeric(subs[ir,3])
    v<-as.matrix(t(v))
    y<- as.numeric(subs[ir,4])
    y<-as.matrix(t(y))
    n<- length(y);
    if (n == 1)
    {d.avg[cnt:(cnt-1+nrow(subs)),1:4]<- subs
    d.avg[cnt:(cnt-1+nrow(subs)),5]<- y
    d.avg[cnt:(cnt-1+nrow(subs)),6]<- st
    xfit<- as.matrix(t(c(1:maxdata)))
    nj<- max(v)
    if (nj > maxdata)
    {nj<- maxdata}
    yfit<- xfit
    yfit[,1:nj]<- y
    if (nj < maxdata)
    {yfit[,(nj+1):maxdata]=NA}
    matrix_yfit[st,]<- yfit
    nd<- length(d)-1
    dl<-d+1
    for (cj in 1:nd) {
      xd1<- dl[cj]
      xd2<- dl[cj+1]-1
      if (nj>=xd1 & nj<=xd2)
      {xd2<- nj-1
      y.avg[st,cj]<- mean(yfit[,xd1:xd2])}
      else
      {y.avg[st,cj]<- mean(yfit[,xd1:xd2])}
      y.avg[st,cj+1]<- max(v)}
    cnt<- cnt+nrow(subs)

    }
    else  {
      d.avg[cnt:(cnt-1+nrow(subs)),1:4]<- subs
      d.avg[cnt:(cnt-1+nrow(subs)),6]<- st
      np1 <- n+1
      nm1 <- n-1
      delta <- v-u
      del <- c(u[2:n],u[n])-v
      r <- matrix(0,ncol=nm1,nrow=nm1)
      for(dig in 1:nm1){
        r[dig,dig]<-1
      }
      for(udig in 1:nm1-1){
        r[udig,udig+1]<-1
      }
      d2 <- matrix(0, ncol=nm1, nrow=nm1)
      diag(d2) <- delta[2:n]
      r <- d2 %*% r
      r <- r + t(r)
      d1 <- matrix(0, ncol=nm1, nrow=nm1)
      diag(d1) <- delta[1:nm1]

      d3 <- matrix(0, ncol=nm1, nrow=nm1)
      diag(d3) <- del[1:nm1]
      r <- r+2*d1 + 6*d3
      q <- matrix(0,ncol=n,nrow=n)
      for (dig in 1:n){
        q[dig,dig]<- -1
      }
      for (udig in 1:n-1){
        q[udig,udig+1]<-1
      }
      q <- q[1:nm1,1:n]
      dim.mat <- matrix(q[],ncol=length(1:n),nrow=length(1:nm1))
      rinv <- try(solve(r), TRUE)
      if(is.matrix(rinv)){
        ind <- diag(n)
        pr.mat <- matrix(0,ncol=length(1:nm1),nrow=length(1:n))
        pr.mat[] <- 6*n*lam
        fdub <- pr.mat*t(dim.mat)%*%rinv
        z <- fdub%*%dim.mat+ind
        sbar <- solve(z,t(y))
        d.avg[cnt:(cnt-1+nrow(subs)),5]<- sbar
        cnt<- cnt+nrow(subs)
        b <- 6*rinv%*%dim.mat%*% sbar
        b0 <- rbind(0,b)
        b1 <- rbind(b,0)
        gamma <- (b1-b0) / t(2*delta)
        alfa <- sbar-b0 * t(delta) / 2-gamma * t(delta)^2/3
        xfit<- as.matrix(t(c(1:maxdata)))
        nj<- max(v)
        if (nj > maxdata)
        {nj<- maxdata}
        yfit<- xfit
        for (k in 1:nj){
          xd<-xfit[k]
          if (xd< u[1])
          {p<- alfa[1]} else
          {for (its in 1:n) {
            if(its < n)
            {tf2=as.numeric(xd>v[its] & xd<u[its+1])} else {tf2<-0}
            if (xd>=u[its] & xd<=v[its])
            {p=alfa[its]+b0[its]*(xd-u[its])+gamma[its]*(xd-u[its])^2} else if (tf2)
            {phi=alfa[its+1]-b1[its]*(u[its+1]-v[its])
            p=phi+b1[its]*(xd-v[its])}
          }}
          yfit[k]=p }
        if (nj < maxdata)
        {yfit[,(nj+1):maxdata]=NA}

        yfit[which(yfit > vhigh)] <- vhigh
        yfit[which(yfit < vlow)]  <-vlow
        matrix_yfit[st,]<- yfit
        nd<- length(d)-1
        dl<-d+1
        for (cj in 1:nd) {
          xd1<- dl[cj]
          xd2<- dl[cj+1]-1
          if (nj>=xd1 & nj<=xd2)
          {xd2<- nj-1
          y.avg[st,cj]<- mean(yfit[,xd1:xd2])}
          else
          {y.avg[st,cj]<- mean(yfit[,xd1:xd2])}
          y.avg[st,cj+1]<- max(v)}
         ssq <- sum((t(y)-sbar)^2)
        g <- solve(z)
        ei <- eigen(g)
        ei <- ei$values
        df <- n-sum(ei)
        sig2w <- ssq/df
        dfc <- n-2*sum(ei)+sum(ei^2)
        sig2c <- ssq/dfc
        tmse <- ssq/n-2*s2*df/n+s2
        sset[st] <- tmse

      }
    }

    if (progress) { setTxtProgressBar(pb, st)  }
  }
  if (progress) {
    close(pb)

  }
   y.avg<- as.data.frame(y.avg)
  jmat<- matrix(NA,ncol=1,nrow=length(d))
  for (i in 1:length(d)-1) {
    a1<-paste(d[i],d[i+1],sep="-")
    a1<-paste(a1,"cm",sep=" ")
    jmat[i]<- a1}
  jmat[length(d)]<- "soil depth"
  for (jj in 1:length(jmat)){
    names(y.avg)[jj]<- jmat[jj]
  }
  y.avg<- cbind(mat_id[,1],y.avg)
  names(y.avg)[1]<- "id"

  retval <- list(harmonized.d=y.avg, obs_n_preds=d.avg)

  return(retval)


}

imageIndices=function(blue, green,red,nir,swir1,swir2,index="NDVI"){

  if(index=="NSI"){ratio=(swir1-swir2)/(swir1-nir+0.001)}
  else if(index=="SI1"){ratio=sqrt(green*red)}
  else if(index=="SI2"){ratio=sqrt(blue*red)}
  else if(index=="SI3"){ratio=sqrt((green)^2+(red)^2)}
  else if(index=="SI4"){
    rat=(nir*swir1-(swir1)^2)
    ratio=ifelse(rat<0,0,rat/nir)}
  else if(index=="SI5"){ratio=blue/red}
  else if(index=="SI6"){ratio=red*nir/green}
  else if(index=="SAVI"){
    rat=1.5*(nir-red)
    rat1=(0.5+nir+red)
    ratio=ifelse(rat<0,0,ifelse(rat1<0,0,(rat/(rat1))))
  }
  else if(index=="VSSI"){ratio=2*green-5*(red+nir)}
  else if(index=="NDSI"){ratio=(red-nir)/(red+nir)}
  else if(index=="NDVI"){ratio=(nir-red)/(nir+red)}
  else if(index=="SR"){ratio=(green-red)/(blue+red)}
  else if(index=="CRSI"){
    rat=(nir*red-blue*green)
    rat1 = (nir*green+blue*green)
    ratio=ifelse(rat<0,0,ifelse(rat1<0,0,sqrt(rat/(rat1))))
    }
  else if(index=="BI"){ratio=sqrt(green^2+red^2+nir^2)}
  else if(index=="NDSnI"){ratio=(green-swir1)/(green+swir1)}
  else if(index=="ROCK"){ratio=nir/swir1}
  else if(index=="NDBI"){ratio=(swir1-nir)/(swir1+nir)}
  else if(index=="NBR"){ratio=(swir1-swir2)/(swir1+swir2)}
  else if(index=="CLAY"){ratio=swir1/swir2}
  else if(index=="NDMI"){ratio=(nir-0.5*(swir1+swir2))/(nir+0.5*(swir1+swir2))}
  else if(index=="NDWI"){ratio=(green-nir)/(green+nir)}
  else if(index=="TNDVI"){
    rat=(nir-red)/(nir+red)
    ratio=ifelse(rat<(-0.5),0,sqrt(rat+0.5))
    }
  return(ratio)
}

\name{NPPmodel}
\alias{NPPmodel}
\title{
Calculating net primary production using air temperature and mean rainfall amount
}
\description{
This is an empirical function for deriving net primary production using climatic variables (mean temperature and rainfall amounts)
}
\usage{
NPPmodel(rain,temperature,model)
}
\arguments{
  \item{rain}{
total annual rainfall amount in mm
}
  \item{temperature}{
average annual air temperature amount in degrees Celsius
}
  \item{model}{
model for calculating net primary production. Included models in the function are Miami, Schurr, and NCEAS
}
}
\details{
This function is based on empirical models for calculating annual net primary production (NPP) of dry matter
}
\value{
Net primary production (NPP) of dry matter in grams per square meter per year
}
\references{
Schuur, E. A. G. 2003. Productivity and global climate revisited: the sensitivity of tropical forest growth to precipitation. Ecology 84:1165–1170

Lieth, H. 1975. Modeling the primary productivity of the world. Pages 237–264 in H. Lieth and R. H. Whittaker, editors. Primary productivity of the biosphere. Springer-Verlag, New York, New York, USA

Del Grosso, S., Parton, W., Stohlgren, T., Zheng, D., Bachelef, D., Prince, S., Hibbard, K., Olson, R. 2008. Global potential net primary production predicted from vegetation class, precipitation, and temperature. Ecology, 89(8): 2117-2126
}
\author{
Christian Thine Omuto
}
\note{
This empirical function estimates annual NPP in g/m2/year. It is a general model for all land cover types. It may be necessary to adjust it for certain cover types or geolocations
}
\seealso{
\code{\link{carbonTurnover}}, \code{\link{RotCmoistcorrection}}
}
\examples{
NPPmodel(800,23,"miami")
NPPmodel(800,23,"schuur")
NPPmodel(800,23,"NCEAS")
}

\name{ME_PHharm}
\alias{ME_PHharm}
\title{
Mixed-effects model for harmonizing soil pH (KCl or CaCl2) to the equivalent pH (water)
}
\description{
A function for harmonizing soil pH (KCl or CaCl2) to the equivalent pH (water) using mixed effects approach
}
\usage{
ME_PHharm(ph, TEXCLASS, model, phtype)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{ph}{
a vector or single value of soil ph in KCl or CaCl2 to be harmonized
}
 \item{TEXCLASS}{
soil textural class of the soil whose ph is to be harmonized. String or test entry of USDA textural classes: Cl, ClLo, Lo,LoSa,Sa,SaCl,SaClLo,SaLo,SiCl,SiClLo,SiLo,Si,CS,MS,HCL,FS. The classes can be determined from Clay, Silt, and Sand proportions using createTexturedata function
}
 \item{model}{
functional model for relating ph in KCl or CaCl to be harmonized and equivalent ph (water). Models considered are second order polynomial, sigmoid, spherical, gaussian, exponential, power, and linear functions. The default is polynomial
}
 \item{phtype}{
KCl or CaCl2 solution for ph. The default is CaCl2
}
}
\details{
ph harmonization models, which were developed using global datasets, are designed to standardize soil ph for applications in soil salt classification
}
\value{
numeric value of equivalent ph (water)
}
\author{
Christian Thine Omuto
}
\note{
The function only works with USDA soil textural classes. Convert other soil textural classes to USDA classes for all applications with this function.
}

\seealso{
\code{\link{ME_ECharm}}, \code{\link{ECconversion1}}, \code{\link{ECconversion2}}
}
\examples{
newdata=data.frame(ph=c(1.6,8.3,5.7,12.1,2.2),tex=c("Cl","SaCl","LoSa", "Si","SaClLo"))
newdata$pH2=ME_PHharm(newdata$ph,newdata$tex,"exponential","kcl")

}

\name{ECconversion1}
\alias{ECconversion1}
\title{
Harmonizing electrical conductivity of a soil solution to that of the saturated paste extract
}
\description{
This function converts electrical conductivity measurements of a soil solution to that of soil paste extract. It considers the influence of texture, organic matter content, and clay content on electrical conductivity conversion. These factors and ratio of soil:water mix for the solution and conversion method must be indicated.
}
\usage{
ECconversion1(ec,texture,method,extract,oc=NULL,clay=NULL)
}
\arguments{
  \item{ec}{
measured electrical conductivity of the soil solution
}
 \item{texture}{
soil textural class according to USDA or its equivalent. Texture class is given in terms of class codes as given in classnames("texture")
}
\item{method}{
method for converting electrical conductivity of the soil:water mix to that of the soil paste extract. The methods included are FAO, sonmez, and hogg. The default is FAO
}
 \item{extract}{
ratio of soil:water in extract solution for measuring electrical conductivity was measured. Example is 1:1, 1:2, etc. The default is 1:1
}
\item{oc}{
organic matter content of the soil in percent
}
 \item{clay}{
clay content of the soil in percent
}
}
\details{
This function considers the influence of texture and soil-water solution on conversion of electrical conductivities. The functions includes FAO, sonmez, and hogg conversion models. FAO model requires information on clay content and organic carbon content.
}
\value{
equivalent electrical conductivity of saturated soil extract
}
\references{
FAO. 2006. Soil description guidelines. FAO, Rome.

Sonmez S, Buyuktas D, Asri FO. 2008. Assessment of different soil to water ratios (1:1, 1:2.5, 1:5) in soil salinity studies. Geoderma, 144: 361-369

Hogg TTJ, Henry JL. 1984. Comparison of 1:1 and 1:2 suspensions and extracts with the saturation extracts in estimating salinity in Saskatchewan. Can. J. Soil Sci. 1984, 64, 699–704

}
\author{
Christian Thine Omuto
}
\seealso{
\code{\link{ECconversion2}}, \code{\link{ECconversion3}}, \code{\link{ECconversion4}}
}
\examples{
library(sp)
library(raster)
ECconversion1(7.31,"SiCl","FAO","1:2.5",0.91,22.5)
ec=suitabinput["ec"]
soc=nutrindicator["soc"]
clay=textureinput["clay"]
texture=suitabinput["texture"]
newmap=ec
newmap$ECe=ECconversion1(ec$ec,texture$texture,"FAO","1:2.5",soc$soc,clay$clay)
spplot(newmap["ECe"], main="Equivalent ECse")
}

\name{PHConversion}
\alias{PHConversion}
\title{
Models for converting soil pH (KCl or CaCl) to the equivalent pH (water)
}
\description{
A suit of functions for converting soil pH (KCl or CaCl2) to the equivalent pH (water)
}
\usage{
PHConversion(ph, model,phtype)
}
\arguments{
  \item{ph}{
a vector or single value of soil ph in KCl or CaCl2 to be converted to ph (water)
}
  \item{model}{
functional model for relating ph in KCl or CaCl to be converting and equivalent ph (water). Models considered are second order kabala, sadovski, davies, brennan functions. The default is kabala
}
  \item{phtype}{
KCl or CaCl2 solution for ph. The default is CaCl2
}
}
\details{
ph conversion models are those in the literature
}
\value{
numeric value of equivalent ph (water)
}
\references{
Davies, B.E. (1971). A Statistical Comparison of pH Values of some English Soils after Measurement in both Water and 0.01M Calcium Chloride. Soil Science Society of America Journal 35, 551–552. https://doi.org/10.2136/sssaj1971.03615995003500040022x

Kabała, C., Musztyfaga, E., Gałka, B., Łabuńska, D., Mańczyńska, P. (2016). Conversion of Soil pH 1:2.5 KCl and 1:2.5 H2O to 1:5 H2O: Conclusions for Soil Management, Environmental Monitoring, and International Soil Databases. Pol. J. Environ. Stud. 25, 647–653. https://doi.org/10.15244/pjoes/61549

Miller, R.O., Kissel, D.E. (2010). Comparison of Soil pH Methods on Soils of North America. Soil Sci. Soc. Am. J. 74, 310–316. https://doi.org/10.2136/sssaj2008.0047

Sadovski, A.N. (2019). Study on pH in water and potassium chloride for Bulgarian soils. EURASIAN JOURNAL OF SOIL SCIENCE (EJSS) 8, 11–16. https://doi.org/10.18393/ejss.477560
}
\author{
Christian Thine Omuto
}
\note{
ph ranges between 1 and 14
}
\seealso{
ME_PHharm, ME_ECharm, ECconversion1
}
\examples{
testdata=data.frame(PHKC=c(6.45,8.34,5.07,12.17, 4.219),TEX=c("Cl","SaCl","LoSa", "Si","SaClLo"))
testdata$PHs1=PHConversion(testdata$PHKC,"kabala","kcl")
}

\name{SASglobeData}
\alias{SASglobeData}
\title{
Querying global SAS data
}
\description{
A function to query soil data availability in the global SAS database
}
\usage{
SASglobeData(dframe,ISO,Region)
}
\arguments{
  \item{dframe}{
is a string to describe type of soil data in the SAS database.
}
  \item{ISO}{
is a string describing three digit international ISO code for a country.
}
  \item{Region}{
is a string describing the region of the world.
}
}
\details{
Options for type of soil data for querrying the database are "ecse","ec2","ec2.5","ec5","ph","phkcl","phcacl2","sand","silt","clay".Options for regions of the world in the SAS database are "Africa", "Asia", "Europe", "Eurasia", "NENA", "LAC", "N.America", and "Pacific". NENA is Near East and North Africa. LAC is Latin America and Caribbean. N. America is North America. Any of these Regions may be specified if desired. The default Region is NULL
}
\value{
The query returns a dataframe with the soil attribute querried, coordinates of sampling locations, and name of country where the samples are located
}
\references{
Batjes, N. H., Ribeiro, E. & van Oostrum, A. Standardised soil profile data to support global mapping and modelling (WoSIS snapshot 2019). Earth Syst. Sci. Data 12, 299–320 (2020).

FAO/IIASA/ISRIC/ISS-CAS/JRC. Harmonized World Soil Database (version 1.2). (FAO and IIASA, 2012).

Omuto, C. T., Vargas. R., Abdelmagin, E.A., Mohamed, N., Viatkin, K., Yusuf, Y. Mapping of salt-affected soils – Technical manual. (FAO, 2020). doi:10.4060/ca9215en

Orgiazzi, A., Ballabio, C., Panagos, P., Jones, A. & Fernández‐Ugalde, O. LUCAS Soil, the largest expandable soil dataset for Europe: a review. Eur J Soil Sci 69, 140–153 (2018).
}
\author{
Christian Thine Omuto
}
\note{
Internet connectivity is needed for the function to work.
}
\examples{
\donttest{
wrter=SASglobeData("sand","ZAF")# For South Africa profiles
plot(Longitude~Latitude, wrter)
}
}

\name{carbonTurnover}
\alias{carbonTurnover}
\title{
A function for implementing RothC carbon turnover model in the soil
}
\description{
This function provides alternatives for implementing RothC carbon turnover model
}
\usage{
carbonTurnover(tt,clay,C0,In,Dr=1.44,effcts,solver)
}
\arguments{
  \item{tt}{
a vector of time in months or years for modelling carbon turnover in the soil
}
  \item{clay}{
Proportion of soil clay content in percent
}
  \item{C0}{
a vector containing five initial carbon pools in the five compartments C1 in DPM, C2 in RPM, C3 in BIO, C4 in HUM and C5 in IOM. They are arranged in the order C1,C2,C3,C4,C5 [C0=c(C1,C2,C3,C4,C5)].
}
  \item{In}{
Input carbon amount. It can be a scalar constant or a 2-column dataframe containing time dependent organic matter input. The two columns are time and carbon input
}
  \item{Dr}{
ratio of decomposable plant material (DPM) to resistant plant material (RPM). Default value is 1.44
}
  \item{effcts}{
a constant or dataframe of environmental effects on carbon decomposition rates. If it's a dataframe of time-dependent variables, then the length of the dataframe should be similar to the length of time (t) vector
}
  \item{solver}{
name of subroutines for solving first order odinary differential equations for organic matter decay in the soil. The subroutines are lsoda, lsodes,rk4, euler,lsode, lsodar,ode23, radau,etc. from deSolve
}
}
\details{
vector t can be years or months sequentially arranged with the start-time as the minimum and end-time as the maximum time. Initial carbon pools are also provided as a vector of five items: C1,C2,C3,C4,C5 in that order where C1 is the pool in the decomposable plant material (DPM) compartment, C2 is pool in the resistant plant material (RPM) compartment, C3 is the pool in the microbial biomass (BIO) compartment, C4 is the pool in the humified organic matter (HUM) compartment, and C5 is the pool in the inert organic matter (IOM) compartment.
}
\value{
nx6 matrix of carbon pools with time in the five compartments DPM, RPM, BIO, HUM, and IOM in that order (time, C1, C2, c3, C4, C5).
}
\references{
Coleman, K. and Jenkinson, D. 2014. ROTHC-26.3 A model for the turnover of carbon in soils: Model description and users guide (Windows version). Rothamsted Research Harpenden Herts AL5 2JQ

Jenkinson, D. S., Andrew, S. P. S., Lynch, J. M., Goss, M. J., Tinker, P. B. 1990. The Turnover of Organic Carbon and Nitrogen in Soil. Philosophical Transactions: Biological Sciences, 329: 361–368.
}
\author{
Christian Thine Omuto
}
\seealso{
\code{\link{RotCmoistcorrection}}, \code{\link{NPPmodel}}
}
\examples{
library(deSolve)
Cin=c(0.6,0.1,0.3,0.1,2.7)
T=seq(1/12,200,by=1/12)
hw=carbonTurnover(tt=T,clay=23.4,C0=Cin,In=1.2,Dr=1.44,effcts=0.85,"euler")
matplot(T,hw[,2:6], type="l", lty=1, xlab="Time", ylab="C stocks (Mg/ha)")
legend("topright", c("DPM", "RPM", "BIO", "HUM", "IOM"),lty=1, col=1:5, bty="n")
}

\name{saltRating}
\alias{saltRating}
\title{
Classifying salt-affected soils using EC and PH only
}
\description{
This function determines classes of salt-affected soils using Electrical Conductivity and pH according to FAO or USDA salt classification schemes
}
\usage{
saltRating(ec,ph,criterion="FAO")
}
\arguments{
   \item{ec}{
Electrical Conductivity in dS/m of saturated soil paste extract or its equivalent
}
  \item{ph}{
soil reaction (pH)
}
   \item{criterion}{
The method to use for classifying salt-affected soil. Either FAO or USDA can be selected
}
}
\value{
The output is an integer value for soil salt class. The class name for any integer code is obtained from classCode function
}
\references{
FAO.2006. Guidelines for soil description. FAO. Rome

Richards, L. A. (ed.) 1954. Diagnosis and Improvement of Saline and Alkali Soils. U.S. Department Agriculture Handbook 60. U.S. Gov. Printing Office, Washington, DC.
}
\author{
Christian Thine Omuto
}
\note{
This function gives approximate classification. A better classification is achieved when indicator of sodium ions is included (e.g. ESP)
}
\seealso{
\code{\link{saltClass}}, \code{\link{saltSeverity}}, \code{\link{classCode}}
}
\examples{
library(sp)
saltRating(11.2,8.14, "USDA")

ec=suitabinput["ec"]
ph=suitabinput["ph"]
soc=nutrindicator["soc"]
clay=textureinput["clay"]
texture=suitabinput["texture"]
newmap=ec
newmap$ph=ph$ph
newmap$ECe=ECconversion1(ec$ec,texture$texture,"FAO","1:1", soc$soc,clay$clay)
newmap$salinity=saltRating(newmap$ECe,newmap$ph,"FAO")
newmap$salineclass=classCode(newmap$salinity,"saltclass")
newmap$salineclass1=as.factor(newmap$salineclass)
spplot(newmap["salineclass"], main="Soil Salinity Class")
summary(newmap$salinity)
}

\name{erodibilityRisk}
\alias{erodibilityRisk}
\title{
Determine soil erodibility risk
}
\description{
This function classifies soil erodibility factor into classes of risk to erosion
}
\usage{
erodibilityRisk(x)
}
\arguments{
  \item{x}{
soil erodibility factor value between 0 and 1
}
}
\details{
Erodibility factor ranges between 0 (lowest risk) to 1 (highest risk)
}
\value{
erodibility risk classes
}
\references{
Wischmeier WH, Mannering JV. 1969. Relation of Soil Properties to its Erodibility, Soil and Water Management and Conservation, 15, 131–137
Benavidez R, Bethana J, Maxwell D, Norton K. 2018. A review of the (Revised) Universal Soil Loss Equation ((R)USLE): with a view to increasing its global applicability and improving soil loss estimates. Hydrol. Earth Syst. Sci., 22, 6059–6086
}
\author{
Christian Thine Omuto
}
\seealso{
\code{\link{erosivFUN}}, \code{\link{erodFUN}}, \code{\link{sloplenFUN}}
}
\examples{
library(sp)
erodibilityRisk(0.8)
x=suitabinput
sand=textureinput["sand"]
silt=textureinput["silt"]
clay=textureinput["clay"]
soc=nutrindicator["soc"]
x$permeability=permeabilityClass(x$texture)
x$renard=erodFUN(sand$sand,silt$silt,clay$clay,soc$soc,x$texture, x$structure,"Renard")
x$erodibilityrisk=erodibilityRisk(x$renard)
x$erodib=classCode(x$renard,"erodibility")
summary(x$erodib)
spplot(x["erodib"])
}

\name{getSuit}
\alias{getSuit}
\title{
Deriving categorical suitability classes
}
\description{
A generic model to derive suitability classes given the target information.
The function uses provided limits to derive the suitability classes
}
\usage{
getSuit(x,lim1,lim2,lim3,lim4)
}
\arguments{
  \item{x}{
  Input value of the indicator to be classified
}
  \item{lim1}{
  Lower limit of the highest class
}
  \item{lim2}{
  Lower limit of the second highest class
}
  \item{lim3}{
  Lower limit of the second last class
}
  \item{lim4}{
  Maximum allowable limit for target variable
  }
}
\details{
The function puts the boundary conditions for realistic values of target soil properties
}
\value{
Suitability class values as integers. 1-High, 2-Moderate, 3-Low, 4-Not suitable
}
\author{
Christian Thine Omuto
}
\note{
Negative values are not permitted and will return NA. Similarly, large values out of range are also not permitted}

\seealso{
\code{\link{classLUT}}, \code{\link{classCode}}
}
\examples{
getSuit(1.67,1.2,1.3,1.5,2.6)
}

\name{ME_ECharmserve}
\alias{ME_ECharmserve}
\title{
Harmonization models for soil electrical conductivity
}
\description{
Mixed effects models for harmonizing electrical conductivity (EC)
}
\details{
Suit of mixed-effects models
}
\note{
Internet connectivity is needed for the function to work.
}

\name{predUncertain}
\alias{predUncertain}
\title{
A function to develop spatial map of modelling uncertainty using the bootstrap approach
}
\description{
This functions uses bootstrap approach to estimate spatial maps of modelling prediction interval width and standard deviation
}
\usage{
predUncertain(indata,fgrid, k, z, model="rf")
}
\arguments{
  \item{indata}{
one column input spatial dataframe containing the target soil variable or its transformation
}
  \item{fgrid}{
Input grid or raster stack containing predictors set for the target soil variable }
  \item{k}{
Set limit for number of realizations/simulations for bootstrap algorithm
}
  \item{z}{
Confidence interval level in percent (for example 95)
}
  \item{model}{
The model for predicting target soil variable using the predictors (for example linear)
}
}
\details{
One-variable input dataframe is prefered or at least the first column should have the target soil variable to predict. It should not contain NAs. The number of realizations k need not be too high because the software multiplies it exponentially and may slow down the computing process if set to a high value. For example k=5 will results into more than 40 realizations created
}
\value{
a two-layer raster stack map of prediction width and standard deviation
}
\references{
Efron B. 1992. Jackknife-after-bootstrap standard errors and influence functions.
Journal of the Royal Statistical Society. Series B (Methodological), 83–127.
}
\author{
Christian Thine Omuto
}
\note{
The input dataframe and predictors need to have similar coordinate reference system (CRS). In addition, the input dataframe should not have missing entrie (NAs)
}
\seealso{
\code{\link{regmodelSuit}}, \code{\link{imageIndices}},\code{\link{predAccuracy}}
}
\examples{
library(raster)
library(caret)
soil1=soil[,c("OC")]
predictere=suitabinput[c("depthcodes","rain","texture","dem")]
\donttest{
pred_uncert=predUncertain(soil1,predictere,3,90,"rf")
plot(pred_uncert)
}
}

\name{depthSuit}
\alias{depthSuit}
\title{
Assessing soil depth suitability requirements for certain crops and trees
}
\description{
This function determines the suitability classes for soil depth requirements of selected agricultural crops and forest trees
}
\usage{
depthSuit(value, crop)
}
\arguments{
  \item{value}{
Input soil depth in cm
}
  \item{crop}{
The crop of interest for which soil depth suitability class is sought
}
}
\details{
The input value can be map or just a numerical entry of soil depth in cm
}
\value{
The output is soil depth suitability class for the crop. The output is integer value for suitability class: 1- highly suitable; 2 - moderately suitable; 3 - marginally suitable; 4 - currently not suitable; 5 - not suitable
}
\references{
Sys, C., Van Ranst, E., Debaveye, J. and Beerneaert, F.1993. Land evaluation: Part III: Crop requirements.
Development Cooperation, Belgium.

Naidu, L.G.K., Ramamurthy, V., Challa O., Hegde, R. and Krishnan, P. 2006. Manual, Soil-site Suitability Criteria for Major Crops, National Bureau of Soil Survey and Land Use Planning, ICAR, Nagpur, India

FAO Crop Suitability Requirements: http://ecocrop.fao.org/ecocrop/srv/en/home
}
\author{
Christian Thine Omuto
}
\seealso{
\code{\link{suitability}}, \code{\link{tempSuit}}, \code{\link{fertilitySuit}}
}
\examples{
depthSuit(33,"cashew")
}

\name{classnames}
\alias{classnames}
\title{
Display class names and codes as used in the soilassessment package
}
\description{
This is a database function for displaying the class names and codes used in the soil assessment package
}
\usage{
classnames(indicator)
}
\arguments{
  \item{indicator}{
indicator of soil condition group of interest. Example: texture, suitability, drainage, fertility, erodibility
}
}
\value{
Table of soil condition code and name
}
\seealso{
\code{\link{classCode}}, \code{\link{classLUT}}
}
\examples{
x="texture"
classnames(x)
}

\name{surveyPoints}
\alias{surveyPoints}
\title{
Generate georeferenced locations for monitoring soil conditions
}
\description{
This function uses stratified random sampling to generate georeferenced locations for monitoring soil conditions
}
\usage{
surveyPoints(soilmap,scorpan,conditionclass,mapproportion)
}
\arguments{
  \item{soilmap}{
input classified map of soil condition
}
  \item{scorpan}{
number of scorpan factors that generated teh soil condition map. The range is 1-5
}
  \item{conditionclass}{
reference class in the soil condition map to be monitored. The class code should be in the map
}
  \item{mapproportion}{
Proportion in percent of the reference class in the soil condition map to be monitored.
}
}
\details{
The number of scorpan factors can be assumed but need to be with respect to the soil forming factors.The maximum possible number of factors is 5 irrespective of number of layers in each factor while the minimum number is 1.The soil condition class is the class code in the map which is to be targeted
}
\value{
A spatial points dataframe with projection similar to the soil condition map projection
}
\author{
Christian Thine Omuto
}
\seealso{
\code{\link{featureRep}}, \code{\link{imageIndices}}, \code{\link{pedoTransfer}}
}
\examples{
library(sp)
library(raster)
ec=suitabinput["ec"]
ph=suitabinput["ph"]
soc=nutrindicator["soc"]
clay=textureinput["clay"]
texture=suitabinput["texture"]
newmap=ec
newmap$ph=ph$ph
newmap$ECe=ECconversion1(ec$ec*0.1,texture$texture,"FAO","1:5", soc$soc,clay$clay)
newmap$salt=saltSeverity(newmap$ECe,newmap$ph,0.84,"FAO")
newmap$salineclass=classCode(newmap$salt,"saltseverity")
newmap$salineclass1=as.factor(newmap$salineclass)
spplot(newmap["salineclass"], main="Salinity Code")
summary(newmap$salt)
summary(newmap$salineclass)
salt=raster(newmap["salt"])
n_points=surveyPoints(salt,4,11,30)
length(n_points$layer)
spplot(salt, scales=list(draw=TRUE),sp.layout=list("sp.points",n_points,pch=8,col="cyan"))
}

\name{ME_ECharm}
\alias{ME_ECharm}
\title{
Mixed-effects model for harmonizing soil electrical conductivity to the equivalent conductivity of saturated paste extract
}
\description{
A function for harmonizing soil electrical conductivity to the equivalent conductivity of saturated paste extract using mixed effects approach
}
\usage{
ME_ECharm(EC, TEXCLASS, model, soilsolution)
}
\arguments{
  \item{EC}{
a vector or single value of soil electrical conductivity to be harmonized. It should have been determined in a given soil solution (e.g. 1:2, 1:2.5 or 1:5)
}
  \item{TEXCLASS}{
soil textural class of the soil whose electrical conductivity is to be harmonized. String or test entry of USDA textural classes: Cl, ClLo,Lo,LoSa,Sa,SaCl,SaClLo,SaLo,SiCl,SiClLo,SiLo,Si,CS,MS,HCL,FS. The classes can be determined from Clay, Silt, and Sand proportions using createTexturedata function
}
\item{model}{
functional model for relating EC to be harmonized and equivalent EC of saturated paste extract. Models considered are second order polynomial, sigmoid, spherical, gaussian, exponential, power, and linear functions. The default is polynomial
}
\item{soilsolution}{
– soil:water mix ratio in which electrical conductivity was measured. The function is currently working on 1:2, 1:2.5, and 1:5. The default is 1:2
}
}
\details{
EC harmonization models, which were developed using global datasets, are designed to standardize soil electrical conductivity for applications in soil salt classification
}
\value{
numeric value of equivalent EC of saturated soil paste extract
}
\references{
Omuto, C. T., Vargas, R.-R., EL Mobarak, A., Nuha, M., Viatkin, K., & Yigini, Y. (2020). Mapping of salt-affected soils – Technical manual. FAO. https://doi.org/10.4060/ca9215en

Omuto, C. T., Minasny, B., McBratney, A. B., & Biamah, E. K. (2006). Nonlinear mixed effect modelling for improved estimation of water retention and infiltration parameters. Journal of Hydrology, 330(3–4), 748–758. https://doi.org/10.1016/j.jhydrol.2006.05.006

Pinheiro, J. C., & Bates, D. M. (2000). Mixed-Effects Models in Sand S-PLUS. Springer New York. https://doi.org/10.1007/978-1-4419-0318-1
}
\author{
Christian Thine Omuto
}
\note{
The models are currently developed for soil solutions from 1:2, 1:2.5 and 1:5 soil:water mix ratios. The function only works with USDA soil textural classes. Convert other soil textural classes to USDA classes for all applications with this function.
}
\seealso{
\code{\link{ME_PHharm}}, \code{\link{ECconversion1}}, \code{\link{ECconversion2}}
}
\examples{
ndata=data.frame(EC=c(1,0.34,5.07,12.17, 2.219),TEX=c("Cl","SaCl","LoSa", "SiCl","SaClLo"))
ndata$ESa1=ME_ECharm(ndata$EC,ndata$TEX,"power","1:5")
}

\name{classCode}
\alias{classCode}
\title{
Displaying names of class codes of soil conditions in the soilassessment package
}
\description{
This function displays names of integer classes (or levels) of derived codes of soil conditions produced in the package
}
\usage{
classCode(value, indicator)
}
\arguments{
  \item{value}{
Integer value of the soil condition indicator
}
  \item{indicator}{
Soil condition whose class (x) is sought. The default = "fertility" if fertility is the soil condition
}
}
\details{
This is for interpretation of the integer codes of the soil conditions generated in the package
}
\value{
Name of the level of soil condition
}
\seealso{
\code{\link{classLUT}}, \code{\link{erodFUN}}, \code{\link{classnames}}
}
\examples{
classCode(2,"texture")
suitclas=classCode(4,"suitability")
levels(suitclas)
}

\name{erosivFUN}
\alias{erosivFUN}
\title{
Estimate rainfall erosivity from annual rainfall amounts
}
\description{
This function assumes an algebraic relationship between annual rainfall amounts and rainfall erosivity. The relationship has constants that may depend of certain regions.
}
\usage{
erosivFUN(rain,A,B, model)
}
\arguments{
  \item{rain}{
annual rainfall amounts in mm or Fourier index of rainfall
}
  \item{A}{
independent constant of the algebraic relationship between rainfall mounts and erosive energy (Energy=A+-B*rainfall)
}
  \item{B}{
rainfall coefficient of the algebraic relationship between rainfall mounts and erosive energy (Energy=A+-B*rainfall)
}
  \item{model}{
model defining the algebraic relationship between rainfall mounts and erosive energy. The model can be linear, power, logarithmic, Fourier, and exponential
}
}
\value{
rainfall erosivity in MJ mm/ha/hr/yr
}
\references{
Morgan RPC. 2005. Soil erosion and conservation. Blackwell. UK
Benavidez R, Bethana J, Maxwell D, Norton K. 2018. A review of the (Revised) Universal Soil Loss Equation ((R)USLE): with a view to increasing its global applicability and improving soil loss estimates. Hydrol. Earth Syst. Sci., 22, 6059–6086
}
\author{
Christian Thine
}
\seealso{
\code{\link{erodFUN}}, \code{\link{sloplenFUN}}
}
\examples{
erosivFUN(587,151, 0.63, "linear")
}

\name{RotCmoistcorrection}
\alias{RotCmoistcorrection}
\title{
Estimating moisture effects in RothC carbon turnover modelling
}
\description{
This function estimates the scalar constant representing the moisture effects in RothC carbon turnover modelling in the soil
}
\usage{
RotCmoistcorrection(P, E, S.Thick, clay, pE, fk)
}
\arguments{
  \item{P}{
 the total rainfall amount in mm
}
  \item{E}{
 the total evapotranspiration amounts in mm. It can be pan evapotranspiration or potential evapotranspiration rate
}
  \item{S.Thick}{
 thickness of soil depth in cm (measured from the soil surface)
}
  \item{clay}{
 clay content in percent
}
  \item{pE}{
 proportion of pan evapotranspiration representing potential evapotranspiration rate.
}
  \item{fk}{
 A constant to correct for soil cover. For bare soil, fk=1.8 and for soil with cover, fk=1
}
}
\details{
E can be given as  pan evapotranspiration or potential evapotranspiration. If potential evapotranspiration is used for E, then pE = 1 and if pan evapotranspiration is used for E then pE=0.75.
}
\value{
A scalar constant for moisture effects on carbon decomposition rates
}
\references{
Burke, I., Kaye, J., Bird, S., Hall, S., McCulley, R., Sommerville, G. 2003. Evaluating and testing models of terrestrial biogeochemistry: the role of temperature in controlling decomposition, Models in ecosystem science, Princeton University Press, Princeton, New Jersey, USA, 225–253, 2003

Adair, E., Parton, W., Del Grosso, S., Silver, W., Harmon, M.,Hall, S., Burke, I., and Hart, S. 2008. Simple three-pool model accurately describes patterns of long-term litter decomposition in diverse climates, Global Change Biology, 14: 2636–2660

Coleman, K. and Jenkinson, D. 2014. ROTHC-26.3 A model for the turnover of carbon in soils: Model description and users guide (Windows version). Rothamsted Research Harpenden Herts AL5 2JQ
}
\author{
Christian Thine Omuto
}
\note{
This function can be used with monthly or annual input data to produce time-dependent scalars
}
\seealso{
\code{\link{carbonTurnover}}, \code{\link{RotCtempcorrection}}, \code{\link{NPPmodel}}
}
\examples{
clay=34.5
depth=30
precip=c(73,59,63,51,52,57,34,55,58,56,76,71)
evapo=c(8,10,27,49,83,99,103,91,69,34,16,8)
inCl=data.frame(seq(1,12,1),precip,evapo)
colnames(inCl)=c("month","rain","ET")
inCl$mcor=RotCmoistcorrection(inCl$rain,inCl$ET,depth,clay,0.75,1)
inCl$mcor
}

\name{SASmodels}
\alias{SASmodels}
\title{
Information on available SAS models in the harmonization service
}
\description{
This information function shows the list of EC and pH harmonization models contained in the SAS harmonization service
}
\usage{
SASmodels(data="ec", extract="1:1")
}
\arguments{
  \item{data}{
either ec or ph data category for SAS harmonization models
}
\item{extract}{
extract solution for measuring ec or ph.
}
 }
\details{
This information function shows available models in the SAS harmonization service. The models are divided into two major categories: ec and ph models. The function returns a list of available SAS harmonization models under each data category. ec is the default data category.
}
\value{
A list of SAS harmonization models
}

\author{
Christian Thine Omuto
}
\seealso{
\code{\link{SASglobeData}}, \code{\link{DataAvailabilityIndex}}
}
\examples{
SASmodels("ec", "1:1")
SASmodels("ph","kcl")
}

\name{checkInternet}
\alias{checkInternet}
\title{
Checking internet connectivity for functions with remote call
}
\description{
This is for testing and reporting url of remote servers for graceful fail in functions which use remote call
}
\usage{
checkInternet(dbase_file)
}

\arguments{
  \item{dbase_file}{
url address of the remote server
}
}
\details{
It carries out three tests on the given url: 1- if the url fetch times out , 2- if there is no internet connection, and 3- if there is bad path name and passes a message when their is failure.
}
\value{
a response message (Time out or error 404 or No internet connection) or data.frame of available data
}
\author{
Christian Thine Omuto
}

\examples{
xx="https://docs.google.com/spreadsheets/d/e"
checkInternet(xx)
}

\name{textureinput}
\alias{textureinput}
\docType{data}
\title{
Sample texture dataset for mapping soil texture
}
\description{
Sample dataset for assessing soil texture
}
\usage{data("textureinput")}
\format{
  The format is:
Formal class 'SpatialGridDataFrame' [package "sp"] with 4 slots
  ..@ data       :'data.frame':	16900 obs. of  3 variables:
  .. ..$ sand: num [1:16900] 61.5 59.8 60.6 58.2 59.1 ...
  .. ..$ clay: num [1:16900] 12.6 13.9 14.1 13.8 13.8 ...
  .. ..$ silt: num [1:16900] 25 26.9 25.3 28 26.9 ...
  ..@ grid       :Formal class 'GridTopology' [package "sp"] with 3 slots
  .. .. ..@ cellcentre.offset: Named num [1:2] 383216 3341506
  .. .. .. ..- attr(*, "names")= chr [1:2] "x" "y"
  .. .. ..@ cellsize         : num [1:2] 357 357
  .. .. ..@ cells.dim        : int [1:2] 130 130
  ..@ bbox       : num [1:2, 1:2] 383038 3341327 429478 3387767
  .. ..- attr(*, "dimnames")=List of 2
  .. .. ..$ : chr [1:2] "x" "y"
  .. .. ..$ : chr [1:2] "min" "max"
  ..@ proj4string:Formal class 'CRS' [package "sp"] with 1 slot
  .. .. ..@ projargs: chr "+proj=utm +zone=41 +datum=WGS84 +units=m +no_defs"
}
\examples{
data(textureinput)
summary(textureinput)
}
\keyword{datasets}

\name{featureRep}
\alias{featureRep}
\title{
Assess how well landscape features are represented in descrete samples
}
\description{
This function establishes graphical representation of the landscape feature in the sample points. An approximation of Kolmogorov-Smirnov similarity test (D-statistic) between the sampled feature distribution and the population feature distribution is also given.
}
\usage{
featureRep(fgrid,df )
}
\arguments{
  \item{fgrid}{
raster grid of the landscape feature
}
  \item{df}{
dataframe of sampled locations with similar coordinate reference system (CRS) as the input raster map
}
}
\details{
The sampled points should have the same coordinate system as the landscape feature (raster map). The function extracts the raster map values, attaches them to the sample points, and creates histogram distributions: one for the feature map as contained in the sample points and another as contained in the raster map.
}
\value{
Histograms on back-to-back showing distribution of the landscape feature in the sampled points and on the map for similarity comparison
}
\references{
Kolmogorov, A. N. 1933. Sulla determinazione empirica di una legge di distribuzione. Giornale dell’ Istituto Italiano degli Attuari 4: 83–91

Simard R, L'Ecuyer P. 2011. Computing the Two-Sided Kolmogorov–Smirnov Distribution. Journal of Statistical Software. 39 (11): 1–18. doi:10.18637/jss.v039.i11
}
\author{
Christian Thine Omuto
}
\note{
The input points dataframe and raster map must have similar coordinate reference system.
}

\seealso{
\code{\link{imageIndices}}
}
\examples{
library(Hmisc)
data(soil)
dem=suitabinput["dem"]
featureRep(dem,soil)
}

\name{DataAvailabilityIndex}
\alias{DataAvailabilityIndex}
\title{
Showing sampling point density map in a geographic area
}
\description{
An index map of density of sampling points in a geographic area
}
\usage{
DataAvailabilityIndex(Boundary, Scale, CP, Data)
}
\arguments{
  \item{Boundary}{
a spatial polygon or data frame of coordinates of vertices of a bounding geographic area where data search is intended
}
 \item{Scale}{
unit area to show spatial density of available sampled points
}
 \item{CP}{
coordinate projection of the Boundary spatial polygon
}
 \item{Data}{
input spatial spreadsheet database containing all possible point samples
}
}
\details{
The input spreadsheet database should contain spatial coordinates of available samples. Example input spatial spreadsheet database is the global soil database.The Scale should be provided in area units e.g., 0.5, 1, 20, 30 (square km). Large areas cover more data than small areas. Hence, they take time to process. Coordinate projection (CP) for Boundary polygon should be of formal class crs (coordinate reference system). It's preferrable to provide CP for Boundary area similar to CP for input data
}
\value{
A spatial raster map of density of sample locations per unit (specified) area
}
\author{
Christian Thine Omuto
}
\note{
Scales less than 0.1 square km may be too small for search. Large scales (say 10000 square km) may be too large and take time to process
}
\examples{
\donttest{
library(sp)
library(raster)
library(terra)
library(sf)
x <- c(20.02,25.69,25.69,20.02)
y <- c(-28.40,-32.76,-32.76,-34.84)
yx=data.frame(cbind(x, y))
CRs="+proj=longlat +datum=WGS84 +no_defs"
Data=SASglobeData("ph","ZAF")
coordinates(Data)=~Longitude+Latitude
crs(Data)=CRs
Index=DataAvailabilityIndex(yx,60,CRs,Data)
plot(Index)
}
}

\name{nutrient}
\alias{nutrient}
\docType{data}
\title{
Sample data of decision ranking table for mapping soil nutrient condition
}
\description{
This is an 11-factor table of decision ranking of soil nutrient indicators
}
\usage{data("nutrient")}
\format{
  A dataframe with 11 factors for pairwise decision ranking of soil nutrient indicators.
   }
\details{
The ranks are the recipricals of Saaty's scale of relative importance which are between 1 and 9
}
\source{
Hypothetical data of rank between soil nutrient indicators
}
\examples{
data(nutrient)
str(nutrient)
plot(nutrient)
}
\keyword{datasets}

\name{PHharm_Info}
\alias{PHharm_Info}
\title{
Information on performance of soil pH (water) harmonization models
}
\description{
Information index for relative predictive performance of soil pH harmonization models
}
\usage{
PHharm_Info(solution)
}
\arguments{
  \item{solution}{
solution for measuring soil pH
}
}
\details{
Solution for measuring soil pH. It’s given in quotation marks. Current models consider “cacl2” and “kcl” ratios. Default solution is “cacl2”
}
\value{
Graphical display of the predictive performance index for the harmonization models in different regions of the world: Africa, Asia, Near East and North Africa (NENA), Latin America and Caribbean (LAC), north America, and Europe. The performance index ranges between 0 (poor) to 1 (best).
}
\author{
Christian Thine Omuto
}
\note{
The function currently works for cacl2 and kcl. These solutions must be entered in quotation marks.Due to periodic update,internet connectivity is needed for the function to work.
}
\seealso{
\code{\link{ECharm_Info}}, \code{\link{SASdata_densityInfo}}
}
\examples{
# Internet connectivity is required to run the function as PHharm_Info("kcl")
Index=data.frame(Kabala=c(0.866,0.846,0.844,0.765,0.791,0.168,0.701),
                 Sadovski=c(0.898,0.846,0.863,0.752,0.802,0.094,0.740),
                 Polynomial=c(0.861,0.815,0.820,0.769,0.778,0.166,0.698),
                 Power=c(0.875,0.807,0.825,0.733,0.765,0.112,0.715),
                 Sigmoid=c(0.850,0.814,0.815,0.760,0.778,0.142,0.700),
                 Linear=c(0.875,0.807,0.825,0.733,0.765,0.112,0.715),
                 Gaussian=c(0.848,0.815,0.815,0.762,0.779,0.148,0.701),
                 Spherical=c(0.848,0.814,0.818,0.762,0.779,0.142,0.703),
                 Exponential=c(0.863,0.813,0.818,0.753,0.774,0.108,0.713))
rownames(Index)=c("Africa","America","Asia","Europe","LAC","NENA","Pacific")
regioncol=c("blue","red","cyan","magenta","green","gray", "yellow")
par(mgp=c(3,0.6,0),mar=c(5,4.5,1,1)+0.1)
Index=as.matrix(Index)
barplot(Index, las=2,beside = TRUE,xpd = FALSE,col=regioncol,ylim=c(0,1.2),
horiz = FALSE, cex.names = 0.75,space = c(0.4, 4))
legend("topleft", x.intersp=0.25,y.intersp=0,bg="transparent",text.width=11,
legend = rownames(Index), fill = regioncol, box.lty = 0, cex = 0.6, horiz = TRUE)
box(lty = 1, col = 'black')
mtext(side=1, text="PH harmonization models", line=3.7)
mtext(side=2, text="Performance index", line=2.5)
}

\name{comparisonTable}
\alias{comparisonTable}
\title{
Normalizing decision ranking table
}
\description{
This function normalizes the decision ranking table and determines consistency of the decisions
}
\usage{
comparisonTable(df)
}
\arguments{
  \item{df}{
A matrix of rank decisions with complete column names.
}
}
\details{
The column names of the rank-decision table should correspond with the names of the criteria maps
}
\value{
nmtx: a normalized pairwise comparison matrix
crt: consistency index and message on whether the input decisions are consistent for analysis
}
\references{
Barzilai J. and Golany B., 1990. Deriving Weights from Pairwise Comparison Matrices: the Additive Case. Operations Research Letters 9: 407–410.
}
\author{
Christian Thine Omuto
}
\seealso{
\code{\link{suitability}}, \code{\link{fertilitySuit}}
}
\examples{
data(nutrient)
library(FuzzyAHP)
comparisonTable(nutrient)
}

\name{suitability}
\alias{suitability}
\title{
Determine soil suitability for agricultural crops
}
\description{
This function determines soil condition classes (such as suitability, fertility, etc.) given a set of indicators.
}
\usage{
suitability(df,data)
}
\arguments{
  \item{df}{
normalized pairwise decision (nxn) matrix for comparing n soil suitability (condition) factors
}
  \item{data}{
a (nxm) matrix of n suitability (condition) factors for m locations (pixels)
}
}
\value{
A vector of soil suitability (condition) class between 0 and 5.
}
\references{
FAO, 1976. A framework for land evaluation. FAO Soils Bulletin 32

Saaty TL. 1980. The Analytic Hierarchy Process. McGraw-Hill, New York
}
\author{
Christian Thine Omuto
}
\note{
It's important to normalize and assess the adequacy of the decision matrix before using this function
}
\seealso{
\code{\link{fertilityRating}}, \code{\link{suitabilityClass}}
}
\examples{
library(sp)
newmap=(nutrindicator)
newmap$carbon=fertilityRating((nutrindicator$soc),"carbon")
newmap$nitrogen=fertilityRating((nutrindicator$nitrogen),"nitrogen")
newmap$potassium=fertilityRating((nutrindicator$potassium),"potassium")
newmap$phosphorus=fertilityRating((nutrindicator$phosphorus),"phosphorus")
newmap$iron=fertilityRating((nutrindicator$iron),"iron")
newmap$zinc=fertilityRating((nutrindicator$zinc),"zinc")
newmap$manganese=fertilityRating((nutrindicator$manganese),"manganese")
newmap$copper=fertilityRating((nutrindicator$copper),"copper")
newmap$cec=fertilityRating((nutrindicator$cec),"cec")
newmap$boron=fertilityRating((nutrindicator$boron),"boron")
newmap$sulfur=fertilityRating((nutrindicator$sulfur),"sulfur")
newmap$soc=NULL
newmapT1=newmap@data
valuT=as.matrix(newmapT1)
data("nutrient")
nutriens=comparisonTable(nutrient)
\donttest{
newmapT1$fertility=suitability(nutrient, valuT)
newmap@data$fertility=newmapT1$fertility
newmap$fertilityclass2=classCode(newmap$fertility,"fertility")
spplot(newmap["fertility"])
summary(newmap$fertilityclass2)
}
}

\name{VegCOV}
\alias{VegCOV}
\title{
Detrmining Erosion Cover Factor (C Factor) from Vegetation Cover Fraction
}
\description{
To estimate erosion model cover factor from vegetation cover fraction
}
\usage{
VegCOV(pcover, model="cai")
}
\arguments{
  \item{pcover}{
percent vegetation cover
}
 \item{model}{
model for estimating C factor from percent vegetation cover
}
}
\details{
This function can be used to estimate the C factor for erosion modelling by use of percent vegetation cover. The function contains five models: cai, xu, hurni, jin, and liu. When the percent cover ('pcover') is given and the model to use (e.g., 'cai'), the function returns dimensionless C factor for erosion modelling. C factor ranges between 0 and 1 (0< cfactor<=1)
}
\value{
A numerical value between 0 and 1
}
\references{
C.F. Cai, S.W. Ding, Z.H. Shi, L. Huang, G.Y. Zhang. Study of applying USLE and geographical information system IDRISI to predict soil erosion in small watershed. J. Soil Water Conserv., 14 (2) (2000), pp. 19-24

Taye, G., Vanmaercke, M., Poesen, J., Van Wesemael, B., Tesfaye, S., Teka, D., Nyssen, J., Deckers, J., Haregeweyn, N., 2018. Determining RUSLE P‐ and C‐factors for stone bunds and trenches in rangeland and cropland, North Ethiopia. Land Degrad Dev 29, 812–824. https://doi.org/10.1002/ldr.2814
}
\author{
Christian Thine Omuto}
\note{
The function does not accept percent cover values that are less than 0 and more than 100.
}


\seealso{
\code{\link{NDVIcoverfactor}}
}
\examples{
VegCOV(20,"cai")
}

\name{predAccuracy}
\alias{predAccuracy}
\title{
Accuracy assessment between an array of two variables
}
\description{
This function calculates statistical indices for accuracy between an array of two variables such as calibration and validation vectors. The indices are Bias, RMSE, R-squared, and NSE
}
\usage{
predAccuracy(x,y)
}

\arguments{
  \item{x}{
a numeric vector of first variable of the two variables for accuracy assessment
}
 \item{y}{
a numeric vector of second variable of the two variables for accuracy assessment
}
}
\details{
The function calculates four indices for accuracy: bias, root mean square error (RMSE), r-squared, Nash-sutcliffe efficiency (NSE)
}
\value{
A table of four variables: bias, RMSE, Rsquared, and NSE
}
\references{
Becker, R. A., Chambers, J. M. and Wilks, A. R. 1988. The New S Language. Wadsworth & Brooks/Cole.

Nash, J. E.; Sutcliffe, J. V. (1970). "River flow forecasting through conceptual models part I — A discussion of principles". Journal of Hydrology. 10 (3): 282–290
}
\author{
Christian Thine Omuto
}

\seealso{
\code{\link{predUncertain}}, \code{\link{featureRep}}
}
\examples{
xy=data.frame(a=c(2,3,4,5,6,7,8,9),b=c(1,1.5,8,10,12,3.5,NA,18))
predAccuracy(xy$a,xy$b)$Rsquared
}

\name{demSuit}
\alias{demSuit}
\title{
Assessing elevation suitability requirements for certain crops and trees
}
\description{
This function determines the suitability classes for elevation requirements for selected agricultural crops and forest trees
}
\usage{
demSuit(value, crop)
}
\arguments{
  \item{value}{
Input elevation in meter.
}
 \item{crop}{
The crop of interest for which elevation suitability class is sought.
}
}
\details{
The input value can be map or just a numerical entry of elevation in meters
}
\value{
The output is elevation suitability class for the crop. The output is integer value for suitability class: 1- highly suitable; 2 - moderately suitable; 3 - marginally suitable; 4 - currently not suitable; 5 - not suitable
}
\references{
Sys, C., Van Ranst, E., Debaveye, J. and Beerneaert, F.1993. Land evaluation: Part III: Crop requirements.
Development Cooperation, Belgium.

Naidu, L.G.K., Ramamurthy, V., Challa O., Hegde, R. and Krishnan, P. 2006. Manual, Soil-site Suitability Criteria for Major Crops, National Bureau of Soil Survey and Land Use Planning, ICAR, Nagpur, India

FAO Crop Suitability Requirements: http://ecocrop.fao.org/ecocrop/srv/en/home
}
\author{
Christian Thine Omuto
}
\note{
Should the input value be raster map, then the output will also be a raster map of elevation suitability for the crop of interest
}
\seealso{
\code{\link{suitability}}, \code{\link{PHSuit}}, \code{\link{fertilitySuit}}
}
\examples{
demSuit(1208,"maize")
}

\name{erodFUN}
\alias{erodFUN}
\title{
Estimate soil erodibility factor
}
\description{
A function to determine soil erodibility factor from a choice of different erodibility models
}
\usage{
erodFUN(sand,silt,clay,OC,texture,Struct,method)
}
\arguments{
  \item{sand}{
sand proportion (percent) of the soil texture
}
  \item{silt}{
silt proportion (percent) of the soil texture
}
  \item{clay}{
clay proportion (percent) of the soil texture
}
  \item{OC}{
soil carbon content (percent)
}
  \item{texture}{
soil texture code representing the USDA soil textural class. Use classnames("texture") to insert the correct texture code
}
  \item{Struct}{
soil structure code representing the soil structure class. Use classnames("structure") to insert the correct structure code
}
  \item{method}{
method for determining soil erodibility. The following methods are included: WSmith,Yang,Renard,Bouyoucos,Denardin,Wang,Wisch1,Wisch2,Sharpley,Cheng,Auer.
}
}
\value{
soil erodibility factor ranging between 0 and 1
}
\references{
Benavidez R, Bethana J, Maxwell D, Norton K. 2018. A review of the (Revised) Universal Soil Loss Equation ((R)USLE): with a view to increasing its global applicability and improving soil loss estimates. Hydrol. Earth Syst. Sci., 22, 6059–6086

Omuto CT and Vargas R. 2009. Combining pedometrics, remote sensing and field observations for assessing soil loss in challenging drylands: a case study of northwestern Somalia. Land Degrad. Develop. 20: 101–115
}
\author{
Christian Thine Omuto
}
\seealso{
\code{\link{erosivFUN}}, \code{\link{erodibilityRisk}}, \code{\link{sloplenFUN}}
}
\examples{
library(sp)
bx=suitabinput
sand=textureinput["sand"]
silt=textureinput["silt"]
clay=textureinput["clay"]
soc=nutrindicator["soc"]
bx$permeability=permeabilityClass(bx$texture)
bx$wsmith=erodFUN(sand$sand,silt$silt,clay$clay,soc$soc,bx$texture, bx$structure,"WSmith")
bx$renard=erodFUN(sand$sand,silt$silt,clay$clay,soc$soc,bx$texture, bx$structure,"Renard")
summary(bx$renard)
spplot(bx["wsmith"])
}

\name{classLUT}
\alias{classLUT}
\title{
Developing Look-up Table (LUT) for the soil condition class map
}
\description{
This function develops a Look-Up Table (LUT) for the class type map of soil condition. LUT is important map legends or maps re-classification.
}
\usage{
classLUT(fgrid,indicator)
}
\arguments{
  \item{fgrid}{
Input classified map
}
  \item{indicator}{
The soil condition indicator of interest as contained in the input map for example, "texture", "salinity", etc.
}
}
\details{
The input raster map should contain only one band for the soil indicator for clear identification of the band.
}
\value{
The output is a dataframe containing classes in the map and corresponding unique integers
}
\author{
Christian Thine Omuto
}
\seealso{
\code{\link{classCode}}, \code{\link{classnames}}
}
\examples{
textrd=suitabinput["texture"]
\donttest{
LUT=classLUT(textrd,"texture")
LUT
}
}

\name{appendTextureclass}
\alias{appendTextureclass}
\title{
Attaching soil textural classes
}
\description{
This function attaches soil textural classes according to different soil texture classification systems
}
\usage{
appendTextureclass(df, method)
}
\arguments{
  \item{df}{
dataframe with columns of soil textural proportions clay, silt, and sand in percentages
}
  \item{method}{
soil texture classification method for calculating soil texture. Default=USDA method
}
}
\details{
df is an output of createTexturedata or similar dataframe with normalized proportions summing to 100%.
method is the texture classification method for textural class calculation. Exanple methods are USDA, FAO, Australian, German, etc.
}
\value{
Output is a soil texture dataframe with textural classes for every row (or pixel) in the dataframe. The output may sometimes return double class such as "SaLo, Lo" implying possibility of a tie for two classes. Such outputs should be edited outside the package for meaningful representation of soil textural classes when necessary
}
\references{
Moyes J. 2018. The soil texture wizard: R functions for plotting, classifying, transforming and exploring soil texture data. https://cran.r-project.org/web/packages/soiltexture/vignettes/soiltexture_vignette.pdf
}
\author{
Christian Thine Omuto
}
\note{
This function can sometimes return double classes such as "SaLo, Lo" implying possibility of a tie for two classes.
}
\seealso{
\code{\link{textureSuit}}, \code{\link{createTexturedata}}
}
\examples{
library(soiltexture)
newtxt=textureinput
\donttest{
texturedata=createTexturedata(newtxt$clay, newtxt$silt, newtxt$sand)
newtxt1=appendTextureclass(as.data.frame(texturedata), method = "USDA")
levels(as.factor(newtxt1$TEXCLASS))
}
}

\name{suitabilityClass}
\alias{suitabilityClass}
\title{
Determine suitability classes for given indicator values
}
\description{
This function determines the suitability class to which a given indicator value falls based on the crop requirement
}
\usage{
suitabilityClass(value,crop,factor)
}
\arguments{
  \item{value}{
Input indicator value.
}
  \item{crop}{
The crop of interest for which suitability is determined.
}
  \item{factor}{
The suitability factor for crop requirement. Example factors include: rain, slope, carbonate, EC, ESP, depth, ph, temperature,
}
}
\value{
The output is rainfall suitability class for the crop. The output is integer value for suitability class: 1- highly suitable; 2 - moderately suitable; 3 - marginally suitable; 4 - currently not suitable; 5 - not suitable
}
\references{
Sys, C., Van Ranst, E., Debaveye, J. and Beerneaert, F.1993. Land evaluation: Part III: Crop requirements.
Development Cooperation, Belgium.

Naidu, L.G.K., Ramamurthy, V., Challa O., Hegde, R. and Krishnan, P. 2006. Manual, Soil-site Suitability Criteria for Major Crops, National Bureau of Soil Survey and Land Use Planning, ICAR, Nagpur, India

FAO Crop Suitability Requirements: http://ecocrop.fao.org/ecocrop/srv/en/home
}
\author{
Christian Thine Omuto
}
\note{
This function assumes rainfall as the source of water for crop development. The input slope value must be in degrees
}
\seealso{
suitability,slopeSuit, tempSuit
}
\examples{
library(sp)
library(raster)
suitabilityClass(20.14,"saffron","slope")
slope=suitabinput["slope"]
slope$tea=slopeSuit(slope$slope,"tea")
slope$saffron=suitabilityClass(slope$slope,"saffron","slope")
summary(slope$saffron)
spplot(slope["tea"], main="Slope suitability for tea")
spplot(slope["saffron"], main="Slope suitability for saffron")
}

\name{NDVIcoverfactor}
\alias{NDVIcoverfactor}
\title{
Estimating Cover Factor for Erosion Models Using NDVI Remote Sensing Index for Vegetation
}
\description{
This function estimates the C factor of erosion models using NDVI derived from remote sensing images
}
\usage{
NDVIcoverfactor(ndvi, model="kniff")
}

\arguments{
  \item{ndvi}{
remote sensing index for vegetation
}
 \item{model}{
model for relating ndvi with C factor
}
}
\details{
The function uses empirical models from the literature. It currently has 15 models: kniff, patil, almagro, jamshidi, dejong, toumi, gitas, joshi, durigon, wickama, suriyaprasit, lin, bahrawi, kulikov, power, modis.
}
\value{
a numeric value between 0 and 1 .
}
\references{
Ayalew, D.A., Deumlich, D., Šarapatka, B., Doktor, D., 2020. Quantifying the Sensitivity of NDVI-Based C Factor Estimation and Potential Soil Erosion Prediction using Spaceborne Earth Observation Data. Remote Sensing 12, 1136. https://doi.org/10.3390/rs12071136


Mahgoub, M., Elalfy, E., Soussa, H., Abdelmonem, Y., 2024. Relation between the soil erosion cover management factor and vegetation index in semi-arid basins. Environ Earth Sci 83, 337. https://doi.org/10.1007/s12665-024-11593-3

}
\author{
Christian Thine Omuto
}
\note{
Some models may return negative values, which are masked out in the function or may return warning
}


\seealso{
\code{\link{VegCOV}}
}
\examples{
NDVIcoverfactor(0.27,"modis")

library(raster)
library(sp)
r <- raster(xmn= 35.5, ymn= -1.5, xmx = 37.5,ymx = 1.5, res = c(0.01,0.01),
            crs = '+proj=latlon +datum=WGS84 +no_defs')
r <- setValues(r, sample(x=0:1, size=ncell(r), replace=TRUE))
r$s2=NDVIcoverfactor(values(r),"modis")
plot(r$s2)
}

\name{fertilitySuit}
\alias{fertilitySuit}
\title{
Assessing soil fertility suitability requirements for certain crops
}
\description{
This function determines the suitability classes for soil fertility requirements of selected agricultural crops
}
\usage{
fertilitySuit(value, crop)
}
\arguments{
  \item{value}{
Input soil fertility index.
}
  \item{crop}{
The crop of interest for which soil fertility suitability class is sought.
}
}
\details{
The input value can be map or just a numerical entry of soil fertility index
}
\value{
The output is fertility suitability class for the crop. The output is integer value for suitability class: 1- highly suitable; 2 - moderately suitable; 3 - marginally suitable; 4 - currently not suitable; 5 - not suitable
}
\references{
Sys, C., Van Ranst, E., Debaveye, J. and Beerneaert, F.1993. Land evaluation: Part III: Crop requirements.
Development Cooperation, Belgium.

Naidu, L.G.K., Ramamurthy, V., Challa O., Hegde, R. and Krishnan, P. 2006. Manual, Soil-site Suitability Criteria for Major Crops, National Bureau of Soil Survey and Land Use Planning, ICAR, Nagpur, India

FAO Crop Suitability Requirements: http://ecocrop.fao.org/ecocrop/srv/en/home
}
\author{
Christian Thine Omuto
}
\note{
If the input value is raster map, then the output will also be a raster map of fertility suitability for the crop of interest
}
\seealso{
\code{\link{suitability}}, \code{\link{ESPSuit}}, \code{\link{fertilityRating}}
}
\examples{
library(sp)
library(FuzzyAHP)
library(raster)
fertilitySuit(1.56, "melon")
newmap=(nutrindicator)
newmap$carbon=fertilityRating((nutrindicator$soc),"carbon")
newmap$nitrogen=fertilityRating((nutrindicator$nitrogen),"nitrogen")
newmap$potassium=fertilityRating((nutrindicator$potassium),"potassium")
newmap$phosphorus=fertilityRating((nutrindicator$phosphorus),"phosphorus")
newmap$iron=fertilityRating((nutrindicator$iron),"iron")
newmap$zinc=fertilityRating((nutrindicator$zinc),"zinc")
newmap$manganese=fertilityRating((nutrindicator$manganese),"manganese")
newmap$copper=fertilityRating((nutrindicator$copper),"copper")
newmap$cec=fertilityRating((nutrindicator$cec),"cec")
newmap$boron=fertilityRating((nutrindicator$boron),"boron")
newmap$sulfur=fertilityRating((nutrindicator$sulfur),"sulfur")
newmap$soc=NULL
newmapT1=newmap@data
valuT=as.matrix(newmapT1)
data("nutrient")
nutriens=comparisonTable(nutrient)
\donttest{
newmapT1$fertility=suitability(nutrient, valuT)
newmap@data$fertility=newmapT1$fertility
newmap$fertilityokra=fertilitySuit(newmap$fertility,"okra")
fertility=raster(newmap$fertilityokra)
spplot(fertility, main="Fertility suitability map for Okra")
}
}

\name{fertilityRating}
\alias{fertilityRating}
\title{
Determining soil fertility levels for given soil property (fertility indicator)
}
\description{
This function determines the fertility levels given values of a soil property
}
\usage{
fertilityRating(value, indicator = "nitrogen")
}
\arguments{
  \item{value}{
numerical value of soil property
}
  \item{indicator}{
soil property as fertility indicator
}
}
\details{
The units for input values are: nitrogen (percent), phosphorus (mg/kg); potassium (cmol(+)/kg);carbon(percent);iron(mg/kg);zinc(mg/kg);manganese(mg/kg);boron(mg/kg);copper(mg/kg);sulfur(mg/kg); CEC(cmol(+)/kg)
}
\value{
soil fertility class code for the given soil property (fertility indicator)
}
\references{
FAO, 1976. A framework for land evaluation. FAO Soils Bulletin 32
Sanchez PA, Couto W, Buol SW. 1982. The fertility capability soil classification system: Interpretation, applicability, and modification

Sanchez PA, Palm CA, Buol SW. 2003. Fertility capability soil classification: a tool to help assess soil quality in the tropics. Geoderma 114, 157 –185.
}
\author{
Christian Thine Omuto
}
\seealso{
\code{\link{suitability}}, \code{\link{saltRating}}, \code{\link{fertilitySuit}}
}
\examples{
library(sp)
newmap=nutrindicator["iron"]
newmap$ironclass=fertilityRating(newmap$iron,"iron")
summary(newmap$iron)
spplot(newmap["ironclass"])
}

\name{ECharm_Info}
\alias{ECharm_Info}
\title{
Information on performance of soil electrical conductivity (EC) harmonization models
}
\description{
Information index for relative predictive performance of soil EC harmonization models
}
\usage{
ECharm_Info(solution)
}
\arguments{
  \item{solution}{
ratio of soil-water solution for the extract used in measuring electrical conductivity.
}
}
\details{
Ratio in text format for the soil-water solution for the extract used in measuring EC. It’s given in quotation marks. Current models consider “1:2”, “1:2.5”, and “1:5” ratios. Default ratio is “1:2”
}
\value{
Graphical display of the predictive performance index for the harmonization models in different regions of the world: Africa, Asia, Near East and North Africa (NENA), Latin America and Caribbean (LAC), north America, and Europe. The performance index ranges between 0 (poor) to 1 (best).
}
\author{
Christian Thine Omuto
}
\note{
The function currently works for 1:2, 1:2.5, and 1:5. These ratios must be entered in quotation marks.Due to periodic update,internet connectivity is needed for the function to work.
}
\seealso{
\code{\link{PHharm_Info}}, \code{\link{SASdata_densityInfo}}
}
\examples{
# Internet connectivity is required to run the function as ECharm_Info("1:2")
Index=data.frame(Africa=c(-0.49,-0.39,-0.24,0.77,0.6,0.75,0.6,0.73,0.79,0.37),
                 America=c(0.48,-0.33,-0.22,0.82,0.71,0.7,0.67,0.63,0.7,0.49),
                 Asia=c(0.23,-0.33,0.12,0.88,0.81,0.45,0.78,0.55,0.44,0.61),
                 Europe=c(0.34,-0.21,-0.12,0.84,0.34,0.01,0.55,0.71,0.08,0.77),
                 LAC=c(0.45,-0.81,0.59,0.05,0.38,-0.13,0.38,-0.14,0.08,0.19),
                NENA=c(0.51,0.53,-0.21,0.88,0.77,0.23,0.56,0.77,0.75,0.54),
                 Pacific=c(0.54,0.57,0.44,0.78,0.74,0.82,0.74,0.79,0.78,0.73))
rownames(Index)=c("FAO","Sonmez","Ozcan","Polynomial","Power","Sigmoid","Linear",
"Gaussian","Spherical","Exponential")
regioncol=c("blue","red","cyan","magenta","green","gray", "yellow","brown",
"darkolivegreen","orange")
par(mgp=c(3,0.6,0),mar=c(5,4.5,1,1)+0.1)
Index=as.matrix(Index)
barplot(Index, las=2,beside = TRUE,xpd = FALSE,col=regioncol,ylim=c(0,1.2),
horiz = FALSE, cex.names = 0.75,space = c(0.4, 4))
legend("topleft", x.intersp=0.25,y.intersp=0,bg="transparent",text.width=11,
legend = rownames(Index), fill = regioncol, box.lty = 0, cex = 0.6, horiz = TRUE)
box(lty = 1, col = 'black')
mtext(side=1, text="Regions of the World", line=3.7)
mtext(side=2, text="Performance index", line=2.5)
}

\name{saltClass}
\alias{saltClass}
\title{
Classify types of salt-affected soils using EC, PH, and ESP
}
\description{
This function determines the major classes of salt-affected soils using Electrical Conductivity (EC), soil reaction (pH), and Exchangeable Sodium Percent (ESP) according to FAO or USDA classification schemes
}
\usage{
saltClass(ec,ph,esp)
}
\arguments{
  \item{ec}{
Electrical Conductivity in dS/m of saturated soil paste extract or its equivalent
}
  \item{ph}{
soil reaction (pH)
}
  \item{esp}{
Exchangeable Sodium Percent
}
}
\value{
saltClass returns integer classes of salt problems in the soil. The classes are 1, 2, 3, 4, 5 corresponding to None, Saline, Saline-sodic, Sodic, and Alkaline categories.
}
\references{
FAO.2006. Guidelines for soil description. FAO. Rome

Richards, L. A. (ed.) 1954. Diagnosis and Improvement of Saline and Alkali Soils. U.S. Department Agriculture Handbook 60. U.S. Gov. Printing Office, Washington, DC.
}
\author{
Christian Thine Omuto
}
\note{
ESP is mandatory when using this function. The "error: 1 * ESP : non-numeric argument to binary operator" is flagged when ESP entry is missing. In case ESP is missing, saltRating is suggested.
}
\seealso{
\code{\link{saltRating}}, \code{\link{saltSeverity}}, \code{\link{classCode}}
}
\examples{
saltClass(6.12,7.84,1)
}

\name{SASdata_densityInfo}
\alias{SASdata_densityInfo}
\title{
Information on global spatial distribution of locations with measured soil properties for salt-affected soils (SAS)
}
\description{
Global distribution of sampling points with measured soil property data
}
\usage{
SASdata_densityInfo(data)
}
\arguments{
  \item{data}{
type of measured soil data in the global database of SAS information. There are three categories of soil data: ec, ph, texture.
}
}
\details{
The function accepts three input alternatives for querrying available SAs information: "ec", "ph", and "texture". The default is "ec"
}
\value{
Spatial maps of sampling locations with measured soil data for SAS information. They include maps of electrical conductivity (ec), pH, texture (sand, silt, clay percentages), and cation exchange capacity (CEC). Locations for CEC are similar to those for texture.
}
\references{
Batjes, N.H., Ribeiro, E., van Oostrum, A., 2020. Standardised soil profile data to support global mapping and modelling (WoSIS snapshot 2019). Earth Syst. Sci. Data 12, 299–320. https://doi.org/10.5194/essd-12-299-2020

FAO/IIASA/ISRIC/ISS-CAS/JRC, 2012. Harmonized World Soil Database (version 1.2). FAO and IIASA, Rome.
}
\author{
Christian Thine Omuto
}
\note{
The function currently works for ec, ph, and texture. Distribution of locations for texture is similar to those for CEC. The input for this function must be entered in quotation marks. Internet connectivity is needed for the function to work.
}
\seealso{
\code{\link{DataAvailabilityIndex}}, \code{\link{PHharm_Info}}
}
\examples{
\donttest{
SASdata_densityInfo("ec")
}
}

\name{permeabilityClass}
\alias{permeabilityClass}
\title{
Determine permeability class
}
\description{
This function determines the soil permeability classes according to the USDA soil textural classes
}
\usage{
permeabilityClass(texture)
}
\arguments{
  \item{texture}{
is a string decribing soil textural class
}
}
\details{
Soil textural class is according to USDA textural triangle such as SiLo, Si, SaLo. The code is represented by first two letters of the class with the first letter in upper case, e.g., Si, Lo, Cl. Class codes with combination of textures have the first two letters included in the combination, e.g., SiLo, SaClLo, etc.
}
\value{
permeability class code. 1-very slow, 2-slow, 3-moderately slow, 4-moderate, 5-moderately rapid, 6-rapid, and 7-very rapid
}
\references{
O'Geen, A. T. (2013) Soil Water Dynamics. Nature Education Knowledge 4(5):9

Soil Survey Staff. Soil Taxonomy A Basic System of Soil Classification for Making and Interpreting Soil Surveys. Agricultural Handbook No. 436. U.S. Government Printing Office Washington, DC, 1999.
}
\author{
Christian Thine Omuto
}
\seealso{
\code{\link{drainageSuit}}, \code{\link{erodFUN}}
}
\examples{
library(sp)
permeabilityClass("SaLo")
\donttest{
texture=suitabinput["texture1"]
texture$permeability=ifelse(texture$texture1=="Lo",
permeabilityClass("Lo"),ifelse(texture$texture1=="SaLo",
permeabilityClass("SaLo"),permeabilityClass("SiLo")))
str(texture$permeability)
texture$Perm=classCode(texture$permeability,"permeability")
spplot(texture["Perm"])}
}

\name{RotCtempcorrection}
\alias{RotCtempcorrection}
\title{
Estimating temperature effects in organic matter decomposition rates in the soil
}
\description{
This function estimates the scalar constant for temperature effects in RothC carbon turnover modelling in the soil
}
\usage{
RotCtempcorrection(temperature)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{temperature}{
mean air temperature in degrees Celsius
}
}
\details{
mean air temperature canbe monthly or annual mean temperature
}
\value{
A scalar constant for temperature effects on carbon decomposition rates
}
\references{
Burke, I., Kaye, J., Bird, S., Hall, S., McCulley, R., Sommerville, G. 2003. Evaluating and testing models of terrestrial biogeochemistry: the role of temperature in controlling decomposition, Models in ecosystem science, Princeton University Press, Princeton, New Jersey, USA, 225–253, 2003

Adair, E., Parton, W., Del Grosso, S., Silver, W., Harmon, M.,Hall, S., Burke, I., and Hart, S. 2008. Simple three-pool model accurately describes patterns of long-term litter decomposition in diverse climates, Global Change Biology, 14: 2636–2660

Coleman, K. and Jenkinson, D. 2014. ROTHC-26.3 A model for the turnover of carbon in soils: Model description and users guide (Windows version). Rothamsted Research Harpenden Herts AL5 2JQ

}
\author{
Christian Thine Omuto
}
\note{
This function can be used with monthly or annual input data to produce time-dependent scalars
The function works with temperatures greater than -18.2 degrees Celsius
}

\seealso{
\code{\link{carbonTurnover}}, \code{\link{RotCmoistcorrection}}, \code{\link{NPPmodel}}
}
\examples{
airTemp=22.1
RotCtempcorrection(airTemp)
}

\name{depthharm}
\alias{depthharm}
\title{
Harmonizing soil property between uniform depth intervals in observation pits
}
\description{
A function to harmonize soil property between uniform depth intervals in a set of observation pits
}
\usage{
depthharm(soildata, var.name, lam, d)
}
\arguments{
  \item{soildata}{
soil data containing soil property to be harmonized and observed depth intervals
}
  \item{var.name}{
name of target variable or soil property to be harmonized
}
  \item{lam}{
a factor to improve prediction of target soil property between sampled depths
}
  \item{d}{
target uniform depth intervals for harmonizing the target soil propert
}
}
\details{
Input soil data must be a dataframe or class of ProfileCollection. The smoothing factor improves prediction of the target soil propert. Its default value is 0.1. Desired depth intervals are seperated by comma and should be choosen between minimum and maximum depths in the soil data.
}
\value{
The output is a list of two dataframes:
harmonized.d is a dataframe of harmonized soil property at target depth intervals.
obs_n_pred is ugmented dataframe of observed and harmonized soil properties
}
\references{
Bishop, T.F.A., McBratney, A.B., Laslett, G.M., 1999. Modelling soil attribute depth functions with equal-area quadratic smoothing splines. Geoderma 91, 27–45. https://doi.org/10.1016/S0016-7061(99)00003-8

Malone, B.P., McBratney, A.B., Minasny, B., Laslett, G.M., 2009. Mapping continuous depth functions of soil carbon storage and available water capacity. Geoderma 154, 138–152. https://doi.org/10.1016/j.geoderma.2009.10.007

Ponce-Hernandez, R., Marriott, F.H.C., Beckett, P.H.T., 1986. An improved method for reconstructing a soil profile from analyses of a small number of samples. Journal of Soil Science 37, 455–467. https://doi.org/10.1111/j.1365-2389.1986.tb00377.x
}
\examples{
library(aqp)
library(plyr)
library(sp)
x=c(rep(2.12,4),rep(2.05,4))
y=c(rep(9.34,4),rep(8.17,4))
pit=c(rep(1,4),rep(2,4))
depthcode=c(1,2,3,4,1,2,3,4)
upper=c(0,18,25,35,0,12,33,50)
lower=c(10,25,35,67,12,33,50,100)
pH=c(6.7,5.5,5.1,6.7,6.4,5.8,5.3,5.0)
df=data.frame(pit,x,y,upper,lower,depthcode,pH)
lat=df$x;lon=df$y;id=df$pit;top=df$upper;
bottom=df$lower;horizon=df$depthcode;Varn=df$pH

soildata <- join(data.frame(id, top, bottom, Varn, horizon),
              data.frame(id, lat, lon), type='inner')
depths(soildata) <- id ~ top + bottom
site(soildata) <- ~ lat + lon
initSpatial(soildata, crs = "EPSG:4326") <- ~ lat + lon
depth.s = depthharm(soildata, var.name= "Varn",
lam=0.01,d = t(c(0,10,40,80,100,150)))
plot(soildata, color= "Varn", name="horizon")
}

\name{ECconversion2}
\alias{ECconversion2}
\title{
Harmonizing electrical conductivity of a soil solution to that of the saturated paste extract for all textural classes
}
\description{
This function converts electrical conductivity measurements of soil solution to that of soil paste extract. The ratio of soil:water mix for the solution and conversion method must be indicated
}
\usage{
ECconversion2(ec, method, extract)
}
\arguments{
  \item{ec}{
measured electrical conductivity of the soil solution in dS/m
}

 \item{method}{
method for converting electrical conductivity of the soil:water mix to that of the soil paste extract. The methods included are USDA, landon, kargas, ozkan, hogg, park, visconti, korsandi, shahid, klaustermeier, and he. The default is USDA
}
  \item{extract}{
ratio of soil:water in extract solution for measuring electrical conductivity was measured. Example is 1:1, 1:2, etc. Default is 1:1
}
}
\details{
This function assumes no influence of texture, clay content, etc on the conversion of electrical conductivities
}
\value{
electrical conductivity equivalent for saturated soil extract in dS/m
}
\references{
Sonmez S, Buyuktas D, Asri FO. 2008. Assessment of different soil to water ratios (1:1, 1:2.5, 1:5) in soil salinity studies. Geoderma, 144: 361-369

Kargas G, Chatzigiakoumis I, Kollias A, Spiliotis D, Massas I, Kerkides P. 2018. Soil salinity assessment using saturated paste and mass soil:water 1:1 and 1:5 ratios extracts. Water, 10:1589,  doi:10.3390/w10111589
}
\author{
Christian Thine Omuto
}
\note{
Models that work with soil solutions in 1:1 soil-water mix are: USDA, landon, kargas, ozkan,hogg, and zhang. Models for 1:2 solutions are: USDA and hogg. Models for 1:2.5 are: ozkan and shahid. landon model also works for 1:3 soil solution. Models for 1:5 are: USDA, landon, kargas, ozkan, chi, park, visconti, korsandi, klaustermeier, and he. The function only works for soil solution mix ratio handled by the respective model.
}
\seealso{
\code{\link{ECconversion1}}, \code{\link{ECconversion3}}, \code{\link{ECconversion4}}
}
\examples{
library(sp)
ECconversion2(0.75, "USDA","1:1")
newmap = suitabinput["ec"]
newmap$salinity=ECconversion2(newmap$ec,"hogg","1:1")
str(newmap$salinity)
spplot(newmap["salinity"])
}

\name{regmodelSuit}
\alias{regmodelSuit}
\title{
Guiding selection of a predition model for modelling soil properties
}
\description{
This function evaluates suitability of most predition models in mapping soil properties using a set of predictors
}
\usage{
regmodelSuit(df, ...)
}
\arguments{
  \item{df}{
a dataframe of target soil property and its predictors
}
  \item{...}{
name of the target soil variable to predict and names of its predictors
}
}
\details{
The name of the target soil variable to predict and names of its predictors are seperated by commas and are similar to column names of the corresponding variables in the supplied dataframe. The name of the target soil variable starts the list and followed by the names of its predictors. For example, if the dataframe has EC, landcover,DEM, Slope,  NDVI, etc., then the input could be (soil,EC,landcover,Slope,DEM).
}
\value{
A table of model statistics such as root mean square error (RMSE), mean absolute error (MAE), r-squared (R2) and Nash-Sutcliffe coefficient of efficiency (NSE) for the popular models in digital soil mapping
}
\references{
Nash, J. E.; Sutcliffe, J. V. 1970. River flow forecasting through conceptual models part I — A discussion of principles. Journal of Hydrology. 10 (3): 282–290
}
\author{
Christian Thine Omuto
}
\note{
The function carries 5-fold cross-validation. Sometimes it may give a warning of missing resample performance with some models. It's important to ensure no NA in the data used for modelling
}
\seealso{
\code{\link{pedoTransfer}}, \code{\link{predUncertain}}, \code{\link{ECconversion3}}
}
\examples{
library(caret)
library(sp)
data(soil)
soil1=soil[,c("EC")]
soil1=subset(soil1,!is.na(soil1$EC))
overlay.ov=over(soil1, suitabinput)
soil1$dem=overlay.ov$dem
soil1$rain=overlay.ov$rain
soil1$ph=overlay.ov$ph
soil2=soil1@data[,c("EC","dem","rain","ph")]
\donttest{
regmodelSuit(soil2,EC,dem,rain,ph)
}
}

\name{pedoTransfer}
\alias{pedoTransfer}
\title{
A pedotransfer function to predict electrical conductivity or any other soil property using other soil properties
}
\description{
This generic pedo-transfer function is used to approximate EC values from other existing and easy-to-measure soil data
}
\usage{
pedoTransfer(method="linear", df, ...)
}
\arguments{
  \item{method}{
modelling method to link EC and other soil predictors (properties). Default method is linear
}
  \item{df}{
dataframe containing measured EC and predictors of soil properies
}
  \item{...}{
names of measured EC and list of predictors (soil properties) seperated by comma. The names should match the variables in the accompanying dataframe
}
 }
\details{
This generic model can be used even with other soil properties. For example, it can be used to predict porosity from bulk density, carbon, and texture components as long as they are in the database and have known/suspected relationship
}
\value{
model for predicting EC given similar input data
}
\references{
van Looy k,  Bouma  J, Herbst M,  Koestel J, Minasny B,  Mishra U, Montzka C,  Nemes A,  Pachepsky AY,  Padarian J,  Schaap MG,  Tóth B,  Verhoef A, Jan Vanderborght,  van der Ploeg MJ,  Weihermüller L,   Zacharias S,  Zhang Y,  Vereecken H. 2017. Pedotransfer functions in Earth System Science: Challenges and Perspectives. Reviews of Geophysics 55(4): 1199-1256.

Sudduth KA, Kitchen RN, Wiebold WJ, Batchelor W. 2005. Relating apparent electrical conductivity to soil properties across the North-Central USA. Computers and Electronics in Agriculture, 46(1-3):263-283
}
\author{
Christian Thine Omuto
}
\note{
This function can also be used to predict EC from apparent electrical conductivity of bulk soil, texture, and other important soil properties
}
\seealso{
\code{\link{ECconversion4}}, \code{\link{conversion}}
}
\examples{
library(caret)
clay=as.data.frame(runif(120, 1,100))
silt=as.data.frame (runif(120,20,70))
sand=as.data.frame(runif(120,10.1,50.5))
pH=as.data.frame(runif(120,1,14))
EC=as.data.frame(runif(120,0.5,20.5))
OC=as.data.frame(runif(120,0.1,1.25))
soil4=cbind(EC,clay,silt,sand,OC,pH)
names(soil4)=c("EC","clay","silt","sand","OC","pH")
bound <- floor((nrow(soil4)/4)*3)
df.train <- soil4[sample(nrow(soil4)), ][1:bound, ]
df.test <- soil4[sample(nrow(soil4)), ][(bound+1):nrow(soil4[sample(nrow(soil4)), ]), ]
EC1.lm=pedoTransfer("randomforest",df.train,EC, clay,sand,silt,OC,pH)
df.test$EC1=predict(EC1.lm,newdata = df.test)
cor(df.test$EC,df.test$EC1)^2
plot(df.test$EC~df.test$EC1)
abline(1,1)
}

\name{createTexturedata}
\alias{createTexturedata}
\title{
Creating spatial dataframe of normalized soil texture proportions
}
\description{
The function creates spatial dataframe of normalized soil texture proportions. They are normalized to 100 percent
}
\usage{
createTexturedata(clay,silt,sand)
}
\arguments{
  \item{clay}{
clay proportion of soil texture in percent
}
  \item{silt}{
silt proportion of soil texture in percent
}
  \item{sand}{
sand proportion of soil texture in percent
}
}
\details{
the input data of soil texture proportions are imported into R as spatial raster or dataframe. They need to have uniform coordinate reference system (CRS) and same pixel size (resolution) if in raster map format. The sum of the proportions should be close to 100 per cent for each row
}
\value{
The output is a spatial pixel dataframe of normalized soil texture proportions (for each pixel)
}
\author{
Christian Thine Omuto
}
\note{
It's important to ensure the input data does not have negative values nor add up to far below or above 100 per cent. It's also important to adhere to the order of the input data: clay, silt, sand
}
\seealso{
\code{\link{createTexturedata}}, \code{\link{appendTextureclass}}
}
\examples{
#data(textureinput)
newmap=textureinput
\donttest{
texturedata=createTexturedata(newmap$clay, newmap$silt, newmap$sand)
cor(texturedata$CLAY,texturedata$CLAY_n)^2
}
}

\name{sloplenFUN}
\alias{sloplenFUN}
\title{
Estimating slope-length factor for soil erosion
}
\description{
Th function estimates slope length factor for erosion risk assessment. It has options for choosing different algorithms
}
\usage{
sloplenFUN(ls,slope,method)
}
\arguments{
  \item{ls}{
length of slope in metres
}
  \item{slope}{
slope of land in degrees
}
  \item{method}{
method for deriving slope-length factor. The methods included are: WSmith, Renard, Remortel, Zhang, Nearing, Smith, Foster, David, Morgan, and Moore.
}
}
\details{
Slope (degrees) and length of slope (metres) are relief parameters in erosion risk assessment.
}
\value{
a dimensionless quantity of slope-length factor of erosion risk
}
\references{
Benavidez R, Bethana J, Maxwell D, Norton K. 2018. A review of the (Revised) Universal Soil Loss Equation ((R)USLE): with a view to increasing its global applicability and improving soil loss estimates. Hydrol. Earth Syst. Sci., 22, 6059–6086

Omuto CT and Vargas R. 2009. Combining pedometrics, remote sensing and field observations for assessing soil loss in challenging drylands: a case study of northwestern Somalia. Land Degrad. Develop. 20: 101–115
}
\author{
Christian Thine Omuto
}
\note{
The slope must be in degrees. The warning given is a reminder to that the slope is given in degrees
}
\seealso{
\code{\link{erosivFUN}}, \code{\link{erodFUN}}, \code{\link{slopeSuit}}
}
\examples{
library(sp)
sloplenFUN(60,14.88,"Renard")
newmap=suitabinput["slope"]
newmap$LSrenard=sloplenFUN(60,(newmap$slope),"Renard")
newmap$LSwsmith=sloplenFUN(60,(newmap$slope),"WSmith")
spplot(newmap["LSrenard"])
spplot(newmap["LSwsmith"])
}

\name{negData}
\alias{negData}
\title{
Correcting negative entries in classes for intenisty of salt-affected soils
}
\description{
Function to handle negative entries when assessing salt-affected soils
}
\usage{
negData(vg,x)
}
\arguments{
  \item{vg}{
tag for soil property. Default is "ec"
}
  \item{x}{
numeric value of soil property to check
}
}
\details{
Three tags for soil properties are allowed: "ec", "ph", "esp"
}
\value{
numeric value of soil property to correct. It return NA where negative "ec" or "esp" is involved or where ph<1 or ph>14
}
\author{
Christian Thine Omuto
}
\examples{
negData("ph",14)
}

\name{ECconversion4}
\alias{ECconversion4}
\title{
A function for harmonizing salt measurements into equivalent electrical conductivity in dS/m
}
\description{
This function allows approximate conversion of other soil salt measurements into equivalent electrical conductivity (EC) in dS/m. These measurements include total soluble salts (TSS), total dissolved solids (TDS) and EC in mmho/cm
}
\usage{
ECconversion4(x,target)
}
\arguments{
  \item{x}{
is a numeric value of salt to convert to equivalent EC in dS/m
}
  \item{target}{
the target salt measurement to be converted into equivalent electrical conductivity (EC) in dS/m. It can be TDS (mg/l or ppm), TSS (mmol/l), EC in (mmho/cm)
}
}
\details{
The target is specified as TDS or TSS or mmho.
}
\value{
The output is a numeric value of equivalent electrical conductivity (EC) in dS/m
}
\author{
Christian Thine Omuto
}
\note{
TDS should be given in mg/l or ppm. TSS should be given in mmol/l. The function does not convert salt values between different measurement methods
}
\seealso{
\code{\link{ECconversion1}}, \code{\link{ECconversion2}}, \code{\link{pedoTransfer}}
}
\examples{
ECconversion4(200,"TSS")
ECconversion4(20,"TDS")
ECconversion4(2,"mmho")
}

\name{reclassifyMap}
\alias{reclassifyMap}
\title{
Re-classifying raster maps based on input look-up table
}
\description{
This function re-classifies an input raster maps based on input look-up table that specifies transition from map classes (or range of classes) to a new class (or range of classes)
}
\usage{
reclassifyMap(fgrid,df)
}
\arguments{
  \item{fgrid}{
Input raster map to be reclassified
}
  \item{df}{
Input look-up table for re-classification
}
}
\details{
The look-up table should have at least two columns in which the first column contains the classes in the input map and the second column contains the new classes to be assigned
}
\value{
The output is a reclassified raster map
}
\references{
Robert Hijman. Raster Package in R. https://www.rdocumentation.org/packages/raster
}
\author{
Christian Thine Omuto
}
\seealso{
\code{\link{classCode}}, \code{\link{classLUT}}, \code{\link{classnames}}
}
\examples{
library(sp)
library(raster)
LUT=data.frame(map=c(1,2,3,4,5,6),new=c(100,20,30,40,60,80))
data("suitabinput")
newmap=raster(suitabinput["depthcodes"])
newmap$depth=reclassifyMap((newmap$depthcodes),LUT)
spplot(newmap$depth)
}

\name{LGPSuit}
\alias{LGPSuit}
\title{
Assessing Length of Growing Period (LGP) suitability requirements for certain crops and trees
}
\description{
This function determines the suitability classes for length of growing period (LGP) requirements for selected agricultural crops and forest trees
}
\usage{
LGPSuit(value, crop)
}
\arguments{
  \item{value}{
Input length of growing period (LGP) in days.
}
  \item{crop}{
The crop of interest for which length of growing period (LGP) suitability class is sought
}
}
\details{
The input value can be map or an integer value of LGP in days
}
\value{
The output is LGP suitability class for the crop. The output is an integer for suitability class: 1- highly suitable; 2 - moderately suitable; 3 - marginally suitable; 4 - currently not suitable; 5 - not suitable
}
\references{
Sys, C., Van Ranst, E., Debaveye, J. and Beerneaert, F.1993. Land evaluation: Part III: Crop requirements.
Development Cooperation, Belgium.

Naidu, L.G.K., Ramamurthy, V., Challa O., Hegde, R. and Krishnan, P. 2006. Manual, Soil-site Suitability Criteria for Major Crops, National Bureau of Soil Survey and Land Use Planning, ICAR, Nagpur, India

FAO Crop Suitability Requirements: http://ecocrop.fao.org/ecocrop/srv/en/home
}
\author{
Christian Thine Omuto
}
\note{
If the input value is raster map, then the output will also be a raster map of LGP suitability for the crop of interest
}
\seealso{
\code{\link{suitability}}, \code{\link{PHSuit}}, \code{\link{fertilitySuit}}
}
\examples{
library(sp)
LGPSuit(138,"cotton")
newmap = data.frame(LGP = c(1:6,158,160,211),
                    lon = c(1,1,1,2,2,2,3,3,3),
                    lat = c(rep(c(0, 1.5, 3),3)))
coordinates(newmap) = ~lon+lat
gridded(newmap) = TRUE
newmap = as(newmap, "SpatialGridDataFrame")
newmap$LGPmillet=LGPSuit(newmap$LGP,"millet")
spplot(newmap["LGPmillet"], main="LGP suitability map for finger millet")
}

\name{ME_PHharmserve}
\alias{ME_PHharmserve}
\title{
Harmonization models for soil pH
}
\description{
Mixed effects models for harmonizing soil pH
}
\details{
Suit of mixed-effects models
}
\note{
Internet connectivity is needed for the function to work.
}

\name{saltSeverity}
\alias{saltSeverity}
\title{
A function to classify salt intensity in soil
}
\description{
This function classifies salt intensity in soil based on EC, pH and ESP levels
}
\usage{
saltSeverity(ec,ph,esp,criterion="FAO")
}
\arguments{
  \item{ec}{
electrical conductivity in dS/m of saturated soil paste extract or its equivalent
}
  \item{ph}{
soil reaction (pH)
}
  \item{esp}{
Exchangeable sodium percent
}
  \item{criterion}{
classification method for severity/degree of salt problems. FAO, USDA, Amrhein, and PSALT criteria are included. Default method is FAO.
}
}
\details{
This function requires input EC, pH and ESP values to process the classification. They can be maps or numerical entries. PSALT criterion uses percent salt content instead of EC.
}
\value{
Integer classes of ranging between 1-17. The names of integer codes are obtained using classCode function
}
\references{
Abrol, IP, Yadav JSP, Massoud FI. 1988. Salt-affected soils and their management. FAO Soils Bulletin 39. FAO, Rome

Amrhein C. 1996. Australian sodic soils: Distribution, properties, and management. Soil Science 161. pp412.

FAO. 2006. Guidelines for soil description. FAO, Rome

Richards LA. 1954. Diagnosis and improvements of saline and alkali soils. Agriculture Handbook No. 60. USDA, Washington
}
\author{
Christian Thine Omuto
}
\note{
The function strictly requires input EC, pH, and ESP. Percent salt content can be used in place of EC if the criterion is PSALT
}
\seealso{
\code{\link{saltClass}}, \code{\link{saltRating}}, \code{\link{classCode}}
}
\examples{
library(sp)
saltSeverity(4.5,7.8,11.6,"USDA")
ec=suitabinput["ec"]
ph=suitabinput["ph"]
soc=nutrindicator["soc"]
clay=textureinput["clay"]
texture=suitabinput["texture"]
newmap=ec
newmap$ph=ph$ph-1
newmap$ECe=ECconversion1(ec$ec*0.25,texture$texture,"FAO","1:5",soc$soc,clay$clay)
newmap$salt=saltSeverity(newmap$ECe,newmap$ph,6.84,"FAO")
newmap$salineclass=classCode(newmap$salt,"saltseverity")
spplot(newmap["salineclass"], main="Salinity Code")
}

\name{ECconversion3}
\alias{ECconversion3}
\title{
Developing own harmonization model
}
\description{
This function enables development of own function for harmonizing soil indicators to standard values
}
\usage{
ECconversion3(x, A, B, method)
}
\arguments{
  \item{x}{
input predictor value
}
  \item{A}{
location parameter representing the value of target variable when the predictors are minimal (or the y-intercept)
}
  \item{B}{
Rate parameter representing the rate of change of the target variable with the predictor (or the slope)
}
 \item{method}{
model relationship between target and predictor variables
}
}
\details{
model for the relationship between target and predictor variables can be "linear", "power", "exponential", "log". Default is "linear"
}
\value{
model object containing predictive parameters of the conversion model
}
\references{
van Looy k,  Bouma  J, Herbst M,  Koestel J, Minasny B,  Mishra U, Montzka C,  Nemes A,  Pachepsky AY,  Padarian J,  Schaap MG,  Tóth B,  Verhoef A, Jan Vanderborght,  van der Ploeg MJ,  Weihermüller L,   Zacharias S,  Zhang Y,  Vereecken H. 2017. Pedotransfer functions in Earth System Science: Challenges and Perspectives. Reviews of Geophysics 55(4): 1199-1256.

Sudduth KA, Kitchen RN, Wiebold WJ, Batchelor W. 2005. Relating apparent electrical conductivity to soil properties across the North-Central USA. Computers and Electronics in Agriculture, 46(1-3):263-283
}
\author{
Christian Thine Omuto
}
\seealso{
\code{\link{ECconversion1}}, \code{\link{ECconversion2}}, \code{\link{ECconversion4}}
}
\examples{
x=as.vector(c(0.800,2.580,0.980,0.532,1.870, 18.500,0.430,0.302,0.345,2.700))
y=as.vector(c(17.88,  6.43,  3.83,  7.18,  6.64, 14.83,  4.19,  7.31,  3.21, 18.41))
xy=as.data.frame(cbind(x,y))
names(xy)=c("ECa", "EC")
EC3.ml=nls(EC~ECconversion3(ECa,A,B), start=c(A=0.1, B=0.8), data=xy)
cor.test(fitted(EC3.ml),xy$EC)
plot(fitted(EC3.ml)~xy$EC)
abline(0,1)
}

\name{erosionSuit}
\alias{erosionSuit}
\title{
Assessing erosion risk for certain crops and trees
}
\description{
This function determines risk classes for erosion tolerance for selected agricultural crops and forest trees
}
\usage{
erosionSuit(value, crop)
}
\arguments{
  \item{value}{
Input erosion risk in ton/ha.
}
 \item{crop}{
The crop of interest for which erosion risk class is sought.
}
}
\details{
The input value can be map or just a numerical entry of erosion risk in g/cm3
}
\value{
The output is erosion risk class for the crop. The output is integer value for suitability class: 1- high; 2 - moderate; 3 - low; 4 - very low
}
\references{
Sys, C., Van Ranst, E., Debaveye, J. and Beerneaert, F.1993. Land evaluation: Part III: Crop requirements.
Development Cooperation, Belgium.

Naidu, L.G.K., Ramamurthy, V., Challa O., Hegde, R. and Krishnan, P. 2006. Manual, Soil-site Suitability Criteria for Major Crops, National Bureau of Soil Survey and Land Use Planning, ICAR, Nagpur, India

FAO Crop Suitability Requirements: http://ecocrop.fao.org/ecocrop/srv/en/home
}
\author{
Christian Thine Omuto
}
\note{
Should the input value be raster map, then the output will also be a raster map of erosion risk class for the crop of interest
}
\seealso{
\code{\link{suitability}}, \code{\link{PHSuit}}, \code{\link{fertilitySuit}}
}
\examples{
erosionSuit(1.78,"cotton")
}

\name{suitabinput}
\alias{suitabinput}
\docType{data}
\title{
Sample grid stack map of nutrient indicators for crop fertility requirements
}
\description{
A grid stack map of nine variables for assessing crop suitabilities
}
\usage{data("suitabinput")}
\format{
  The format is:
Formal class 'SpatialGridDataFrame' [package "sp"] with 4 slots
  ..@ data       :'data.frame':	16900 obs. of  12 variables:
  .. ..$ cac03     : num [1:16900] 21.8 20.6 21.2 22 22.3 ...
  .. ..$ ec        : num [1:16900] 2.5 2.38 2.15 2.36 2.24 ...
  .. ..$ depthcodes: num [1:16900] 3 1 3 3 3 3 3 3 1 1 ...
  .. ..$ rain      : num [1:16900] 282 279 260 279 276 ...
  .. ..$ texture   : int [1:16900] 5 5 5 5 5 5 5 5 11 11 ...
  .. ..$ dem       : num [1:16900] 489 489 489 485 487 ...
  .. ..$ drainage  : int [1:16900] 2 5 2 2 2 5 7 5 5 5 ...
  .. ..$ stones    : num [1:16900] 6 9 6 6 6 6 6 9 9 9 ...
  .. ..$ structure : int [1:16900] 3 8 7 5 5 5 7 5 9 9 ...
  .. ..$ ph        : num [1:16900] 8.76 8.83 8.73 8.71 8.69 ...
  .. ..$ slope     : num [1:16900] 0.969 0.969 0.969 0.969 0.969 ...
  .. ..$ texture1  : Factor w/ 3 levels "Lo","SaLo","SiLo": 2 2  ...
 ..@ grid       :Formal class 'GridTopology' [package "sp"] with 3 slots
  .. .. ..@ cellcentre.offset: Named num [1:2] 383216 3341506
  .. .. .. ..- attr(*, "names")= chr [1:2] "x" "y"
  .. .. ..@ cellsize         : num [1:2] 357 357
  .. .. ..@ cells.dim        : int [1:2] 130 130
  ..@ bbox       : num [1:2, 1:2] 383038 3341327 429478 3387767
  .. ..- attr(*, "dimnames")=List of 2
  .. .. ..$ : chr [1:2] "x" "y"
  .. .. ..$ : chr [1:2] "min" "max"
  ..@ proj4string:Formal class 'CRS' [package "sp"] with 1 slot
  .. .. ..@ projargs: chr "+proj=utm +zone=41 +datum=WGS84 +units=m +no_defs"
}
\examples{
data(suitabinput)
summary(suitabinput$depthcodes)
hist(suitabinput$dem)
}
\keyword{datasets}

\name{harmonization}
\alias{harmonization}
\title{
Harmonization model for salt-affected soils
}
\description{
A generic model for harmonizing soil data for salt-affected soils.
}
\usage{
harmonization(x,A,B)
}
\arguments{
  \item{x}{
- is input data to harmonize such as electrical conductivity (ec) or ph.
}
  \item{A}{
 - is real number rate parameter or slope of the harmonization model
 }
  \item{B}{
- is real number constant (intercept) of the harmonization model
}
}
\details{
This is a generic linear model for harmonizing input soil data for assessing salt-affected soils.
}
\value{
a numeric output of harmonized ec or ph
}
\author{
Christian Thine Omto
}
\seealso{
\code{\link{ME_ECharmserve}}, \code{\link{ME_PHharmserve}}
}
\examples{
A = 1.08
B = 0.303
ec=2.45
harmonization(2.45,1.08,0.303)
}

\name{calcSuit}
\alias{calcSuit}
\title{
Calculating suitability classes
}
\description{
Function for calculating suitability classes given the target information.
The function use given limits to calculate the suitability class
}
\usage{
calcSuit(x, lm1,lm2,lm3,lm4)
}
\arguments{
\item{x}{
  Input value of the indicator to be classified
}
  \item{lm1}{
  Upper limit of the highest class
}
  \item{lm2}{
  Upper limit of the second highest class
}
  \item{lm3}{
  Upper limit of the second last class
}
  \item{lm4}{
  Maximum allowable limit for target variable
  }
}
\details{
The function calculates the boundary conditions for realistic values of target soil properties
}
\value{
An interger representing suitability class. 1-High, 2-Moderate, 3-Low, 4-Not suitable
}
\author{
Christian Thine Omuto}
\note{
Negative values are not permitted and will return NA. Similarly, large values out of range are also not permitted
}

\seealso{
\code{\link{classCode}}
}
\examples{
calcSuit(22,8,12,24,100)
}

\name{imageIndices}
\alias{imageIndices}
\title{
Developing remote sensing indices for soil assessment
}
\description{
The function determines commonly used remote sensing indices with relationship with soil surface or vegetation cover characteristics.
}
\usage{
imageIndices(blue, green,red,nir,swir1,swir2,index)
}
\arguments{
  \item{blue}{
blue image band with wavelength range: 0.452-0.512 µm
}
  \item{green}{
green image band with wavelength range: 0.533-0.59 µm
}
  \item{red}{
red image band with wavelength range: 0.636-0.673 µm
}
  \item{nir}{
NIR image band with wavelength range: 0.851-0.879 µm
}
  \item{swir1}{
SWIR image band with wavelength range: 1.566-1.651 µm
}
  \item{swir2}{
SWIR image band with wavelength range: 2.107-2.294 µm
}
\item{index}{
index from combination of image bands such as NDVI, SAVI, SI, etc. The default is NDVI.
}
}
\details{
The indices are based on multispectral bands: blue, green, red, NIR(near infrared), SWIR1 (short-wave infrared1) and SWIR2(short-wave infrared2)
}
\value{
dimensionless remote sensing index
}
\references{
Gorji T, Yildirim A, Sertel E, Tanik A. 2019. Remote sensing approaches and mapping methods for monitoring soil salinity under different climate regimes. International Journal of Environment and Geoinformatics 6(1): 33-49 (2019)
}
\author{
Christian Thine Omuto
}
\seealso{
\code{\link{featureRep}}
}
\examples{
imageIndices(0.15,0.05,0.18,0.25,0.36,0.45,"SAVI")
}
